// CharStatsView.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Doc.h"
#include "CharStatsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCharStatsView

IMPLEMENT_DYNCREATE(CCharStatsView, CSizingFormView)

CCharStatsView::CCharStatsView()
	: CSizingFormView(CCharStatsView::IDD)
{
	//{{AFX_DATA_INIT(CCharStatsView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_bValid = FALSE;
}

CCharStatsView::~CCharStatsView()
{
}

void CCharStatsView::DoDataExchange(CDataExchange* pDX)
{
	CSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCharStatsView)
	DDX_Control(pDX, IDC_CHARSPIN, m_wndCharSpin);
	DDX_Control(pDX, IDC_HPMPPROG, m_wndProgression);
	DDX_Control(pDX, IDC_EQUIPMENT, m_wndEquipment);
	DDX_Control(pDX, IDC_BATTLECMDS, m_wndCommands);
	DDX_Control(pDX, IDC_NAME, m_wndName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCharStatsView, CSizingFormView)
	//{{AFX_MSG_MAP(CCharStatsView)
	ON_EN_CHANGE(IDC_CHARNUM, OnChangeCharnum)
	ON_EN_CHANGE(IDC_INITIALHP, OnChangeInitialhp)
	ON_EN_CHANGE(IDC_INITIALMP, OnChangeInitialmp)
	ON_EN_CHANGE(IDC_VIGOR, OnChangeVigor)
	ON_EN_CHANGE(IDC_SPEED, OnChangeSpeed)
	ON_EN_CHANGE(IDC_MAGICPOWER, OnChangeMagicpower)
	ON_EN_CHANGE(IDC_BATTLEPOWER, OnChangeBattlepower)
	ON_EN_CHANGE(IDC_DEFENSE, OnChangeDefense)
	ON_EN_CHANGE(IDC_STAMINA, OnChangeStamina)
	ON_EN_CHANGE(IDC_MAGICDEFENSE, OnChangeMagicdefense)
	ON_EN_CHANGE(IDC_MAGICBLOCK, OnChangeMagicblock)
	ON_EN_CHANGE(IDC_EVADE, OnChangeEvade)
	ON_CONTROL(FF3LB_ITEMCHANGED, IDC_BATTLECMDS, OnChangeBattlecmds)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCharStatsView diagnostics

#ifdef _DEBUG
void CCharStatsView::AssertValid() const
{
	CSizingFormView::AssertValid();
}

void CCharStatsView::Dump(CDumpContext& dc) const
{
	CSizingFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCharStatsView message handlers

void CCharStatsView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();

	m_wndName.m_pDoc = pDoc;
	m_wndEquipment.m_pDoc = pDoc;
	m_wndCommands.m_pDoc = pDoc;

	m_wndCommands.m_dwListStyle = FF3LBS_FFEMPTY;

	m_wndCharSpin.SetRange(0, 63);

	m_wndProgression.DeleteAllItems();

	CRect rect;
	m_wndProgression.GetClientRect(&rect);
	int nWidth = (rect.Width() - GetSystemMetrics(SM_CXVSCROLL)) / 3;

	m_wndProgression.InsertColumn(0, _T("Level"), LVCFMT_LEFT, nWidth, 0);
	m_wndProgression.InsertColumn(1, _T("HP"), LVCFMT_LEFT, nWidth, 1);
	m_wndProgression.InsertColumn(2, _T("MP"), LVCFMT_LEFT, nWidth, 2);

	for(int i = 1; i < 100; i++)
	{
		CString s;  s.Format("%d", i);
		m_wndProgression.InsertItem(m_wndProgression.GetItemCount(), s, 0);
	}

	UpdateControls(0);
	m_bValid = TRUE;
}

Character* CCharStatsView::GetCharacter(int nIndex)
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	return &pDoc->characters[nIndex];
}

void CCharStatsView::UpdateControls(int nIndex)
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	Character* pChar = &pDoc->characters[nIndex];

	m_wndName.SetText(pChar->name, 6);

	SetDlgItemInt(IDC_INITIALHP, pChar->initialHP);
	SetDlgItemInt(IDC_INITIALMP, pChar->initialMP);
	SetDlgItemInt(IDC_VIGOR, pChar->vigor);
	SetDlgItemInt(IDC_SPEED, pChar->speed);
	SetDlgItemInt(IDC_MAGICPOWER, pChar->magicPower);
	SetDlgItemInt(IDC_BATTLEPOWER, pChar->battlePower);
	SetDlgItemInt(IDC_DEFENSE, pChar->defense);
	SetDlgItemInt(IDC_STAMINA, pChar->stamina);
	SetDlgItemInt(IDC_MAGICDEFENSE, pChar->magicDefense);
	SetDlgItemInt(IDC_EVADE, pChar->evade);
	SetDlgItemInt(IDC_MAGICBLOCK, pChar->magicBlock);

	m_itemArray.RemoveAll();
	for(int i = 0; i < 256; i++)
		m_itemArray.Add(pDoc->items[i].name);
	m_wndEquipment.m_pArray = &m_itemArray;

	m_cmdArray.RemoveAll();
	for(i = 0; i < 32; i++)
		m_cmdArray.Add(pDoc->battleCommands[i].name);
	m_wndCommands.m_pArray = &m_cmdArray;

	m_wndEquipment.ResetContent();
	m_wndEquipment.AddItem(pChar->weapon, 13);
	m_wndEquipment.AddItem(pChar->shield, 13);
	m_wndEquipment.AddItem(pChar->hat, 13);
	m_wndEquipment.AddItem(pChar->armor, 13);
	m_wndEquipment.AddItem(pChar->relic1, 13);
	m_wndEquipment.AddItem(pChar->relic2, 13);

	m_wndCommands.ResetContent();
	for(i = 0; i < 4; i++)
		m_wndCommands.AddItem(pChar->battleCmds[i], 7 | 0x10000);

	int nHP = pChar->initialHP;
	int nMP = pChar->initialMP;

	for(i = 1; i < 100; i++)
	{
		CString s;
		s.Format("%d", nHP);
		m_wndProgression.SetItemText(i - 1, 1, s);

		s.Format("%d", nMP);
		m_wndProgression.SetItemText(i - 1, 2, s);

		nHP += pDoc->hpProgression[i - 1];
		nMP += pDoc->mpProgression[i - 1];
	}
}

void CCharStatsView::UpdateProgression()
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	Character* pChar = &pDoc->characters[GetDlgItemInt(IDC_CHARNUM)];

	int nHP = pChar->initialHP;
	int nMP = pChar->initialMP;

	for(int i = 1; i < 100; i++)
	{
		CString s;
		s.Format("%d", nHP);
		m_wndProgression.SetItemText(i - 1, 1, s);

		s.Format("%d", nMP);
		m_wndProgression.SetItemText(i - 1, 2, s);

		nHP += pDoc->hpProgression[i - 1];
		nMP += pDoc->mpProgression[i - 1];
	}
}

void CCharStatsView::OnChangeCharnum() 
{
	if(!m_bValid) return;

	int nChar = GetDlgItemInt(IDC_CHARNUM);

	if(nChar < 0) nChar = 0;
	else if(nChar > 63) nChar = 63;

	m_bValid = FALSE;
	SetDlgItemInt(IDC_CHARNUM, nChar);
	m_bValid = TRUE;

	UpdateControls(nChar);
}

void CCharStatsView::OnChangeInitialhp() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->initialHP = GetDlgItemInt(IDC_INITIALHP);


	UpdateProgression();
}

void CCharStatsView::OnChangeInitialmp() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->initialMP = GetDlgItemInt(IDC_INITIALMP);

	UpdateProgression();
}

void CCharStatsView::OnChangeVigor() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->vigor = GetDlgItemInt(IDC_VIGOR);
}

void CCharStatsView::OnChangeSpeed() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->speed = GetDlgItemInt(IDC_SPEED);
}

void CCharStatsView::OnChangeMagicpower() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->magicPower = GetDlgItemInt(IDC_MAGICPOWER);
}

void CCharStatsView::OnChangeBattlepower() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->battlePower = GetDlgItemInt(IDC_BATTLEPOWER);
}

void CCharStatsView::OnChangeDefense() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->defense = GetDlgItemInt(IDC_DEFENSE);
}

void CCharStatsView::OnChangeStamina() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->stamina = GetDlgItemInt(IDC_STAMINA);
}

void CCharStatsView::OnChangeMagicdefense() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->magicDefense = GetDlgItemInt(IDC_MAGICDEFENSE);
}

void CCharStatsView::OnChangeMagicblock() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->magicBlock = GetDlgItemInt(IDC_MAGICBLOCK);
}

void CCharStatsView::OnChangeEvade() 
{
	if(!m_bValid) return;

	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
	pChar->evade = GetDlgItemInt(IDC_EVADE);
}

void CCharStatsView::OnChangeBattlecmds() 
{
	Character* pChar = GetCharacter(GetDlgItemInt(IDC_CHARNUM));
AfxMessageBox("sdf");
	for(int i = 0; i < 4; i++)
		pChar->battleCmds[i] = m_wndCommands.GetItem(i);
}
