
#ifndef __COMMANDBARCHILDREN_H__
#define __COMMANDBARCHILDREN_H__

class CCommandBarEdit;
class CCommandBarList;
class XCommandBarListBox;


class CCommandBarEdit : public CEdit
{
// Construction
public:
	CString m_strText;

protected:
	CResourceCollection* m_pResources;
	BOOL m_bAccept;

// Overrides
public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	BOOL Create(CWnd* pParentWnd, UINT nID, CResourceCollection* pRes);

// Generated message map functions
protected:
	afx_msg void OnKillFocus();
	afx_msg void OnSetFocus();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()

	friend class CCommandBar;
};


class XCommandBarListBox : public CListBox
{
public:
	int AddItem(LPCTSTR lpszText, int nImage = -1);

protected:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNcPaint();
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
	DECLARE_MESSAGE_MAP()

	friend class CCommandBar;
};


class CCommandBarList : public CMiniFrameWnd
{
protected:

public:
	void Invoke(CPoint pt, int nWidth, BOOL bOwnerDraw);
	void CancelWindow();
	void GetText(int nIndex, CString& rString);
	CCommandBar* m_pBar;

protected:
	int m_nModalResult;
	XCommandBarListBox m_wndList;
	BOOL m_bOwnerDraw;
	BOOL m_bValid;
	BOOL m_bCanceled;

	CSize m_sizeItem;

	CResourceCollection* m_pResources;
	CImageList m_images;

public:
	virtual BOOL Create(CWnd* pParentWnd, UINT nID, CResourceCollection* pRes);
	void AddItem(LPCTSTR lpszText, int nImage);

protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg LONG OnSetFont(UINT hFont, LONG fRedraw);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	
	afx_msg void OnMeasureItem(int nID, LPMEASUREITEMSTRUCT lpmis);
	afx_msg void OnDrawItem(int nID, LPDRAWITEMSTRUCT lpdis);
	DECLARE_MESSAGE_MAP()

	friend class CCommandBar;
};

#endif