// DialogueList.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "DialogueList.h"
#include "FF3Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogueList

CDialogueList::CDialogueList()
{
}

CDialogueList::~CDialogueList()
{
}


BEGIN_MESSAGE_MAP(CDialogueList, CListBox)
	//{{AFX_MSG_MAP(CDialogueList)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogueList message handlers

void CDialogueList::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 16;
}

extern BYTE g_rawDTE[256];
extern LPCTSTR g_rawNames[];
extern LPCTSTR g_rawCtrl[];

void CDialogueList::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		CString strID;
		CString strDlg;  GetText(nIndex, strDlg);
		DialogueItem* pDlg = (DialogueItem*)GetItemData(nIndex);
		BYTE* pText = pDlg->text;

		strID.Format("%04X:", nIndex);

		dc.SetTextColor(::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHTTEXT : COLOR_WINDOWTEXT));

		CRect textRect = rect;

		dc.FillSolidRect(textRect, ::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHT : COLOR_WINDOW));
		if(lpdis->itemState & ODS_FOCUS) dc.DrawFocusRect(&textRect);
		
		textRect.left += 4;

		CFont* oldFont = dc.SelectObject(GetParent()->GetFont());
		dc.SetBkMode(TRANSPARENT);
		dc.DrawText(strID, &textRect, DT_LEFT | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);

		textRect.left += 36;

		if(!pText) { dc.Detach(); return; }

		BYTE bChar = *(pText++);

		BYTE bString[1024];
		int nStringPos = 0;

		// First, get all the DTE and names out,
		// converting it into an entire string of single characters.
		while(bChar)
		{
			if(bChar >= 0x80 && bChar <= 0xFF)
			{
				BYTE bDTE1 = g_rawDTE[(bChar - 0x80) * 2];
				BYTE bDTE2 = g_rawDTE[(bChar - 0x80) * 2 + 1];

				bString[nStringPos++] = bDTE1;
				bString[nStringPos++] = bDTE2;
			}
			if(bChar >= 0x02 && bChar <= 0x0F)
			{
				for(int i = 0; i < 6; i++)
				{
					if(g_rawNames[bChar - 0x02][i] != 0x00)
						bString[nStringPos++] = g_rawNames[bChar - 0x02][i];
				}
			}
			if(bChar >= 0x19 && bChar <= 0x1B)
			{
				for(int i = 0; i < 6; i++)
				{
					if(g_rawCtrl[bChar - 0x19][i] != 0x00)
						bString[nStringPos++] = g_rawCtrl[bChar - 0x19][i];
				}
			}
			else if(bChar == 0x11 || bChar == 0x16)
			{
				while(bChar != 0x12)
					bChar = *(pText++);
			}
			else if(bChar == 0x14)
			{
				bChar = *(pText++);
			}
			else if(bChar == 0x01 || bChar == 0x13)
			{
				bString[nStringPos++] = 0x7F;
			}
			else
			{
				bString[nStringPos++] = bChar;
			}

			bChar = *(pText++);
		}

		bString[nStringPos++] = 0x00;
		
		nStringPos = 0;

		bChar = bString[nStringPos++];

		while(bChar != 0x00)
		{
			if(0x20 <= bChar && bChar <= 0x7F)
				textRect.left += OutputVariableFontChar(&dc, CPoint(textRect.left, textRect.top + 4),
					m_pDoc, bChar, FALSE);

			bChar = bString[nStringPos++];
		}

		dc.SelectObject(oldFont);
	}

	dc.Detach();
}