// DirectDrawListBox.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDirectDrawListBox window

#ifndef __DIRECTDRAWLISTBOX_H__
#define __DIRECTDRAWLISTBOX_H__

#include "FF3Data.h"

class CDirectDrawListBox : public CListBox
{
typedef struct 
{
	RGNDATAHEADER hdr;
	RECT rgndata[4];
} CLIPLIST, *LPCLIPLIST;

// Construction
public:
	CDirectDrawListBox();

// Attributes
public:

protected:
	CRect m_rectOffset;

	LPDIRECTDRAWSURFACE4 m_lpSurfaceBack;
	LPDIRECTDRAWCLIPPER m_lpSurfaceClipper;
	DDSURFACEDESC2 m_surfaceDesc;
	CLIPLIST m_clipList;
	DDPIXELFORMAT m_pixelFormat;

	void RestoreSurface();
	HRESULT Flip();

	void BeginDraw(LPRECT lpWorkRect, BOOL bErase = TRUE);
	void EndDraw();

// Operations
public:
protected:
	CDC* GetSurfaceDC();
	void ReleaseSurfaceDC(CDC* pDC);

	void BeginGDI();
	void EndGDI();

	void ClearSurface(COLORREF clr);
	void SetPixel(int x, int y, COLORREF clr);
	void HorizontalLine(int xStart, int yStart, int xEnd, COLORREF clr);
	void VerticalLine(int xStart, int yStart, int yEnd, COLORREF clr);
	void Line(int xStart, int yStart, int xEnd, int yEnd, CPen* pPen);
	void FillSolidRect(LPRECT lpRect, COLORREF clr);
	void FillSolidRect(int x, int y, int cx, int cy, COLORREF clr);
	void Rectangle(LPRECT lpRect, CPen* pPen, CBrush* pBrush = NULL);
	void Rectangle(int x, int y, int cx, int cy, CPen* pPen, CBrush* pBrush = NULL);
	void TextOut(int x, int y, LPCTSTR lpszString, int nCount, CFont* pFont, COLORREF clr);
	void TextOut(int x, int y, const CString& str, CFont* pFont, COLORREF clr);

	void ShadeRect(DDSURFACEDESC2* ddsd, int dx, int dy, int cx, int cy, WORD wShadeColor, float fPercent);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDirectDrawListBox)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDirectDrawListBox();

	// Generated message map functions
protected:
	//{{AFX_MSG(CDirectDrawListBox)
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
