// DockBarEx.h : header file
// Copyright 1998 - Kirk Stowell
// All Rights Reserved.
//
// Email: kstowel@sprynet.com
// URL:   www.geocities.com/SiliconValley/Haven/8230
//
// You are free to use, modify and distribute this source, as long as
// it is not sold for profit, and this HEADER stays intact. This source is
// supplied "AS-IS", and without WARRANTY OF ANY KIND. The user
// agrees to hold the author(s) blameless from any or all problems that
// may arise from the use or distribution of this code.
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(DOCKBAREX_H_INCLUDED)
#define DOCKBAREX_H_INCLUDED

#include <afxpriv.h>
#include "CommandBar.h"

// nDockBarMap
const DWORD nDockBarMap[4][2] =
{
	{ AFX_IDW_DOCKBAR_TOP,      CBRS_TOP    },
	{ AFX_IDW_DOCKBAR_BOTTOM,   CBRS_BOTTOM },
	{ AFX_IDW_DOCKBAR_LEFT,     CBRS_LEFT   },
	{ AFX_IDW_DOCKBAR_RIGHT,    CBRS_RIGHT  },
};

/////////////////////////////////////////////////////////////////////////////
// CDockBarEx class

class CDockBarEx : public CDockBar
{
	DECLARE_DYNAMIC(CDockBarEx)

// Construction
public:
	CDockBarEx();
	CDockBarEx(BOOL bFloating);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDockBarEx)
	public:
//	virtual CSize CalcFixedLayout(BOOL bStretch, BOOL bHorz);
	//}}AFX_VIRTUAL

	virtual void DockControlBar(CCommandBar* pBar, LPCRECT lpRect = NULL);
	virtual void ReDockControlBar(CCommandBar* pBar, LPCRECT lpRect = NULL);
	virtual void RemovePlaceHolder(CCommandBar* pBar);
	virtual CSize CalcFixedLayout(BOOL bStretch, BOOL bHorz);

// Implementation
public:
	virtual ~CDockBarEx();

// Generated message map functions
protected:
	//{{AFX_MSG(CDockBarEx)
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	friend class CMiniDockFrameWndEx;
};

class CMiniDockFrameWndEx : public CMiniFrameWnd
{
	DECLARE_DYNCREATE(CMiniDockFrameWndEx)

public:
// Construction
	CMiniDockFrameWndEx();
	virtual BOOL Create(CWnd* pParent, DWORD dwBarStyle);

// Operations
	virtual void RecalcLayout(BOOL bNotify = TRUE);

// Implementation
public:
	CDockBarEx m_wndDockBar;

	//{{AFX_MSG(CMiniDockFrameWndEx)
	afx_msg void OnClose();
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnNcLButtonDblClk(UINT nHitTest, CPoint point);
	//}}AFX_MSG
	afx_msg int OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message);
	afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
	DECLARE_MESSAGE_MAP()
};

#endif // !defined(DOCKBAREX_H_INCLUDED)

