// FF3ComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3ComboBox.h"
#include "FF3Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFF3ComboBox

CFF3ComboBox::CFF3ComboBox()
{
}

CFF3ComboBox::~CFF3ComboBox()
{
}


BEGIN_MESSAGE_MAP(CFF3ComboBox, CComboBox)
	//{{AFX_MSG_MAP(CFF3ComboBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFF3ComboBox message handlers

void CFF3ComboBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 11;
}

void CFF3ComboBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(lpdis->itemState & ODS_DISABLED)
	{
		dc.FillSolidRect(rect, GetSysColor(COLOR_BTNFACE));
		dc.Detach();
		return;
	}

	if(nIndex != (UINT)-1)
	{
		CString str;  GetLBText(nIndex, str);
		int nLength = atoi(str);
		BYTE* pText = (BYTE*)GetItemData(nIndex);

		CRect textRect = rect;
		textRect.DeflateRect(1, 1, 1, 1);
		CRect focusRect = textRect;

		dc.FillSolidRect(rect, RGB(112, 120, 192));
		if(lpdis->itemState & ODS_SELECTED) dc.InvertRect(rect);

		textRect.left += 2;

		for(int i = 0; i < nLength; i++)
		{
			OutputFixedFontChar(&dc, CPoint(textRect.left, textRect.top + 4), m_pDoc,
				pText[i]);

			textRect.left += 8;
		}
	}
	else
		dc.FillSolidRect(rect, RGB(112, 120, 192));

	dc.Detach();
}

void CFF3ComboBox::AddString(BYTE *pText, int nLength)
{
	CString s;  s.Format("%d", nLength);
	int nIndex = CComboBox::AddString(s);
	SetItemData(nIndex, (DWORD)pText);
}
