#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Data.h"
#include "FF3Doc.h"

CString FixedTextToCString(BYTE* text, int length, DWORD tag, DWORD value, ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	BOOL bTrim = 0;
	bTagFound = tagColl.Lookup(TTCS_TrimTrailingSpaces, dwValue);
	if(bTagFound)
		bTrim = (BOOL)dwValue;
	else
		bTrim = FALSE;

	CString str;

	for(int i = 0; i < length; i++)
	{
		if(text[i] >= 0x80 && text[i] <= 0x99) str += text[i] - 0x3F;
		else if(text[i] >= 0x9A && text[i] <= 0xB3) str += text[i] - 0x39;
		else if(text[i] >= 0xB4 && text[i] <= 0xBD) str += text[i] - 0x84;

		else if(text[i] == 0xBE) str += "!";
		else if(text[i] == 0xBF) str += "?";
		else if(text[i] == 0xC0) str += "/";
		else if(text[i] == 0xC1) str += ":";
		else if(text[i] == 0xC2) str += "\"";
		else if(text[i] == 0xC3) str += "'";
		else if(text[i] == 0xC4) str += "-";
		else if(text[i] == 0xC5) str += ".";
		else if(text[i] == 0xC6) str += ",";
		else if(text[i] == 0xC7) str += "_";
		else if(text[i] == 0xC8) str += ";";
		else if(text[i] == 0xC9) str += "#";
		else if(text[i] == 0xCA) str += "+";
		else if(text[i] == 0xCB) str += "(";
		else if(text[i] == 0xCC) str += ")";
		else if(text[i] == 0xCD) str += "%";
		else if(text[i] == 0xCE) str += "~";
		else if(text[i] == 0xCF) str += "*";
		else if(text[i] == 0xD2) str += "=";
		else if(text[i] == 0xD3) str += "@";
		else if(text[i] == 0xD7) str += "$";
		else if(text[i] == 0xFF) str += " ";

		else if(text[i] >= 0xD8) str += (text[i] - 0xD8) + 0xA0;
	}

	return str;
}

char VariableCharToASCII(BYTE fixed)
{
	char ch;

	if(fixed >= 0x20 && fixed <= 0x39) ch = fixed + 0x21;
	else if(fixed >= 0x3A && fixed <= 0x53) ch = fixed + 0x27;
	else if(fixed >= 0x54 && fixed <= 0x5D) ch = fixed - 0x24;

	else if(fixed == 0x5E) ch = '!';
	else if(fixed == 0x5F) ch = '?';
	else if(fixed == 0x60) ch = '/';
	else if(fixed == 0x61) ch = ':';
	else if(fixed == 0x62) ch = '"';
	else if(fixed == 0x63) ch = '\'';
	else if(fixed == 0x64) ch = '-';
	else if(fixed == 0x65) ch = '.';
	else if(fixed == 0x66) ch = ',';
	else if(fixed == 0x68) ch = ';';
	else if(fixed == 0x69) ch = '#';
	else if(fixed == 0x6A) ch = '+';
	else if(fixed == 0x6B) ch = '(';
	else if(fixed == 0x6C) ch = ')';
	else if(fixed == 0x6D) ch = '%';
	else if(fixed == 0x6E) ch = '~';
	else if(fixed == 0x6F) ch = '*';
	else if(fixed == 0x70) ch = '@';
	else if(fixed == 0x72) ch = '=';
	else if(fixed == 0x73) ch = '"';
	else ch = 0;

	return ch;
}

BYTE ASCIIToFixedChar(char ch)
{
	BYTE fixed = 0;

	if(ch >= 0x41 && ch <= 0x5A) fixed = ch + 0x3F;
	else if(ch >= 0x61 && ch <= 0x7A) fixed = ch + 0x39;
	else if(ch >= 0x30 && ch <= 0x39) fixed = ch + 0x84;

	else if(ch == '!') fixed = 0xBE;
	else if(ch == '?') fixed = 0xBF;
	else if(ch == '/') fixed = 0xC0;
	else if(ch == ':') fixed = 0xC1;
	else if(ch == '"') fixed = 0xC2;
	else if(ch == '\'') fixed = 0xC3;
	else if(ch == '-') fixed = 0xC4;
	else if(ch == '.') fixed = 0xC5;
	else if(ch == ',') fixed = 0xC6;
	else if(ch == '_') fixed = 0xC7;
	else if(ch == ';') fixed = 0xC8;
	else if(ch == '#') fixed = 0xC9;
	else if(ch == '+') fixed = 0xCA;
	else if(ch == '(') fixed = 0xCB;
	else if(ch == ')') fixed = 0xCC;
	else if(ch == '%') fixed = 0xCD;
	else if(ch == '~') fixed = 0xCE;
	else if(ch == '*') fixed = 0xCF;
	else if(ch == '=') fixed = 0xD2;
	else if(ch == '@') fixed = 0xD3;
	else if(ch == '$') fixed = 0xD7;
	else if(ch == ' ') fixed = 0xFE;

	else if(ch >= '\xA0') fixed = ch - 0xA0 + 0xD8;

	return fixed;
}

char FixedCharToASCII(BYTE fixed)
{
	char ch;

	if(fixed >= 0x80 && fixed <= 0x99) ch = fixed - 0x3F;
	else if(fixed >= 0x9A && fixed <= 0xB3) ch = fixed - 0x39;
	else if(fixed >= 0xB4 && fixed <= 0xBD) ch = fixed - 0x84;

	else if(fixed == 0xBE) ch = '!';
	else if(fixed == 0xBF) ch = '?';
	else if(fixed == 0xC0) ch = '/';
	else if(fixed == 0xC1) ch = ':';
	else if(fixed == 0xC2) ch = '"';
	else if(fixed == 0xC3) ch = '\'';
	else if(fixed == 0xC4) ch = '-';
	else if(fixed == 0xC5) ch = '.';
	else if(fixed == 0xC6) ch = ',';
	else if(fixed == 0xC8) ch = ';';
	else if(fixed == 0xC9) ch = '#';
	else if(fixed == 0xCA) ch = '+';
	else if(fixed == 0xCB) ch = '(';
	else if(fixed == 0xCC) ch = ')';
	else if(fixed == 0xCD) ch = '%';
	else if(fixed == 0xCE) ch = '~';
	else if(fixed == 0xCF) ch = '*';
	else if(fixed == 0xD2) ch = '=';
	else if(fixed == 0xD3) ch = '@';
	else if(fixed == 0xD7) ch = '"';
//	else if(fixed == 0xFF) ch = ' ';

	return ch;
}

WorldData::WorldData()
{
	objectType = ObjWorldData;

	map = NULL;
	miniMap = NULL;
	tiles = NULL;

	ppdLastScrollPos = CPoint(0, 0);
}

WorldData::~WorldData()
{
	for(int i = 0; i < triggers.GetSize(); i++)
		delete triggers[i];

	if(miniMap) delete [] miniMap;
	if(map) delete [] map;
	if(tiles) delete [] tiles;
}

BOOL WorldData::ReadMapData(DWORD dwOffset)
{
	map = (BYTE*)pDoc->ReadCompressed(pDoc->m_pFile, dwOffset);
	return TRUE;
}

BOOL WorldData::ReadMiniMapData(DWORD dwOffset)
{
	miniMap = (BYTE*)pDoc->ReadCompressed(pDoc->m_pFile, dwOffset);
	return TRUE;
}

BOOL WorldData::ReadTileData(DWORD dwOffset)
{
	// Extract the tiles (as an array of BYTEs) from the ROM.  They are stored
	// in a chunky 4 bits-per-pixel format.  The tile data is 8192 
	// bytes long.

	BYTE* pTiles = (BYTE*)pDoc->ReadCompressed(pDoc->m_pFile, dwOffset);

	memcpy(&(tileFormations), pTiles, 0x400);

	for(int i = 0; i < 256; i++)
	{
		BYTE b1 = pTiles[0x2400 + (i / 2)];

		if(i % 2 == 0)
			tilePalettes[i] = (b1 & 0xF) << 4;
		else
			tilePalettes[i] = b1 & 0xF0;
	}

	tiles = new BYTE[0x2000];
	memcpy(tiles, pTiles + 0x400, 0x2000);

	delete [] pTiles;

	return TRUE;
}

/*BOOL WorldData::ReadEnemyLayout(DWORD dwOffset, DWORD dwLength)
{
	// Extract the tiles (as an array of BYTEs) from the ROM.  They are stored
	// in a chunky sequential 4 bits per pixel format.  The tile data is 8192 
	// bytes long.

	pDoc->m_pFile->Seek(dwOffset, CFile::begin);
	pDoc->m_pFile->Read(enemyLayout, dwLength);

	return TRUE;
}*/

/*BOOL WorldData::ReadEnemyOdds(DWORD dwOffset, DWORD dwLength)
{
	// Extract the tiles (as an array of BYTEs) from the ROM.  They are stored
	// in a chunky sequential 4 bits per pixel format.  The tile data is 8192 
	// bytes long.

	pDoc->m_pFile->Seek(dwOffset, CFile::begin);
	pDoc->m_pFile->Read(enemyOdds, dwLength);

	return TRUE;
}*/

BOOL WorldData::ReadTileProperties(DWORD dwOffset)
{
	// Extract the information assigning various properties for each of the
	// 512 16x16 tiles.  This information tells the game engine which tiles
	// can be walked on, whether enemy encounters are activated, among other
	// things.  Each property is represented by a WORD, totalling 512 bytes
	// of data for 256 tiles.

	pDoc->Seek(dwOffset);
	pDoc->Read(&tileProperties, 512);

	return TRUE;
}

BOOL WorldData::ReadPalettes(DWORD dwOffset)
{
	// Extract the actual color information from the ROM.  There are 128 colors
	// per map, each color being represented by a WORD in a 555 BGR format.
	// This makes a total of 256 bytes per map.

	pDoc->Seek(dwOffset);
	pDoc->Read(&palette, 256);

	return TRUE;
}

BOOL WorldData::ReadTriggers(DWORD dwEntranceOffset, DWORD dwEventOffset)
{
	DWORD dwActualOffset = 0, dwLength = 0;
	WORD wThisOffset = 0, wNextOffset = 0;
	int numEntrances = 0, numEvents = 0;
	BYTE bEvent[3] = { 0 };

	// Read the entrances.
	pDoc->Seek(dwEntranceOffset);
	pDoc->Read(&wThisOffset, 2);
	pDoc->Read(&wNextOffset, 2);

	dwLength = wNextOffset - wThisOffset;

	numEntrances = dwLength / 6;
	triggers.SetSize(numEntrances);

	pDoc->Seek(0xDFBB00 + wThisOffset, CFile::begin);
	for(int i = 0; i < numEntrances; i++)
	{
		EntranceTrigger* pTrigger = new EntranceTrigger;
		pTrigger->type = triggerEntrance;
		pTrigger->flags = TRIGGER_MINIMAP;
		pDoc->Read(&pTrigger->srcX, 2);
		pDoc->Read(&pTrigger->destination, 4);
		triggers[i] = pTrigger;
	}

	// Now read the events.
	pDoc->Seek(dwEventOffset, CFile::begin);
	pDoc->Read(&wThisOffset, 2);
	pDoc->Read(&wNextOffset, 2);

	dwLength = wNextOffset - wThisOffset;

	numEvents = dwLength / 5;
	triggers.SetSize(numEntrances + numEvents);

	pDoc->Seek(0xC40000 + wThisOffset, CFile::begin);
	for(i = numEntrances; i < numEntrances + numEvents; i++)
	{
		EventTrigger* pTrigger = new EventTrigger;
		pTrigger->type = triggerEvent;
		pTrigger->flags = TRIGGER_MINIMAP;
		pTrigger->event = 0;
		pDoc->Read(&pTrigger->srcX, 2);
		pDoc->Read(&pTrigger->event, 3);
		triggers[i] = pTrigger;
	}

	return TRUE;
}

Trigger* WorldData::GetTrigger(BYTE x, BYTE y)
{
	int i;

	for(i = 0; i < triggers.GetSize(); i++)
	{
		Trigger* pTrigger = triggers[i];
		if(pTrigger->srcX == x && pTrigger->srcY == y) return pTrigger;
	}

	return NULL;
}

BOOL WorldData::StoreMapData(DWORD dwDest, DWORD dwOrigSize)
{
	DWORD dwSize = size.cx * size.cy;
	LPVOID pData = pDoc->CompressData(map, dwSize);

	if(dwSize > dwOrigSize)
	{
		// Rewrite pointers.
		for(int i = 0; i < mapPtrs.GetSize(); i++)
		{
			pDoc->Seek(mapPtrs[i]);
			pDoc->Write(&pDoc->m_dwROMEnd, 3);
		}

		pDoc->Seek(dwDest);
		BYTE* dummy = new BYTE[dwOrigSize];
		FillMemory(dummy, dwOrigSize, 0x00);
		pDoc->Write(dummy, dwOrigSize);
		delete [] dummy;

		pDoc->Seek(pDoc->m_dwROMEnd);
		pDoc->Write(pData, dwSize);
		pDoc->m_dwROMEnd += dwSize;
	}
	else
	{
		// Rewrite pointers.
		for(int i = 0; i < mapPtrs.GetSize(); i++)
		{
			pDoc->Seek(mapPtrs[i]);
			pDoc->Write(&dwDest, 3);
		}

		pDoc->Seek(dwDest);
		pDoc->Write(pData, dwSize);
	}

	delete [] pData;

	return TRUE;
}

BOOL WorldData::StoreMiniMapData(DWORD dwDest, DWORD dwOrigSize)
{
	BYTE aMap[4096];
	int bPix[16], bAverage;

	int y, x, ry, rx;

	for(y = 0; y < size.cy; y += 4)
	{
		for(x = 0; x < size.cx; x += 4)
		{
			bPix[0] = ((tileProperties[map[y * size.cx + x]] & 0x0C) >> 2);
			bPix[1] = ((tileProperties[map[y * size.cx + (x + 1)]] & 0x0C) >> 2);
			bPix[2] = ((tileProperties[map[y * size.cx + (x + 2)]] & 0x0C) >> 2);
			bPix[3] = ((tileProperties[map[y * size.cx + (x + 3)]] & 0x0C) >> 2);
			bPix[4] = ((tileProperties[map[(y + 1) * size.cx + x]] & 0x0C) >> 2);
			bPix[5] = ((tileProperties[map[(y + 1) * size.cx + (x + 1)]] & 0x0C) >> 2);
			bPix[6] = ((tileProperties[map[(y + 1) * size.cx + (x + 2)]] & 0x0C) >> 2);
			bPix[7] = ((tileProperties[map[(y + 1) * size.cx + (x + 3)]] & 0x0C) >> 2);
			bPix[8] = ((tileProperties[map[(y + 2) * size.cx + x]] & 0x0C) >> 2);
			bPix[9] = ((tileProperties[map[(y + 2) * size.cx + (x + 1)]] & 0x0C) >> 2);
			bPix[10] = ((tileProperties[map[(y + 2) * size.cx + (x + 2)]] & 0x0C) >> 2);
			bPix[11] = ((tileProperties[map[(y + 2) * size.cx + (x + 3)]] & 0x0C) >> 2);
			bPix[12] = ((tileProperties[map[(y + 3) * size.cx + x]] & 0x0C) >> 2);
			bPix[13] = ((tileProperties[map[(y + 3) * size.cx + (x + 1)]] & 0x0C) >> 2);
			bPix[14] = ((tileProperties[map[(y + 3) * size.cx + (x + 2)]] & 0x0C) >> 2);
			bPix[15] = ((tileProperties[map[(y + 3) * size.cx + (x + 3)]] & 0x0C) >> 2);

			bAverage = 0;
			for(int i = 0; i < 16; i++)
			{
				bPix[i] *= 16;
				bAverage += bPix[i];
			}
			bAverage /= 16;

			if(bAverage == 0) bAverage = 1;
			else if(bAverage > 0 && bAverage < 6) bAverage = 9;
			else if(bAverage >= 6 && bAverage < 24) bAverage = 3;
			else if(bAverage >= 24 && bAverage < 32) bAverage = 4;
			else if(bAverage >= 32) bAverage = 10;

			Trigger* pTrigger = NULL;

			if((pTrigger = GetTrigger(x, y)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 1, y)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 2, y)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 3, y)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x, y + 1)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 1, y + 1)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 2, y + 1)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 3, y + 1)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x, y + 2)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 1, y + 2)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 2, y + 2)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 3, y + 2)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x, y + 3)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 1, y + 3)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 2, y + 3)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;
			else if((pTrigger = GetTrigger(x + 3, y + 3)) && (pTrigger->flags & TRIGGER_MINIMAP)) bAverage = 5;

			aMap[(y / 4) * 64 + (x / 4)] = (BYTE)bAverage;
		}
	}

	ry = 0;
	for(y = 0; y < 8; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	for(y = 16; y < 24; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	for(y = 8; y < 16; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	for(y = 24; y < 40; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	for(y = 48; y < 56; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	for(y = 40; y < 48; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	for(y = 56; y < 64; y += 8, ry += 8)
	{
		rx = 0;
		for(x = 0; x < 64; x += 8, rx += 8)
		{
			BYTE* pChar = &miniMap[(ry * 32) + (rx * 4)];
			BYTE bPlanes[4];

			for(int row = 0; row < 8; row++)
			{
				bPlanes[0] = bPlanes[1] = bPlanes[2] = bPlanes[3] = 0;

				for(int col = 0; col < 8; col++)
				{
					BYTE bColor = aMap[(y + row) * 64 + (x + col)];
					if(bColor & 1) bPlanes[0] |= (1 << (7 - col));
					if(bColor & 2) bPlanes[1] |= (1 << (7 - col));
					if(bColor & 4) bPlanes[2] |= (1 << (7 - col));
					if(bColor & 8) bPlanes[3] |= (1 << (7 - col));
				}

				pChar[row * 2] = bPlanes[0];
				pChar[row * 2 + 1] = bPlanes[1];
				pChar[row * 2 + 16] = bPlanes[2];
				pChar[row * 2 + 17] = bPlanes[3];
			}
		}
	}

	DWORD dwSize = 0x800;
	LPVOID pData = pDoc->CompressData(miniMap, dwSize);

	if(dwSize > dwOrigSize)
	{
		// Rewrite pointers.
		for(int i = 0; i < miniMapPtrs.GetSize(); i++)
		{
			pDoc->Seek(miniMapPtrs[i]);
			pDoc->Write(&pDoc->m_dwROMEnd, 3);
		}

		pDoc->Seek(dwDest);
		BYTE* dummy = new BYTE[dwOrigSize];
		FillMemory(dummy, dwOrigSize, 0x00);
		pDoc->Write(dummy, dwOrigSize);
		delete [] dummy;

		pDoc->Seek(pDoc->m_dwROMEnd);
		pDoc->Write(pData, dwSize);
		pDoc->m_dwROMEnd += dwSize;
	}
	else
	{
		// Rewrite pointers.
		for(int i = 0; i < miniMapPtrs.GetSize(); i++)
		{
			pDoc->Seek(miniMapPtrs[i]);
			pDoc->Write(&dwDest, 3);
		}

		pDoc->Seek(dwDest);
		pDoc->Write(pData, dwSize);
	}

	delete [] pData;

	return TRUE;
}

/*
BOOL WorldData::StoreEnemyLayout(DWORD dwOffset, DWORD dwLength)
{
	// Extract the tiles (as an array of BYTEs) from the ROM.  They are stored
	// in a chunky sequential 4 bits per pixel format.  The tile data is 8192 
	// bytes long.

	pDoc->m_pFile->Seek(dwOffset, CFile::begin);
	pDoc->m_pFile->Write(enemyLayout, dwLength);

	return TRUE;
}

BOOL WorldData::StoreEnemyOdds(DWORD dwOffset, DWORD dwLength)
{
	// Extract the tiles (as an array of BYTEs) from the ROM.  They are stored
	// in a chunky sequential 4 bits per pixel format.  The tile data is 8192 
	// bytes long.

	pDoc->m_pFile->Seek(dwOffset, CFile::begin);
	pDoc->m_pFile->Write(enemyOdds, dwLength);

	return TRUE;
}
*/
BOOL WorldData::StoreTileData(DWORD dwOffset, DWORD dwOrigSize)
{
	// Extract the tiles (as an array of BYTEs) from the ROM.  They are stored
	// in a chunky sequential 4 bits per pixel format.  The tile data is 8192 
	// bytes long.

	BYTE* pTiles = new BYTE[0x2480];
	memcpy(pTiles, &tileFormations, 0x400);
	memcpy(pTiles + 0x400, tiles, 0x2000);

	for(int i = 0; i < 256; i += 2)
	{
		BYTE b1 = (tilePalettes[i] >> 4) | tilePalettes[i + 1];
		pTiles[0x2400 + (i / 2)] = b1;
	}

	DWORD dwSize = 0x2480;
	LPVOID pData = pDoc->CompressData(pTiles, dwSize);

	if(dwSize > dwOrigSize)
	{
		// Rewrite pointers.
		for(int i = 0; i < tilePtrs.GetSize(); i++)
		{
			pDoc->Seek(tilePtrs[i]);
			pDoc->Write(&pDoc->m_dwROMEnd, 3);
		}

		pDoc->Seek(dwOffset);
		BYTE* dummy = new BYTE[dwOrigSize];
		FillMemory(dummy, dwOrigSize, 0x00);
		pDoc->Write(dummy, dwOrigSize);
		delete [] dummy;

		pDoc->Seek(pDoc->m_dwROMEnd);
		pDoc->Write(pData, dwSize);
		pDoc->m_dwROMEnd += dwSize;
	}
	else
	{
		// Rewrite pointers.
		for(int i = 0; i < tilePtrs.GetSize(); i++)
		{
			pDoc->Seek(tilePtrs[i]);
			pDoc->Write(&dwOffset, 3);
		}

		pDoc->Seek(dwOffset);
		pDoc->Write(pData, dwSize);
	}

	delete [] pTiles;

	return TRUE;
}

BOOL WorldData::StoreTileProperties(DWORD dwOffset)
{
	pDoc->Seek(dwOffset);
	pDoc->Write(&tileProperties, 512);

	return TRUE;
}

BOOL WorldData::StorePalettes(DWORD dwOffset)
{
	pDoc->Seek(dwOffset);
	pDoc->Write(&palette, 256);

	return TRUE;
}
/*
BOOL WorldData::StoreEntrances(DWORD dwOffset, BOOL bExpand)
{
	// Create a new instance of an Entrance class and fill it with the
	// necessary parameters for every entrance on the map (each is 5 bytes).
	
	static WORD wNextOffset;

	DWORD dwActualOffset = 0;
	WORD wEntranceOffset = 0, wLength = 0;

	if(dwOffset == 0xD0060)
	{
		wLength = entrances.GetSize() * 5;
		
		if(bExpand)
		{
			dwActualOffset = pDoc->m_dwExpansionOffset;
			wEntranceOffset = 0x0000;

			BYTE bEntr = entrances.GetSize();
			pDoc->m_pFile->Seek(0xD0066, CFile::begin);
			pDoc->m_pFile->Write(&bEntr, 1);
		}
		else
		{
			dwActualOffset = 0xD0066;
			wEntranceOffset = 0x0000;
			wNextOffset = wLength;
		}
	}
	else if(dwOffset == 0xD0062)
	{
		wLength = entrances.GetSize() * 5;

		if(bExpand)
		{
			dwActualOffset = pDoc->m_dwExpansionOffset;
			wEntranceOffset = 0x0500;

			BYTE bEntr = entrances.GetSize();
			pDoc->m_pFile->Seek(0xD0067, CFile::begin);
			pDoc->m_pFile->Write(&bEntr, 1);
		}
		else
		{
			dwActualOffset = 0xD0066;
			wEntranceOffset = wNextOffset;
			wNextOffset += wLength;
		}
	}
	else if(dwOffset == 0xD0064)
	{
		wLength = entrances.GetSize() * 5;

		if(bExpand)
		{
			dwActualOffset = pDoc->m_dwExpansionOffset;
			wEntranceOffset = 0x0A00;

			// We've used 3.75K.
			pDoc->m_dwExpansionOffset += 0xF00;

			BYTE bEntr = entrances.GetSize();
			pDoc->m_pFile->Seek(0xD0068, CFile::begin);
			pDoc->m_pFile->Write(&bEntr, 1);
		}
		else
		{
			dwActualOffset = 0xD0066;
			wEntranceOffset = wNextOffset;
			wNextOffset += wLength;
		}
	}

	// Eight pointers to repair.  Wow.
	DWORD dwPtr0 = SMCToLoROM(dwActualOffset);
	DWORD dwPtr1 = SMCToLoROM(dwActualOffset + 1);
	DWORD dwPtr2 = SMCToLoROM(dwActualOffset + 2);
	DWORD dwPtr3 = SMCToLoROM(dwActualOffset + 3);
	DWORD dwPtr4 = SMCToLoROM(dwActualOffset + 4);
	pDoc->m_pFile->Seek(0x1D8D, CFile::begin);  pDoc->m_pFile->Write(&dwPtr0, 3);
	pDoc->m_pFile->Seek(0x1D96, CFile::begin);  pDoc->m_pFile->Write(&dwPtr1, 3);
	pDoc->m_pFile->Seek(0x1DA7, CFile::begin);  pDoc->m_pFile->Write(&dwPtr2, 3);
	pDoc->m_pFile->Seek(0x1DAF, CFile::begin);  pDoc->m_pFile->Write(&dwPtr3, 3);
	pDoc->m_pFile->Seek(0x1DEA, CFile::begin);  pDoc->m_pFile->Write(&dwPtr2, 3);
	pDoc->m_pFile->Seek(0x1DF1, CFile::begin);  pDoc->m_pFile->Write(&dwPtr3, 3);
	pDoc->m_pFile->Seek(0x1DFA, CFile::begin);  pDoc->m_pFile->Write(&dwPtr4, 3);
	pDoc->m_pFile->Seek(0x1E01, CFile::begin);  pDoc->m_pFile->Write(&dwPtr3, 3);

	pDoc->m_pFile->Seek(dwOffset, CFile::begin);
	pDoc->m_pFile->Write(&wEntranceOffset, 2);

	if(bExpand)
	{
		// Clear out the old data.
		BYTE* bEmpty = new BYTE[0x500];
		ZeroMemory(bEmpty, 0x500);
		
		pDoc->m_pFile->Seek(dwActualOffset + wEntranceOffset, CFile::begin);
		pDoc->m_pFile->Write(bEmpty, 0x500);

		delete bEmpty;
	}

	pDoc->m_pFile->Seek(dwActualOffset + wEntranceOffset, CFile::begin);
	for(int i = 0; i < entrances.GetSize(); i++)
	{
		pDoc->m_pFile->Write(entrances[i], 5);
	}

	return TRUE;
}
*/
//////////////////////////////////////////////////////////////////////////
/*
LocationData::LocationData()
{
	objectType = ObjLocationData;
}

LocationData::~LocationData()
{
	for(int i = 0; i < entrances.GetSize(); i++)
		delete entrances[i];
}

Entrance* LocationData::FindEntranceFromSource(BYTE x, BYTE y)
{
	for(int i = 0; i < entrances.GetSize(); i++)
	{
		Entrance* pEntr = entrances[i];
		if(pEntr->srcX == x && pEntr->srcY == y) return pEntr;
	}

	return NULL;
}

Enemy::Enemy()
{
	size.cx = size.cy = 0;
	gold = 0;
	experience = 0;
	hp = 0;
	tiles = NULL;
}

Enemy::~Enemy()
{
	if(tiles) delete tiles;
}

Event::Event()
{
	size = 0;
}

Event::~Event()
{
	for(int i = 0; i < code.GetSize(); i++)
		delete code[i];
}

GlobalLocationData::GlobalLocationData()
{
	pFile = NULL;
}

GlobalLocationData::~GlobalLocationData()
{
	for(int i = 0; i < 256; i++) delete maps[i];
	for(i = 0; i < 16; i++) delete tiles[i];
}

Item::Item()
{
}

Item::~Item()
{
}

Character::Character()
{
}

Character::~Character()
{
}

*/

CString g_dteTable[] = {
//		0,    1,    2,    3,    4,    5,    6,    7,    8,    9,    A,    B,    C,    D,    E,    F
/* 8 */ "e ", " t", ": ", "th", "t ", "he", "s ", "er", " a", "re", "in", "ou", "d ", " w", " s", "an",
/* 9 */ "o ", " h", " o", "r ", "n ", "at", "to", " i", ", ", "ve", "ng", "ha", " m", "Th", "st", "on",
/* A */ "yo", " b", "me", "y ", "en", "it", "ar", "ll", "ea", "I ", "ed", " f", " y", "hi", "is", "es",
/* B */ "or", "l ", " c", "ne", "'s", "nd", "le", "se", " I", "a ", "te", " l", "pe", "as", "ur", "u ",
/* C */ "al", " p", "g ", "om", " d", "f ", " g", "ow", "rs", "be", "ro", "us", "ri", "wa", "we", "Wh",
/* D */ "et", " r", "nt", "m ", "ma", "I'", "li", "ho", "of", "Yo", "h ", " n", "ee", "de", "so", "gh",
/* E */ "ca", "ra", "n'", "ta", "ut", "el", "! ", "fo", "ti", "We", "lo", "e!", "ld", "no", "ac", "ce",
/* F */ "k ", " u", "oo", "ke", "ay", "w ", "!!", "ag", "il", "ly", "co", ". ", "ch", "go", "ge", "e_"
};

DialogueItem::DialogueItem()
{
}

DialogueItem::~DialogueItem()
{
	if(length != 0 && text) delete [] text;
}

void DialogueItem::ConvertToASCII(CString& str, DWORD tag, DWORD value, ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	DWORD dwMode = 0;
	bTagFound = tagColl.Lookup(DI_ConvertMode, dwValue);
	if(bTagFound)
		dwMode = (DWORD)dwValue;
	else
		return;

	int nOffset = 0;
	bTagFound = tagColl.Lookup(DI_Offset, dwValue);
	if(bTagFound)
		nOffset = (int)dwValue;
	else
		nOffset = 0;

	str.Empty();

	if(text == NULL)
	{
		if(dwMode == DICM_List)
			str = "<Empty>";
		else
			str.Empty();

		return;
	}

	for(int i = nOffset; i < length; i++)
	{
		if(text[i] >= 0x20 && text[i] <= 0x39) str += text[i] + 0x21;
		else if(text[i] >= 0x3A && text[i] <= 0x53) str += text[i] + 0x27;
		else if(text[i] >= 0x54 && text[i] <= 0x5D) str += text[i] - 0x24;

		else if(text[i] >= 0x80 && text[i] <= 0xFF) str += g_dteTable[text[i] - 0x80];

		else if(text[i] == 0x5E) str += "!";
		else if(text[i] == 0x5F) str += "?";
		else if(text[i] == 0x60) str += "/";
		else if(text[i] == 0x61) str += ":";
		else if(text[i] == 0x62) str += "$";			// $ is the right quote in FF3.FNT
		else if(text[i] == 0x63) str += "'";
		else if(text[i] == 0x64) str += "-";
		else if(text[i] == 0x65) str += ".";
		else if(text[i] == 0x66) str += ",";
		else if(text[i] == 0x67) str += "_";			// _ is the ellipsis
		else if(text[i] == 0x68) str += ";";
		else if(text[i] == 0x69) str += "#";
		else if(text[i] == 0x6A) str += "+";
		else if(text[i] == 0x6B) str += "(";
		else if(text[i] == 0x6C) str += ")";
		else if(text[i] == 0x6D) str += "%";
		else if(text[i] == 0x6E) str += "~";
		else if(text[i] == 0x6F) str += "*";
		else if(text[i] == 0x70) str += "@";
		else if(text[i] == 0x71) str += "&";			// & is the musical note
		else if(text[i] == 0x72) str += "=";
		else if(text[i] == 0x73) str += "\"";
		else if(text[i] == 0x7F) str += " ";

		else if(text[i] == 0x01 && dwMode == DICM_List) str += " ";
		else if(text[i] == 0x01 && dwMode == DICM_Edit) str += "\r\n";
		else if(text[i] == 0x13 && dwMode == DICM_List) str += " ";
		else if(text[i] == 0x13 && dwMode == DICM_Edit) str += "<P>\r\n";
		else if(text[i] == 0x15) str += "^";			// ^ is the multiple choice indicator

		else if(text[i] == 0x19) str += "<N>";
		else if(text[i] == 0x1A) str += "<I>";
		else if(text[i] == 0x1B) str += "<S>";

		else if(text[i] == 0x02 && dwMode == DICM_List) str += "TERRA";
		else if(text[i] == 0x03 && dwMode == DICM_List) str += "LOCKE";
		else if(text[i] == 0x04 && dwMode == DICM_List) str += "CYAN";
		else if(text[i] == 0x05 && dwMode == DICM_List) str += "SHADOW";
		else if(text[i] == 0x06 && dwMode == DICM_List) str += "EDGAR";
		else if(text[i] == 0x07 && dwMode == DICM_List) str += "SABIN";
		else if(text[i] == 0x08 && dwMode == DICM_List) str += "CELES";
		else if(text[i] == 0x09 && dwMode == DICM_List) str += "STRAGO";
		else if(text[i] == 0x0A && dwMode == DICM_List) str += "RELM";
		else if(text[i] == 0x0B && dwMode == DICM_List) str += "SETZER";
		else if(text[i] == 0x0C && dwMode == DICM_List) str += "MOG";
		else if(text[i] == 0x0D && dwMode == DICM_List) str += "GAU";
		else if(text[i] == 0x0E && dwMode == DICM_List) str += "GOGO";
		else if(text[i] == 0x0F && dwMode == DICM_List) str += "UMARO";

		else if(text[i] == 0x02 && dwMode == DICM_Edit) str += "<C 1>";
		else if(text[i] == 0x03 && dwMode == DICM_Edit) str += "<C 2>";
		else if(text[i] == 0x04 && dwMode == DICM_Edit) str += "<C 3>";
		else if(text[i] == 0x05 && dwMode == DICM_Edit) str += "<C 4>";
		else if(text[i] == 0x06 && dwMode == DICM_Edit) str += "<C 5>";
		else if(text[i] == 0x07 && dwMode == DICM_Edit) str += "<C 6>";
		else if(text[i] == 0x08 && dwMode == DICM_Edit) str += "<C 7>";
		else if(text[i] == 0x09 && dwMode == DICM_Edit) str += "<C 8>";
		else if(text[i] == 0x0A && dwMode == DICM_Edit) str += "<C 9>";
		else if(text[i] == 0x0B && dwMode == DICM_Edit) str += "<C 10>";
		else if(text[i] == 0x0C && dwMode == DICM_Edit) str += "<C 11>";
		else if(text[i] == 0x0D && dwMode == DICM_Edit) str += "<C 12>";
		else if(text[i] == 0x0E && dwMode == DICM_Edit) str += "<C 13>";
		else if(text[i] == 0x0F && dwMode == DICM_Edit) str += "<C 14>";

		else if((text[i] == 0x10 || text[i] == 0x12) && dwMode == DICM_List) ;
		else if(text[i] == 0x00) ;

		else if(text[i] == 0x10 && dwMode == DICM_Edit) str += "<D>";

		else if(text[i] == 0x14 && dwMode == DICM_List)
		{
			i++;
		}
		else if(text[i] == 0x14 && dwMode == DICM_Edit)
		{
			i++;
			BYTE param = text[i];

			CString t;  t.Format("<T %d>", param);
			str += t;
		}

		else if((text[i] == 0x11 || text[i] == 0x16) && dwMode == DICM_List)
		{
			i++;
			while(text[i] != 0x12)
				i++;			
		}
		else if(text[i] == 0x16 && dwMode == DICM_Edit)
		{
			CString t;
			i++;
			BYTE param = text[i];

			t.Format("<WS %d", param);

			while(text[i] != 0x12)
			{
				str += t;
				i++;
				param = text[i];
				t.Format(", %d", param);
			}

//			str += t;
			str += ">";
		}
		else if(text[i] == 0x11 && dwMode == DICM_Edit)
		{
			CString t;
			i++;
			BYTE param = text[i];

			t.Format("<WT %d", param);

			while(text[i] != 0x12)
			{
				str += t;
				i++;
				param = text[i];
				t.Format(", %d", param);
			}

//			str += t;
			str += ">";
		}

		else
		{
			CString t;
			t.Format("<%02X>", text[i]);
			str += t;
		}
	}
}

extern BYTE g_rawDTE[256];

DWORD DialogueItem::ConvertFromASCII(CString str, DWORD tag, DWORD value, ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	if(str.IsEmpty())
	{
		if(text) delete [] text;

		text = NULL;
		length = NULL;
		return NULL;
	}

	// Length is the length of the ASCII string--the resultant string will NEVER be more
	// than this.
	int len = str.GetLength();
	BYTE* pText = new BYTE[len + 1024];
	BYTE* pOrigPtr = pText;

	CString temp, partial;
	BOOL bMalformed = FALSE;

	for(int i = 0; i < len; i++)
	{
		if(str[i] >= 'A' && str[i] <= 'Z') *(pText++) = str[i] - 0x21;
		else if(str[i] >= 'a' && str[i] <= 'z') *(pText++) = str[i] - 0x27;
		else if(str[i] >= '0' && str[i] <= '9') *(pText++) = str[i] + 0x24;

		else if(str[i] == '!') *(pText++) = 0x5E;
		else if(str[i] == '?') *(pText++) = 0x5F;
		else if(str[i] == '/') *(pText++) = 0x60;
		else if(str[i] == ':') *(pText++) = 0x61;
		else if(str[i] == '$') *(pText++) = 0x62;			// $ is the right quote in FF3.FNT
		else if(str[i] == '\'') *(pText++) = 0x63;
		else if(str[i] == '-') *(pText++) = 0x64;
		else if(str[i] == '.') *(pText++) = 0x65;
		else if(str[i] == ',') *(pText++) = 0x66;
		else if(str[i] == '_') *(pText++) = 0x67;			// _ is the ellipsis
		else if(str[i] == ';') *(pText++) = 0x68;
		else if(str[i] == '#') *(pText++) = 0x69;
		else if(str[i] == '+') *(pText++) = 0x6A;
		else if(str[i] == '(') *(pText++) = 0x6B;
		else if(str[i] == ')') *(pText++) = 0x6C;
		else if(str[i] == '%') *(pText++) = 0x6D;
		else if(str[i] == '~') *(pText++) = 0x6E;
		else if(str[i] == '*') *(pText++) = 0x6F;
		else if(str[i] == '@') *(pText++) = 0x70;
		else if(str[i] == '&') *(pText++) = 0x71;			// & is the musical note
		else if(str[i] == '=') *(pText++) = 0x72;
		else if(str[i] == '"') *(pText++) = 0x73;
		else if(str[i] == ' ') *(pText++) = 0x7F;

		else if(str[i] == '\r' && str[i + 1] == '\n')
		{
			*(pText++) = 0x01;
			i++;
		}

		else if(str[i] == '^') *(pText++) = 0x15;			// ^ is the multiple choice indicator

		// Control character handling

		else if(str[i] == '<')
		{
			i++;

			if(i >= str.GetLength())
			{
				bMalformed = TRUE;
				break;
			}

			// Handle the single-character controls first--they're easiest.
			if(toupper(str[i]) == 'N')
			{
				*(pText++) = 0x19;
				i++;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}
			}
			else if(toupper(str[i]) == 'I')
			{
				*(pText++) = 0x1A;
				i++;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}
			}
			else if(toupper(str[i]) == 'S')
			{
				*(pText++) = 0x1B;
				i++;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}
			}
			else if(toupper(str[i]) == 'D')
			{
				*(pText++) = 0x10;
				i++;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}
			}
			else if(toupper(str[i]) == 'P')
			{
				*(pText++) = 0x13;
				
				i++;
				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}

				char ch = str[i];
				while(ch != '>') { ch = str[i++]; }
				if(i + 2 < str.GetLength() && str[i + 1] == '\r' && str[i + 2] == '\n') i += 2;
			}

			// Now the ones that take parameters.
			else if(toupper(str[i]) == 'C')
			{
				temp.Empty();
				i++;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}

				while(str[i] != ':')
				{
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				while(str[i] != '>')
				{
					temp += str[i];
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				char nVal = atoi(temp);
				*(pText++) = nVal + 0x01;
			}
			else if(toupper(str[i]) == 'T')
			{
				temp.Empty();
				i++;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}

				while(str[i] == ' ')
				{
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				while(str[i] != '>')
				{
					temp += str[i];
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				char nVal = atoi(temp);

				*(pText++) = 0x14;
				*(pText++) = nVal;
			}
			else if(toupper(str[i]) == 'W' && toupper(str[i + 1]) == 'S')
			{
				temp.Empty();
				i += 2;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}

				while(str[i] == ' ')
				{
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				while(str[i] != '>')
				{
					temp += str[i];
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				char nVal = atoi(temp);

				*(pText++) = 0x16;
				*(pText++) = nVal;
				*(pText++) = 0x12;
			}
			else if(toupper(str[i]) == 'W' && toupper(str[i + 1]) == 'T')
			{
				temp.Empty();
				i += 2;

				if(i >= str.GetLength())
				{
					bMalformed = TRUE;
					break;
				}

				while(str[i] == ' ')
				{
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				while(str[i] != '>')
				{
					temp += str[i];
					i++;

					if(i >= str.GetLength())
					{
						bMalformed = TRUE;
						break;
					}
				}

				char nVal = atoi(temp);

				*(pText++) = 0x11;
				*(pText++) = nVal;
				*(pText++) = 0x12;
			}
			else
			{
				bMalformed = TRUE;
				break;
			}
		}
	}

	if(bMalformed)
	{
		delete [] pOrigPtr;
		return DICERROR_Malformed;
	}

	*(pText++) = 0x00;

	// Now go through and compress with DTE.
	len = pText - pOrigPtr;

	BYTE* pDTE = new BYTE[len];
	BYTE* pOrigDTE = pDTE;
	BOOL bMatch;

	for(i = 0; i < len; i++)
	{
		bMatch = FALSE;

		if(i < len - 1)
		{
			BYTE b1 = pOrigPtr[i];
			BYTE b2 = pOrigPtr[i + 1];

			for(BYTE j = 0; j < 128; j++)
			{
				if(b1 == g_rawDTE[j * 2] && b2 == g_rawDTE[j * 2 + 1])
				{
					*(pDTE++) = 0x80 + j;
					bMatch = TRUE;
					i++;
					break;
				}
			}

			if(bMatch == FALSE)
			{
				*(pDTE++) = b1;
			}
		}
		else
			*(pDTE++) = pOrigPtr[i];
	}

	if(text) delete [] text;
	delete [] pOrigPtr;

	len = pDTE - pOrigDTE;
	BYTE* pCompressed = new BYTE[len];
	memcpy(pCompressed, pOrigDTE, len);

	delete [] pOrigDTE;

	text = pCompressed;
	length = len;

	return NULL;
}
