// FF3Doc.h : interface of the CFF3Doc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FF3DOC_H__F76E85AA_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_FF3DOC_H__F76E85AA_B089_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FF3Data.h"

#define WM_COMPAREVIEW (WM_USER + 100)

class CFF3Doc : public CDocument
{
protected: // create from serialization only
	CFF3Doc();
	DECLARE_DYNCREATE(CFF3Doc)

// Attributes
public:
	CFile* m_pFile;
	BOOL m_bValid;
	DWORD m_dwROMEnd;

	WorldData* worldData;
	BYTE event[16384];

	CTypedPtrArray<CPtrArray, DialogueItem*> dialogue;
	BYTE charWidths[128];

	Character characters[64];
	CharacterGraphic characterGraphic[40];
	BYTE hpProgression[98];
	BYTE mpProgression[98];

	Item items[256];
	Esper espers[27];
	Magic magic[256];
	BattleCommand battleCommands[32];
	ShopData shops[128];

	MonsterFormation monsterFormations[576];
	Monster monsters[384];
	MonsterTemplate monsterTemplates[13][6];
	int monsterTemplateCount[13];
	BYTE monsterGraphics[0x38000];
	MonsterVisuals monsterVisuals[384];
	MonsterComposition monsterCompositions[176];
	WORD monsterPalettes[0x1800];
	BYTE morphPackages[26][4];

	WORD variableFont[11 * 128];
	BYTE fixedFont[16 * 128];

	WORD characterPalettes[128];		// 8 palettes, 16 words each
	WORD portraitPalettes[256];		// 16 palettes, 16 words each

	BYTE romChanges[128];

// File operations (allows me to access everything with HiROM offsets)
	void Seek(DWORD dwHI, UINT nFrom = CFile::begin) { m_pFile->Seek(HiROMToSMC(dwHI), nFrom); }
	void Read(void* lpBuf, UINT nCount) { m_pFile->Read(lpBuf, nCount); }
	void Write(const void* lpBuf, UINT nCount) { m_pFile->Write(lpBuf, nCount); }

//	DWORD WriteBlock(DWORD dwBegin, DWORD dwEnd, const void* lpBuf, UINT nCount);

	void LoadChanges() { m_pFile->Seek(0x80, CFile::begin); m_pFile->Read(romChanges, 0x80); }
	void SaveChanges() { m_pFile->Seek(0x80, CFile::begin); m_pFile->Write(romChanges, 0x80); }
	void SetChange(BYTE byte, BYTE bit, BOOL set)
	{
		if(set) romChanges[byte] |= bit;
		else romChanges[byte] &= ~(bit);
	}
	BOOL GetChange(BYTE byte, BYTE bit) { return romChanges[byte] & bit; }

// Operations
public:
	LPVOID ReadCompressed(CFile* pFile, DWORD dwSource);
	LPVOID CompressData(LPVOID pData, DWORD& dwSize);

	void PatchDialogueRoutine(CFile* pFile);
	DWORD GetPointer(CFile* pFile, DWORD dwOffset);

	CFrameWnd* CreateFrame(CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass,
		int nID, LPVOID lpData, DWORD dwStyle = WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE);
	CFrameWnd* CreateFrameAlways(CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass,
		int nID, DWORD dwStyle = WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF3Doc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFF3Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFF3Doc)
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FF3DOC_H__F76E85AA_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
