// FF3Edit.h : main header file for the FF3EDIT application
//

#if !defined(AFX_FF3EDIT_H__F76E85A4_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_FF3EDIT_H__F76E85A4_B089_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "ResourceCollection.h"

#include "Hyperlink.h"

class CFF3Doc;

#define WM_DIALOGUESWITCH	(WM_APP + 0x200)
#define WM_INITVIEW			(WM_APP + 0x400)

// Tags
#define TAG_END					0x00000000

class DDrawUtil
{
public:
	// Functions
	LPDIRECTDRAWPALETTE LoadPalette(LPDIRECTDRAW4 pdd, LPCSTR szBitmap);
	LPDIRECTDRAWSURFACE4 LoadBitmap(LPDIRECTDRAW4 pdd, LPCSTR szBitmap, int dx, int dy);
	LPDIRECTDRAWSURFACE4 LoadSizeBitmap(LPDIRECTDRAW4 pdd, LPCSTR szBitmap, int *dx, int *dy);
	HRESULT ReLoadBitmap(LPDIRECTDRAWSURFACE4 pdds, LPCSTR szBitmap);
	HRESULT CopyBitmap(LPDIRECTDRAWSURFACE4 pdds, HBITMAP hbm, int x, int y, int dx, int dy);
	DWORD ColorMatch(LPDIRECTDRAWSURFACE4 pdds, COLORREF rgb);
	HRESULT SetColorKey(LPDIRECTDRAWSURFACE4 pdds, COLORREF rgb);
	void Error(HRESULT hErr, HWND hWnd);

	// Variables
	LPDIRECTDRAW4 lpDD;
	LPDIRECTDRAWSURFACE4 lpSurfFront;
	DDPIXELFORMAT ddpfPrimary;
	LPDIRECTDRAWCLIPPER lpClipper;
	DWORD dwColorBG, dwColorBlack, dwColorGrid, dwColorCursor;
};

static double HuetoRGB(double m1, double m2, double h );
COLORREF HLStoRGB( double H, double L, double S );
void RGBtoHSL( COLORREF rgb, double *H, double *S, double *L );
WORD HLStoRGB555( double H, double L, double S );
void RGB555toHSL( WORD rgb, double *H, double *S, double *L );

typedef struct
{
	RECT rect;
	BOOL bVisible, bMaximized, bMinimized;
} WINDOWSPECS;

class AppSettings
{
public:
	AppSettings();
	~AppSettings();

	CString FormatWindowSpecs(WINDOWSPECS* ws);
	BOOL ExtractWindowSpecs(CString& str, WINDOWSPECS* ws);

	BOOL bMapGridlines, bAdvanced;

	WINDOWSPECS wsMainWindow;
	WINDOWSPECS wsTileDlg, wsTileWnd, wsTriggerWnd;
	WINDOWSPECS wsGenericPropWnd;
};

/////////////////////////////////////////////////////////////////////////////
// CFF3EditApp:
// See FF3Edit.cpp for the implementation of this class
//

class CFF3EditApp : public CWinApp
{
public:
	CFF3EditApp();

	DDrawUtil _DDraw;
	AppSettings* _Settings;

	UINT clipboardWorldMap;

	CResourceCollection* GetResources() { return m_pResources; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF3EditApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CFF3EditApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	CResourceCollection* m_pResources;

};

#define App (*(CFF3EditApp*)AfxGetApp())
#define DDraw (((CFF3EditApp*)AfxGetApp())->_DDraw)
#define Classes (((CFF3EditApp*)AfxGetApp())->_Classes)
#define Settings (*(((CFF3EditApp*)AfxGetApp())->_Settings))

/////////////////////////////////////////////////////////////////////////////

#define RGB555(r, g, b) (WORD)((BYTE)(r) | ((BYTE)(g) << 5) | ((BYTE)(b) << 10))
#define R555(clr) (clr & 0x1F)
#define G555(clr) ((clr >> 5) & 0x1F)
#define B555(clr) ((clr >> 10) & 0x1F)

DWORD DDColor(BYTE r, BYTE g, BYTE b);
BYTE DDGetR(DWORD color);
BYTE DDGetG(DWORD color);
BYTE DDGetB(DWORD color);
DWORD Convert555ToDDColor(WORD color);
DWORD SubtractDDColor(DWORD src, DWORD dest, BYTE opacity);

#define SendCommandMessage(wnd, msg) SendMessage(WM_COMMAND, MAKELONG((wnd)->GetDlgCtrlID(), (msg)), (LPARAM)(wnd)->GetSafeHwnd())

#define SMCToHiROM(dwSMC) (dwSMC - 0x200 + 0xC00000)
#define HiROMToSMC(dwHiROM) (dwHiROM - 0xC00000 + 0x200)

int OutputVariableFontChar(CDC* pDC, CPoint pt, CFF3Doc* pDoc, BYTE bChar, BOOL bShadow = TRUE);
int OutputFixedFontChar(CDC* pDC, CPoint pt, CFF3Doc* pDoc, BYTE bChar, BOOL bShadow = TRUE);

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FF3EDIT_H__F76E85A4_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
