// HexEditCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "HexEditCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


void AFXAPI DDX_HexValue(CDataExchange* pDX, int nIDC, UINT& value, int nLength)
{
	HWND hWndMain = pDX->PrepareCtrl(nIDC);
	HWND hWndCtrl = ::GetDlgItem(hWndMain, 1000);

	char szT[32];

	if(pDX->m_bSaveAndValidate)
	{
		::GetWindowText(hWndCtrl, szT, sizeof(szT));
		value = strtoul(szT, NULL, 16);
	}
	else
	{
		sprintf(szT, _T("%0*X"), nLength, value);
		::SetWindowText(hWndCtrl, szT);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CHexEditCtrl

CHexEditCtrl::CHexEditCtrl()
{
}

CHexEditCtrl::~CHexEditCtrl()
{
}


BEGIN_MESSAGE_MAP(CHexEditCtrl, CWnd)
	//{{AFX_MSG_MAP(CHexEditCtrl)
	ON_WM_SETFOCUS()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SETFONT, OnSetFont)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexEditCtrl message handlers

void CHexEditCtrl::PreSubclassWindow() 
{
	CWnd::PreSubclassWindow();

	CRect rect;  GetClientRect(rect);
	rect.DeflateRect(1, 1, 2, 2);
	rect.left += 8;

	m_wndEdit.Create(WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL | ES_UPPERCASE, rect, this, 1000);
	m_wndEdit.SetFont(GetFont());
}

void CHexEditCtrl::OnSetFocus(CWnd* pOldWnd) 
{
	m_wndEdit.SetFocus();
}

LRESULT CHexEditCtrl::OnSetFont(WPARAM wParam, LPARAM lParam)
{
	Default();

	CClientDC dc(this);
	CRect rect;  GetClientRect(rect);

	CString s = "$";
	CFont* oldFont = dc.SelectObject(GetFont());
	CSize size = dc.GetTextExtent(s, s.GetLength());

	rect.DeflateRect(1, 1, 2, 2);
	rect.left += size.cx;
	m_wndEdit.MoveWindow(rect);

	dc.SelectObject(oldFont);

	return m_wndEdit.SendMessage(WM_SETFONT, wParam, lParam);
}

void CHexEditCtrl::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect rect;  GetClientRect(rect);
	dc.FillSolidRect(rect, GetSysColor(COLOR_WINDOW));

	CString s = "$";
	CFont* oldFont = dc.SelectObject(GetFont());
	dc.SetTextColor(GetSysColor(COLOR_WINDOWTEXT));
	dc.TextOut(2, 1, s);
	dc.SelectObject(oldFont);
}

void CHexEditCtrl::SetValue(UINT nValue, int nLength)
{
	CString s;  s.Format("%0*X", nLength, nValue);
	m_wndEdit.SetWindowText(s);
}

UINT CHexEditCtrl::GetValue()
{
	CString s;
	m_wndEdit.GetWindowText(s);

	return strtoul(s, NULL, 16);
}


/////////////////////////////////////////////////////////////////////////////
// XHexEditCtrl

XHexEditCtrl::XHexEditCtrl()
{
}

XHexEditCtrl::~XHexEditCtrl()
{
}


BEGIN_MESSAGE_MAP(XHexEditCtrl, CEdit)
	//{{AFX_MSG_MAP(XHexEditCtrl)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// XHexEditCtrl message handlers

void XHexEditCtrl::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if((nChar >= '0' && nChar <= '9') || (nChar >= 'A' && nChar <= 'F') ||
		nChar == 0x08)
	{
		CEdit::OnChar(nChar, nRepCnt, nFlags);
		return;
	}

	MessageBeep(-1);
}
