// ItemEditView.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Doc.h"
#include "ItemEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CItemEditView

IMPLEMENT_DYNCREATE(CItemEditView, CSizingFormView)

CItemEditView::CItemEditView()
	: CSizingFormView(CItemEditView::IDD)
{
	//{{AFX_DATA_INIT(CItemEditView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CItemEditView::~CItemEditView()
{
}

void CItemEditView::DoDataExchange(CDataExchange* pDX)
{
	CSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CItemEditView)
	DDX_Control(pDX, IDC_LIST, m_wndList);
	DDX_Control(pDX, IDC_PROPS, m_wndProps);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CItemEditView, CSizingFormView)
	//{{AFX_MSG_MAP(CItemEditView)
	ON_WM_CREATE()
	ON_LBN_SELCHANGE(IDC_LIST, OnSelChangeItemList)
	//}}AFX_MSG_MAP
	ON_NOTIFY(PROPTN_PROPCHANGED, IDC_PROPS, OnChangeProperties)
	ON_MESSAGE(WM_COMPAREVIEW, OnCompareView)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CItemEditView diagnostics

#ifdef _DEBUG
void CItemEditView::AssertValid() const
{
	CSizingFormView::AssertValid();
}

void CItemEditView::Dump(CDumpContext& dc) const
{
	CSizingFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CItemEditView message handlers

LRESULT CItemEditView::OnCompareView(WPARAM wParam, LPARAM lParam)
{
	if(lParam == 'ITMG') return TRUE;
	else return FALSE;
}

int CItemEditView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CSizingFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetControlInfo(IDC_MINBOUNDS, MINIMUM_BOUND);
	SetControlInfo(IDC_LIST, RESIZE_VERT);
	SetControlInfo(IDC_PROPS, RESIZE_HORZ | RESIZE_VERT);
	
	return 0;
}

PROPERTYITEM g_strItemTypes[] =
{
	{ 0, "Tool", NULL },
	{ 1, "Weapon", NULL },
	{ 2, "Armor", NULL },
	{ 3, "Shield", NULL },
	{ 4, "Hat", NULL },
	{ 5, "Relic", NULL },
	{ 6, "Item", NULL },
	{ -1, NULL, NULL },
};

PROPERTYITEM g_strPercentModifiers[] =
{
	{ 0, "No change", NULL },
	{ 1, "+10%", NULL },
	{ 2, "+20%", NULL },
	{ 3, "+30%", NULL },
	{ 4, "+40%", NULL },
	{ 5, "+50%", NULL },
	{ 6, "-10%", NULL },
	{ 7, "-20%", NULL },
	{ 8, "-30%", NULL },
	{ 9, "-40%", NULL },
	{ 10, "-50%", NULL },
	{ -1, NULL, NULL },
};

PROPERTYITEM g_strConstantModifiers[] =
{
	{ 0, "No change", NULL },
	{ 1, "+1", NULL },
	{ 2, "+2", NULL },
	{ 3, "+3", NULL },
	{ 4, "+4", NULL },
	{ 5, "+5", NULL },
	{ 6, "+6", NULL },
	{ 7, "+7", NULL },
	{ 8, "No change", NULL },
	{ 9, "-1", NULL },
	{ 10, "-2", NULL },
	{ 11, "-3", NULL },
	{ 12, "-4", NULL },
	{ 13, "-5", NULL },
	{ 14, "-6", NULL },
	{ 15, "-7", NULL },
	{ -1, NULL, NULL },
};

PROPERTYITEM g_strItemActions[] =
{
	{ 0, "No special action", NULL },
	{ 1, "Summon random esper", NULL },
	{ 2, "Super Ball attack", NULL },
	{ 3, "Remove character from battle", NULL },
	{ 4, "? (Elixir/Megalixir uses this)", NULL },
	{ 5, "All characters escape from battle", NULL },
	{ 6, "Attracts Gau when encountered on the Veldt", NULL },
	{ -1, NULL, NULL },
};

PROPERTYITEM g_strWeaponActions[] =
{
	{ 0, "No special action", NULL },
	{ 1, "Steal item", NULL },
	{ 2, "Attack increases as HP increases", NULL },
	{ 3, "Kill (with X graphic)", NULL },
	{ 4, "Cause double damage to humans", NULL },
	{ 5, "Drain HP", NULL },
	{ 6, "Drain MP", NULL },
	{ 7, "Attack with MP", NULL },
	{ 8, "Unknown (used by Hawkeye and Sniper)", NULL },
	{ 9, "Dice", NULL },
	{ 10, "Attack increases as HP decreases", NULL },
	{ 11, "Wind attack", NULL },
	{ 12, "Recover HP", NULL },
	{ 13, "Kill", NULL },
	{ 14, "Uses MP to inflict mortal blow", NULL },
	{ 15, "Uses (more) MP to inflict mortal blow (?)", NULL },
	{ -1, NULL, NULL },
};

void CItemEditView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();

	m_wndProps.m_pDoc = pDoc;

	m_wndList.ResetContent();
	m_wndList.m_pDoc = pDoc;
	m_wndList.m_dwListStyle = FF3LBS_NOCHANGE;

	m_itemArray.RemoveAll();

	for(int i = 0; i < 256; i++)
		m_itemArray.Add(pDoc->items[i].name);

	m_wndList.m_pArray = &m_itemArray;

	for(i = 0; i < 256; i++)
	{
		m_wndList.AddItem(i, 13);
	}

	for(i = 0; i < 0x36; i++)
		m_magicArray.Add(pDoc->magic[i].name);

	m_wndList.SetCurSel(0);
	UpdateTree();
}

void CItemEditView::UpdateTree()
{
	int nSel = m_wndList.GetCurSel();

	m_wndProps.SetRedraw(FALSE);

	// Store the expanded nodes.
	LRESULT bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(100);  if(bExpanded != 0x80000001) m_expanded[100] = bExpanded; 
	bExpanded = m_wndProps.IsItemExpanded(200);  if(bExpanded != 0x80000001) m_expanded[200] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(1000);  if(bExpanded != 0x80000001) m_expanded[1000] = bExpanded; 
	bExpanded = m_wndProps.IsItemExpanded(2000);  if(bExpanded != 0x80000001) m_expanded[2000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(3000);  if(bExpanded != 0x80000001) m_expanded[3000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(4000);  if(bExpanded != 0x80000001) m_expanded[4000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(4100);  if(bExpanded != 0x80000001) m_expanded[4100] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(4200);  if(bExpanded != 0x80000001) m_expanded[4200] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(4300);  if(bExpanded != 0x80000001) m_expanded[4300] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(4400);  if(bExpanded != 0x80000001) m_expanded[4400] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(5000);  if(bExpanded != 0x80000001) m_expanded[5000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(6000);  if(bExpanded != 0x80000001) m_expanded[6000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(7000);  if(bExpanded != 0x80000001) m_expanded[7000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(8000);  if(bExpanded != 0x80000001) m_expanded[8000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(9000);  if(bExpanded != 0x80000001) m_expanded[9000] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(9100);  if(bExpanded != 0x80000001) m_expanded[9100] = bExpanded;
	bExpanded = m_wndProps.IsItemExpanded(9200);  if(bExpanded != 0x80000001) m_expanded[9200] = bExpanded;

	// Update the property tree.
	m_wndProps.DeleteAllItems();
	
	if(nSel == -1)
	{
		m_wndProps.SetRedraw(TRUE);
		m_wndProps.Invalidate();
		return;
	}

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	BYTE* pProps = pDoc->items[nSel].props;

	m_wndProps.SetTrueFalseText(_T("Yes"), _T("No"));
	m_wndProps.AddGroup(1000, "General");
		m_wndProps.AddItem(1000, 1001, "Name", PROPT_FF3EDIT, 13, (LPARAM)&pDoc->items[nSel].name);
		m_wndProps.AddItem(1000, 1002, "Item Type", PROPT_COMBO, 0, (LPARAM)&g_strItemTypes, pProps[0] & 0x0F);
		m_wndProps.AddItem(1000, 1003, "Can be thrown", PROPT_BOOLEAN, NULL, pProps[0] & 0x10);
		m_wndProps.AddItem(1000, 1004, "Can be used as an item in battle", PROPT_BOOLEAN, NULL, pProps[0] & 0x20);
		m_wndProps.AddItem(1000, 1005, "Can be used in the field", PROPT_BOOLEAN, NULL, pProps[0] & 0x40);
		m_wndProps.AddItem(1000, 1006, "Cost in GP", PROPT_NUMEDIT, 0, MAKEWORD(pProps[0x1C], pProps[0x1D]));

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		CString s;
		m_wndProps.AddGroup(100, "Equippable By:");

			for(int i = 0; i < 8; i++)
			{
				s = FixedTextToCString(pDoc->characters[i].name, 6, NULL, NULL);
				m_wndProps.AddItem(100, 101 + i, s, PROPT_BOOLEAN, 0, pProps[1] & (1 << i));
			}
			for(i = 0; i < 6; i++)
			{
				s = FixedTextToCString(pDoc->characters[i + 8].name, 6, NULL, NULL);
				m_wndProps.AddItem(100, 109 + i, s, PROPT_BOOLEAN, 0, pProps[2] & (1 << i));
			}

			m_wndProps.AddItem(100, 115, "Effective only when Imp", PROPT_BOOLEAN, 0, pProps[2] & 0x40);
			m_wndProps.AddItem(100, 116, "Unknown Bit", PROPT_BOOLEAN, 0, pProps[2] & 0x80);
	}

	m_wndProps.AddGroup(2000, "Targetting");
		m_wndProps.AddItem(2000, 2001, "Affects single ally or enemy", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x01);
		m_wndProps.AddItem(2000, 2002, "Affects either enemies or allies only", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x02);
		m_wndProps.AddItem(2000, 2003, "Affects all allies and all enemies", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x04);
		m_wndProps.AddItem(2000, 2004, "Affects either all allies or all enemies", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x08);
		m_wndProps.AddItem(2000, 2005, "Auto-accept default selection", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x10);
		m_wndProps.AddItem(2000, 2006, "Multiple selection possible", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x20);
		m_wndProps.AddItem(2000, 2007, "Enemy is selected by default", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x40);
		m_wndProps.AddItem(2000, 2008, "Random selection among all enemies and allies", PROPT_BOOLEAN, NULL, pProps[0x0E] & 0x80);

	if((pProps[0] & 0x0F) == 0x01)
	{
		m_wndProps.AddGroup(200, "Attack- and Ability-Related Properties");
			m_wndProps.AddItem(200, 201, "Can use SwdTech when equipped", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x02);
			m_wndProps.AddItem(200, 202, "Can use Runic when equipped", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x80);
			m_wndProps.AddItem(200, 203, "Can use with two hands", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x40);
			m_wndProps.AddItem(200, 204, "Does same damage from back row", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x20);
			m_wndProps.AddItem(200, 205, "Special action performed when used", PROPT_COMBO, NULL, (LPARAM)&g_strWeaponActions, (pProps[0x1B] & 0xF0) >> 4);
			m_wndProps.AddItem(200, 206, "Unknown nybble", PROPT_NUMEDIT, 0, pProps[0x1B] & 0x0F);
	}
	else if((pProps[0] & 0x0F) == 0x06)
	{
		m_wndProps.AddGroup(200, "Ability-Related Properties");
			m_wndProps.AddItem(200, 201, "Affects HP", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x08);
			m_wndProps.AddItem(200, 202, "Affects MP", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x10);
			m_wndProps.AddItem(200, 203, "Removes status conditions", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x20);
			m_wndProps.AddItem(200, 204, "Causes damage", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x40);
			m_wndProps.AddItem(200, 205, "Manipulates 1/16ths of the maximum value affected", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x80);
			m_wndProps.AddItem(200, 206, "Special action performed when used", PROPT_COMBO, NULL, (LPARAM)&g_strItemActions, (pProps[0x1B] == 0xFF) ? 0 : pProps[0x1B]);
			m_wndProps.AddItem(200, 207, "Unknown bit", PROPT_BOOLEAN, NULL, pProps[0x13] & 0x02);
	}

	m_wndProps.AddGroup(6000, "Numerical Status Properties");

		if((pProps[0] & 0x0F) == 0x00)
		{
			m_wndProps.AddItem(6000, 6001, "Attack Strength", PROPT_NUMEDIT, 0, pProps[0x14]);
			m_wndProps.AddItem(6000, 6002, "Hit Rate", PROPT_NUMEDIT, 0, pProps[0x15]);
		}
		else if((pProps[0] & 0x0F) == 0x01)
		{
			m_wndProps.AddItem(6000, 6001, "Battle Power", PROPT_NUMEDIT, 0, pProps[0x14]);
			m_wndProps.AddItem(6000, 6002, "Hit Rate", PROPT_NUMEDIT, 0, pProps[0x15]);
			m_wndProps.AddItem(6000, 6003, "Vigor Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, pProps[0x10] & 0x0F);
			m_wndProps.AddItem(6000, 6004, "Speed Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, (pProps[0x10] & 0xF0) >> 4);
			m_wndProps.AddItem(6000, 6005, "Stamina Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, pProps[0x11] & 0x0F);
			m_wndProps.AddItem(6000, 6006, "Magic Power Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, (pProps[0x11] & 0xF0) >> 4);
			m_wndProps.AddItem(6000, 6007, "Evade% Modification", PROPT_COMBO, 0, (LPARAM)&g_strPercentModifiers, pProps[0x1A] & 0x0F);
			m_wndProps.AddItem(6000, 6008, "Magic Block% Modification", PROPT_COMBO, 0, (LPARAM)&g_strPercentModifiers, (pProps[0x1A] & 0xF0) >> 4);
		}
		else if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
		{
			m_wndProps.AddItem(6000, 6001, "Defense Power", PROPT_NUMEDIT, 0, pProps[0x14]);
			m_wndProps.AddItem(6000, 6002, "Magic Defense Power", PROPT_NUMEDIT, 0, pProps[0x15]);
			m_wndProps.AddItem(6000, 6003, "Vigor Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, pProps[0x10] & 0x0F);
			m_wndProps.AddItem(6000, 6004, "Speed Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, (pProps[0x10] & 0xF0) >> 4);
			m_wndProps.AddItem(6000, 6005, "Stamina Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, pProps[0x11] & 0x0F);
			m_wndProps.AddItem(6000, 6006, "Magic Power Modification", PROPT_COMBO, 0, (LPARAM)&g_strConstantModifiers, (pProps[0x11] & 0xF0) >> 4);
			m_wndProps.AddItem(6000, 6007, "Evade% Modification", PROPT_COMBO, 0, (LPARAM)&g_strPercentModifiers, pProps[0x1A] & 0x0F);
			m_wndProps.AddItem(6000, 6008, "Magic Block% Modification", PROPT_COMBO, 0, (LPARAM)&g_strPercentModifiers, (pProps[0x1A] & 0xF0) >> 4);
		}
		else if((pProps[0] & 0x0F) == 0x06)
		{
			m_wndProps.AddItem(6000, 6001, "HP/MP Affected", PROPT_NUMEDIT, 0, pProps[0x14]);
		}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		m_wndProps.AddGroup(7000, "Boolean Status Properties");
			m_wndProps.AddItem(7000, 7001, "Raise Attack Damage", PROPT_BOOLEAN, 0, pProps[0x09] & 0x01);
			m_wndProps.AddItem(7000, 7002, "Raise Magic Damage", PROPT_BOOLEAN, 0, pProps[0x09] & 0x02);
			m_wndProps.AddItem(7000, 7003, "Raise HP by 25%", PROPT_BOOLEAN, 0, pProps[0x09] & 0x04);
			m_wndProps.AddItem(7000, 7004, "Raise HP by 50%", PROPT_BOOLEAN, 0, pProps[0x09] & 0x08);
			m_wndProps.AddItem(7000, 7005, "Raise HP by 12%", PROPT_BOOLEAN, 0, pProps[0x09] & 0x10);
			m_wndProps.AddItem(7000, 7006, "Raise MP by 25%", PROPT_BOOLEAN, 0, pProps[0x09] & 0x20);
			m_wndProps.AddItem(7000, 7007, "Raise MP by 50%", PROPT_BOOLEAN, 0, pProps[0x09] & 0x40);
			m_wndProps.AddItem(7000, 7008, "Raise MP by 12%", PROPT_BOOLEAN, 0, pProps[0x09] & 0x80);
			m_wndProps.AddItem(7000, 7009, "Increase Steal Success Rate", PROPT_BOOLEAN, 0, pProps[0x0B] & 0x01);
			m_wndProps.AddItem(7000, 7010, "Increase Hit Rate to 100%", PROPT_BOOLEAN, 0, pProps[0x0B] & 0x10);
			m_wndProps.AddItem(7000, 7011, "Halve MP Consumption", PROPT_BOOLEAN, 0, pProps[0x0B] & 0x20);
			m_wndProps.AddItem(7000, 7012, "Reduce MP Consumption to 1", PROPT_BOOLEAN, 0, pProps[0x0B] & 0x40);
			m_wndProps.AddItem(7000, 7013, "Raise Vigor", PROPT_BOOLEAN, 0, pProps[0x0B] & 0x80);
		}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		m_wndProps.AddGroup(8000, "Battle-Related Effects");
			m_wndProps.AddItem(8000, 8001, "Fight becomes Jump", PROPT_BOOLEAN, 0, pProps[0x0A] & 0x04);
			m_wndProps.AddItem(8000, 8002, "Magic becomes X-Magic", PROPT_BOOLEAN, 0, pProps[0x0A] & 0x08);
			m_wndProps.AddItem(8000, 8003, "Sketch becomes Control", PROPT_BOOLEAN, 0, pProps[0x0A] & 0x10);
			m_wndProps.AddItem(8000, 8004, "Slot becomes GP Rain", PROPT_BOOLEAN, 0, pProps[0x0A] & 0x20);
			m_wndProps.AddItem(8000, 8005, "Steal becomes Capture", PROPT_BOOLEAN, 0, pProps[0x0A] & 0x40);
			m_wndProps.AddItem(8000, 8006, "Jump continuously", PROPT_BOOLEAN, 0, pProps[0x0A] & 0x80);
			m_wndProps.AddItem(8000, 8007, "Fight becomes X-Fight", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x01);
			m_wndProps.AddItem(8000, 8008, "Character randomly counter attacks", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x02);
			m_wndProps.AddItem(8000, 8009, "Increase chances of evading attacks", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x04);
			m_wndProps.AddItem(8000, 8010, "Character can attack with both hands", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x08);
			m_wndProps.AddItem(8000, 8011, "Character can equip a weapon in each hand", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x10);
			m_wndProps.AddItem(8000, 8012, "Wearer can equip heavy armor", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x20);
			m_wndProps.AddItem(8000, 8013, "Wearer protects those with low HP", PROPT_BOOLEAN, 0, pProps[0x0C] & 0x40);
			m_wndProps.AddItem(8000, 8014, "Casts Shell when HP gets low", PROPT_BOOLEAN, 0, pProps[0x0D] & 0x01);
			m_wndProps.AddItem(8000, 8015, "Casts Safe when HP gets low", PROPT_BOOLEAN, 0, pProps[0x0D] & 0x02);
			m_wndProps.AddItem(8000, 8016, "Casts Rflect when HP gets low", PROPT_BOOLEAN, 0, pProps[0x0D] & 0x04);
			m_wndProps.AddItem(8000, 8017, "Doubles experience received", PROPT_BOOLEAN, 0, pProps[0x0D] & 0x08);
			m_wndProps.AddItem(8000, 8018, "Doubles gold received", PROPT_BOOLEAN, 0, pProps[0x0D] & 0x10);
			m_wndProps.AddItem(8000, 8019, "Makes body cold", PROPT_BOOLEAN, 0, pProps[0x0D] & 0x80);
		}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		m_wndProps.AddGroup(9000, "Status Conditions Protected Against");
			m_wndProps.AddItem(9000, 9001, "Blindness", PROPT_BOOLEAN, 0, pProps[0x06] & 0x01);
			m_wndProps.AddItem(9000, 9002, "Zombie", PROPT_BOOLEAN, 0, pProps[0x06] & 0x02);
			m_wndProps.AddItem(9000, 9003, "Poison", PROPT_BOOLEAN, 0, pProps[0x06] & 0x04);
			m_wndProps.AddItem(9000, 9004, "Invisibility", PROPT_BOOLEAN, 0, pProps[0x06] & 0x10);
			m_wndProps.AddItem(9000, 9005, "Imp", PROPT_BOOLEAN, 0, pProps[0x06] & 0x20);
			m_wndProps.AddItem(9000, 9006, "Petrification", PROPT_BOOLEAN, 0, pProps[0x06] & 0x40);
			m_wndProps.AddItem(9000, 9007, "Mortal Attacks", PROPT_BOOLEAN, 0, pProps[0x06] & 0x80);
			// 9008 intentionally left out for synchronization with below.
			m_wndProps.AddItem(9000, 9009, "Condemned", PROPT_BOOLEAN, 0, pProps[0x07] & 0x01);
			m_wndProps.AddItem(9000, 9010, "Kneeling", PROPT_BOOLEAN, 0, pProps[0x07] & 0x02);
			m_wndProps.AddItem(9000, 9011, "Blink", PROPT_BOOLEAN, 0, pProps[0x07] & 0x04);
			m_wndProps.AddItem(9000, 9012, "Silence", PROPT_BOOLEAN, 0, pProps[0x07] & 0x08);
			m_wndProps.AddItem(9000, 9013, "Berserk", PROPT_BOOLEAN, 0, pProps[0x07] & 0x10);
			m_wndProps.AddItem(9000, 9014, "Confusion", PROPT_BOOLEAN, 0, pProps[0x07] & 0x20);
			m_wndProps.AddItem(9000, 9015, "HP Drain", PROPT_BOOLEAN, 0, pProps[0x07] & 0x40);
			m_wndProps.AddItem(9000, 9016, "Sleep", PROPT_BOOLEAN, 0, pProps[0x07] & 0x80);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		m_wndProps.AddGroup(9100, "Status Conditions Inflicted while Equipped");
			
			m_wndProps.AddItem(9100, 9101, "Floating", PROPT_BOOLEAN, 0, pProps[0x08] & 0x01);
			m_wndProps.AddItem(9100, 9102, "Regeneration", PROPT_BOOLEAN, 0, pProps[0x08] & 0x02);
			m_wndProps.AddItem(9100, 9103, "Slow", PROPT_BOOLEAN, 0, pProps[0x08] & 0x04);
			m_wndProps.AddItem(9100, 9104, "Haste", PROPT_BOOLEAN, 0, pProps[0x08] & 0x08);
			m_wndProps.AddItem(9100, 9105, "Stop", PROPT_BOOLEAN, 0, pProps[0x08] & 0x10);
			m_wndProps.AddItem(9100, 9106, "Shell", PROPT_BOOLEAN, 0, pProps[0x08] & 0x20);
			m_wndProps.AddItem(9100, 9107, "Safe", PROPT_BOOLEAN, 0, pProps[0x08] & 0x40);
			m_wndProps.AddItem(9100, 9108, "Reflect", PROPT_BOOLEAN, 0, pProps[0x08] & 0x80);
			
			if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
			{
				m_wndProps.AddItem(9100, 9109, "Condemned", PROPT_BOOLEAN, 0, pProps[0x19] & 0x01);
				m_wndProps.AddItem(9100, 9110, "Kneeling", PROPT_BOOLEAN, 0, pProps[0x19] & 0x02);
				m_wndProps.AddItem(9100, 9111, "Blink", PROPT_BOOLEAN, 0, pProps[0x19] & 0x04);
				m_wndProps.AddItem(9100, 9112, "Silence", PROPT_BOOLEAN, 0, pProps[0x19] & 0x08);
				m_wndProps.AddItem(9100, 9113, "Berserk", PROPT_BOOLEAN, 0, pProps[0x19] & 0x10);
				m_wndProps.AddItem(9100, 9114, "Confusion", PROPT_BOOLEAN, 0, pProps[0x19] & 0x20);
				m_wndProps.AddItem(9100, 9115, "HP Drain", PROPT_BOOLEAN, 0, pProps[0x19] & 0x40);
				m_wndProps.AddItem(9100, 9116, "Sleep", PROPT_BOOLEAN, 0, pProps[0x19] & 0x80);
			}
	}

	if((pProps[0] & 0x0F) == 0x06)
	{
		m_wndProps.AddGroup(9200, "Status Conditions Affected when Used");
			m_wndProps.AddItem(9200, 9201, "Blindness", PROPT_BOOLEAN, 0, pProps[0x15] & 0x01);
			m_wndProps.AddItem(9200, 9202, "Zombie", PROPT_BOOLEAN, 0, pProps[0x15] & 0x02);
			m_wndProps.AddItem(9200, 9203, "Poison", PROPT_BOOLEAN, 0, pProps[0x15] & 0x04);
			m_wndProps.AddItem(9200, 9204, "Invisibility", PROPT_BOOLEAN, 0, pProps[0x15] & 0x10);
			m_wndProps.AddItem(9200, 9205, "Imp", PROPT_BOOLEAN, 0, pProps[0x15] & 0x20);
			m_wndProps.AddItem(9200, 9206, "Petrification", PROPT_BOOLEAN, 0, pProps[0x15] & 0x40);
			m_wndProps.AddItem(9200, 9207, "Death", PROPT_BOOLEAN, 0, pProps[0x15] & 0x80);
			m_wndProps.AddItem(9200, 9208, "Condemned", PROPT_BOOLEAN, 0, pProps[0x16] & 0x01);
			m_wndProps.AddItem(9200, 9209, "Kneeling", PROPT_BOOLEAN, 0, pProps[0x16] & 0x02);
			m_wndProps.AddItem(9200, 9210, "Blink", PROPT_BOOLEAN, 0, pProps[0x16] & 0x04);
			m_wndProps.AddItem(9200, 9211, "Silence", PROPT_BOOLEAN, 0, pProps[0x16] & 0x08);
			m_wndProps.AddItem(9200, 9212, "Berserk", PROPT_BOOLEAN, 0, pProps[0x16] & 0x10);
			m_wndProps.AddItem(9200, 9213, "Confusion", PROPT_BOOLEAN, 0, pProps[0x16] & 0x20);
			m_wndProps.AddItem(9200, 9214, "HP Drain", PROPT_BOOLEAN, 0, pProps[0x16] & 0x40);
			m_wndProps.AddItem(9200, 9215, "Sleep", PROPT_BOOLEAN, 0, pProps[0x16] & 0x80);
			m_wndProps.AddItem(9200, 9216, "Dance", PROPT_BOOLEAN, 0, pProps[0x17] & 0x01);
			m_wndProps.AddItem(9200, 9217, "Regenerate", PROPT_BOOLEAN, 0, pProps[0x17] & 0x02);
			m_wndProps.AddItem(9200, 9218, "Slow", PROPT_BOOLEAN, 0, pProps[0x17] & 0x04);
			m_wndProps.AddItem(9200, 9219, "Haste", PROPT_BOOLEAN, 0, pProps[0x17] & 0x08);
			m_wndProps.AddItem(9200, 9220, "Stop", PROPT_BOOLEAN, 0, pProps[0x17] & 0x10);
			m_wndProps.AddItem(9200, 9221, "Shell", PROPT_BOOLEAN, 0, pProps[0x17] & 0x20);
			m_wndProps.AddItem(9200, 9222, "Safe", PROPT_BOOLEAN, 0, pProps[0x17] & 0x40);
			m_wndProps.AddItem(9200, 9223, "Reflect", PROPT_BOOLEAN, 0, pProps[0x17] & 0x80);
			m_wndProps.AddItem(9200, 9224, "Rage", PROPT_BOOLEAN, 0, pProps[0x18] & 0x01);
			m_wndProps.AddItem(9200, 9225, "Frozen", PROPT_BOOLEAN, 0, pProps[0x18] & 0x02);
			m_wndProps.AddItem(9200, 9226, "Prevent Death Once", PROPT_BOOLEAN, 0, pProps[0x18] & 0x04);
			m_wndProps.AddItem(9200, 9227, "Morph into Esper", PROPT_BOOLEAN, 0, pProps[0x18] & 0x08);
			m_wndProps.AddItem(9200, 9228, "Casting Spell Stance", PROPT_BOOLEAN, 0, pProps[0x18] & 0x10);
			m_wndProps.AddItem(9200, 9229, "Removed from Battle", PROPT_BOOLEAN, 0, pProps[0x18] & 0x20);
			m_wndProps.AddItem(9200, 9230, "Randomly defended by Interceptor", PROPT_BOOLEAN, 0, pProps[0x18] & 0x40);
			m_wndProps.AddItem(9200, 9231, "Floating", PROPT_BOOLEAN, 0, pProps[0x18] & 0x80);
	}

	m_wndProps.AddGroup(3000, "Magic-Related Properties");

		if(pProps[0] & 0x0F != 0x06)
			m_wndProps.AddItem(3000, 3001, "Special attack when used as an item", PROPT_FF3COMBO, 7, (LPARAM)&m_magicArray, pProps[0x12] & 0x3F);

		if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
		{
			m_wndProps.AddItem(3000, 3002, "Spell learned from item", PROPT_FF3COMBO, 7, (LPARAM)&m_magicArray, pProps[0x04]);
			m_wndProps.AddItem(3000, 3003, "Spell learn rate (in percent)", PROPT_NUMEDIT, 0, pProps[3]);
		}

	if((pProps[0] & 0x0F) == 0x01)
	{
		m_wndProps.AddGroup(4000, "Elemental Properties");
			m_wndProps.AddItem(4000, 4001, "Fire", PROPT_BOOLEAN, 0, pProps[0xF] & 0x01);
			m_wndProps.AddItem(4000, 4002, "Ice", PROPT_BOOLEAN, 0, pProps[0xF] & 0x02);
			m_wndProps.AddItem(4000, 4003, "Lightning", PROPT_BOOLEAN, 0, pProps[0xF] & 0x04);
			m_wndProps.AddItem(4000, 4004, "Poison", PROPT_BOOLEAN, 0, pProps[0xF] & 0x08);
			m_wndProps.AddItem(4000, 4005, "Wind", PROPT_BOOLEAN, 0, pProps[0xF] & 0x10);
			m_wndProps.AddItem(4000, 4006, "Holy", PROPT_BOOLEAN, 0, pProps[0xF] & 0x20);
			m_wndProps.AddItem(4000, 4007, "Earth", PROPT_BOOLEAN, 0, pProps[0xF] & 0x40);
			m_wndProps.AddItem(4000, 4008, "Water", PROPT_BOOLEAN, 0, pProps[0xF] & 0x80);
	}

	if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
	{
		m_wndProps.AddGroup(4000, "Elements that Cause 50% Damage");
			m_wndProps.AddItem(4000, 4001, "Fire", PROPT_BOOLEAN, 0, pProps[0xF] & 0x01);
			m_wndProps.AddItem(4000, 4002, "Ice", PROPT_BOOLEAN, 0, pProps[0xF] & 0x02);
			m_wndProps.AddItem(4000, 4003, "Lightning", PROPT_BOOLEAN, 0, pProps[0xF] & 0x04);
			m_wndProps.AddItem(4000, 4004, "Poison", PROPT_BOOLEAN, 0, pProps[0xF] & 0x08);
			m_wndProps.AddItem(4000, 4005, "Wind", PROPT_BOOLEAN, 0, pProps[0xF] & 0x10);
			m_wndProps.AddItem(4000, 4006, "Holy", PROPT_BOOLEAN, 0, pProps[0xF] & 0x20);
			m_wndProps.AddItem(4000, 4007, "Earth", PROPT_BOOLEAN, 0, pProps[0xF] & 0x40);
			m_wndProps.AddItem(4000, 4008, "Water", PROPT_BOOLEAN, 0, pProps[0xF] & 0x80);
		m_wndProps.AddGroup(4100, "Elements that are Absorbed");
			m_wndProps.AddItem(4100, 4101, "Fire", PROPT_BOOLEAN, 0, pProps[0x16] & 0x01);
			m_wndProps.AddItem(4100, 4102, "Ice", PROPT_BOOLEAN, 0, pProps[0x16] & 0x02);
			m_wndProps.AddItem(4100, 4103, "Lightning", PROPT_BOOLEAN, 0, pProps[0x16] & 0x04);
			m_wndProps.AddItem(4100, 4104, "Poison", PROPT_BOOLEAN, 0, pProps[0x16] & 0x08);
			m_wndProps.AddItem(4100, 4105, "Wind", PROPT_BOOLEAN, 0, pProps[0x16] & 0x10);
			m_wndProps.AddItem(4100, 4106, "Holy", PROPT_BOOLEAN, 0, pProps[0x16] & 0x20);
			m_wndProps.AddItem(4100, 4107, "Earth", PROPT_BOOLEAN, 0, pProps[0x16] & 0x40);
			m_wndProps.AddItem(4100, 4108, "Water", PROPT_BOOLEAN, 0, pProps[0x16] & 0x80);
		m_wndProps.AddGroup(4200, "Elements that have No Effect");
			m_wndProps.AddItem(4200, 4201, "Fire", PROPT_BOOLEAN, 0, pProps[0x17] & 0x01);
			m_wndProps.AddItem(4200, 4202, "Ice", PROPT_BOOLEAN, 0, pProps[0x17] & 0x02);
			m_wndProps.AddItem(4200, 4203, "Lightning", PROPT_BOOLEAN, 0, pProps[0x17] & 0x04);
			m_wndProps.AddItem(4200, 4204, "Poison", PROPT_BOOLEAN, 0, pProps[0x17] & 0x08);
			m_wndProps.AddItem(4200, 4205, "Wind", PROPT_BOOLEAN, 0, pProps[0x17] & 0x10);
			m_wndProps.AddItem(4200, 4206, "Holy", PROPT_BOOLEAN, 0, pProps[0x17] & 0x20);
			m_wndProps.AddItem(4200, 4207, "Earth", PROPT_BOOLEAN, 0, pProps[0x17] & 0x40);
			m_wndProps.AddItem(4200, 4208, "Water", PROPT_BOOLEAN, 0, pProps[0x17] & 0x80);
		m_wndProps.AddGroup(4300, "Elements that are Weak Points");
			m_wndProps.AddItem(4300, 4301, "Fire", PROPT_BOOLEAN, 0, pProps[0x18] & 0x01);
			m_wndProps.AddItem(4300, 4302, "Ice", PROPT_BOOLEAN, 0, pProps[0x18] & 0x02);
			m_wndProps.AddItem(4300, 4303, "Lightning", PROPT_BOOLEAN, 0, pProps[0x18] & 0x04);
			m_wndProps.AddItem(4300, 4304, "Poison", PROPT_BOOLEAN, 0, pProps[0x18] & 0x08);
			m_wndProps.AddItem(4300, 4305, "Wind", PROPT_BOOLEAN, 0, pProps[0x18] & 0x10);
			m_wndProps.AddItem(4300, 4306, "Holy", PROPT_BOOLEAN, 0, pProps[0x18] & 0x20);
			m_wndProps.AddItem(4300, 4307, "Earth", PROPT_BOOLEAN, 0, pProps[0x18] & 0x40);
			m_wndProps.AddItem(4300, 4308, "Water", PROPT_BOOLEAN, 0, pProps[0x18] & 0x80);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		m_wndProps.AddGroup(5000, "Field Effects when Equipped");
			m_wndProps.AddItem(5000, 5001, "Reduce enemy encounters", PROPT_BOOLEAN, 0, pProps[0x5] & 0x01);
			m_wndProps.AddItem(5000, 5002, "Prevent enemy encounters", PROPT_BOOLEAN, 0, pProps[0x5] & 0x02);
			m_wndProps.AddItem(5000, 5003, "Characters walk at 2x speed", PROPT_BOOLEAN, 0, pProps[0x5] & 0x20);
			m_wndProps.AddItem(5000, 5004, "Characters gain HP each step (?)", PROPT_BOOLEAN, 0, pProps[0x5] & 0x80);
	}

	// Re-expand the nodes by expanded them all and then closing the ones
	// that should remain closed.
	m_wndProps.ExpandAll();

	UINT nID;  BOOL bExpand;
	POSITION pos = m_expanded.GetStartPosition(); 
	while(pos != NULL)
	{
		m_expanded.GetNextAssoc(pos, nID, bExpand);

		if(bExpand == FALSE)
			m_wndProps.Expand(m_wndProps.IndexToItem(nID), TVE_COLLAPSE);
	}

	m_wndProps.SetRedraw(TRUE);
	m_wndProps.Invalidate();
}

void CItemEditView::OnSelChangeItemList() 
{
	UpdateTree();
}

void CItemEditView::OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nSel = m_wndList.GetCurSel();

	NMPROPTREE* pNMPropTree = (NMPROPTREE*)pNMHDR;
	LPPROPERTYNODE node = pNMPropTree->node;

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	BYTE* pProps = pDoc->items[nSel].props;

	BYTE bItemProp = pProps[0];

	if(node->id == 1001)
	{
		CRect rect;
		m_wndList.GetItemRect(nSel, &rect);
		m_wndList.InvalidateRect(&rect);
	}
	else if(node->id == 1002) bItemProp = (bItemProp & ~0x0F) | node->lData2;
	else if(node->id == 1003) bItemProp = (bItemProp & ~0x10) | (node->lData ? 0x10 : 0);
	else if(node->id == 1004) bItemProp = (bItemProp & ~0x20) | (node->lData ? 0x20 : 0);
	else if(node->id == 1005) bItemProp = (bItemProp & ~0x40) | (node->lData ? 0x40 : 0);

	if((bItemProp & 0x0F) != (pProps[0] & 0x0F))
	{
		pProps[0] = bItemProp;
		UpdateTree();
	}
	else
		pProps[0] = bItemProp;

	if(node->id == 1006)
	{
		pProps[0x1C] = LOBYTE((WORD)node->lData);
		pProps[0x1D] = HIBYTE((WORD)node->lData);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id >= 101 && node->id <= 108)
			pProps[1] = pProps[1] & ~(1 << (node->id - 101)) | (node->lData ? (1 << (node->id - 101)) : 0);

		if(node->id >= 109 && node->id <= 116)
			pProps[2] = pProps[2] & ~(1 << (node->id - 109)) | (node->lData ? (1 << (node->id - 109)) : 0);
	}

	if(node->id == 2001) pProps[0x0E] = pProps[0x0E] & ~0x01 | (node->lData ? 0x01 : 0);
	if(node->id == 2002) pProps[0x0E] = pProps[0x0E] & ~0x02 | (node->lData ? 0x02 : 0);
	if(node->id == 2003) pProps[0x0E] = pProps[0x0E] & ~0x04 | (node->lData ? 0x04 : 0);
	if(node->id == 2004) pProps[0x0E] = pProps[0x0E] & ~0x08 | (node->lData ? 0x08 : 0);
	if(node->id == 2005) pProps[0x0E] = pProps[0x0E] & ~0x10 | (node->lData ? 0x10 : 0);
	if(node->id == 2006) pProps[0x0E] = pProps[0x0E] & ~0x20 | (node->lData ? 0x20 : 0);
	if(node->id == 2007) pProps[0x0E] = pProps[0x0E] & ~0x40 | (node->lData ? 0x40 : 0);
	if(node->id == 2008) pProps[0x0E] = pProps[0x0E] & ~0x80 | (node->lData ? 0x80 : 0);

	if((pProps[0] & 0x0F) == 0x01)
	{
		if(node->id == 201) pProps[0x13] = pProps[0x13] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 202) pProps[0x13] = pProps[0x13] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 203) pProps[0x13] = pProps[0x13] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 204) pProps[0x13] = pProps[0x13] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 205) pProps[0x1B] = pProps[0x1B] & ~0xF0 | (node->lData2 << 4);
		else if(node->id == 206) pProps[0x1B] = pProps[0x1B] & ~0x0F | (node->lData);
	}
	else if((pProps[0] & 0x0F) == 0x06)
	{
		if(node->id == 201) pProps[0x13] = pProps[0x13] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 202) pProps[0x13] = pProps[0x13] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 203) pProps[0x13] = pProps[0x13] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 204) pProps[0x13] = pProps[0x13] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 205) pProps[0x13] = pProps[0x13] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 206) pProps[0x13] = (node->lData2 ? node->lData2 : 0xFF);
		else if(node->id == 207) pProps[0x13] = pProps[0x13] & ~0x02 | (node->lData ? 0x02 : 0);
	}

	if((pProps[0] & 0x0F) == 0x00)
	{
		if(node->id == 6001) pProps[0x14] = node->lData;
		else if(node->id == 6002) pProps[0x15] = node->lData;
	}
	else if((pProps[0] & 0x0F) == 0x01)
	{
		if(node->id == 6001) pProps[0x14] = node->lData;
		else if(node->id == 6002) pProps[0x15] = node->lData;
		else if(node->id == 6003) pProps[0x10] = pProps[0x10] & ~0x0F | node->lData2;
		else if(node->id == 6004) pProps[0x10] = pProps[0x10] & ~0xF0 | (node->lData2 << 4);
		else if(node->id == 6005) pProps[0x11] = pProps[0x11] & ~0x0F | node->lData2;
		else if(node->id == 6006) pProps[0x11] = pProps[0x11] & ~0xF0 | (node->lData2 << 4);
		else if(node->id == 6007) pProps[0x1A] = pProps[0x1A] & ~0x0F | node->lData2;
		else if(node->id == 6008) pProps[0x1A] = pProps[0x1A] & ~0xF0 | (node->lData2 << 4);
	}
	else if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 6001) pProps[0x14] = node->lData;
		else if(node->id == 6002) pProps[0x15] = node->lData;
		else if(node->id == 6003) pProps[0x10] = pProps[0x10] & ~0x0F | node->lData2;
		else if(node->id == 6004) pProps[0x10] = pProps[0x10] & ~0xF0 | (node->lData2 << 4);
		else if(node->id == 6005) pProps[0x11] = pProps[0x11] & ~0x0F | node->lData2;
		else if(node->id == 6006) pProps[0x11] = pProps[0x11] & ~0xF0 | (node->lData2 << 4);
		else if(node->id == 6007) pProps[0x1A] = pProps[0x1A] & ~0x0F | node->lData2;
		else if(node->id == 6008) pProps[0x1A] = pProps[0x1A] & ~0xF0 | (node->lData2 << 4);
	}
	else if((pProps[0] & 0x0F) == 0x06)
	{
		if(node->id == 6001) pProps[0x14] = node->lData;
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 7001) pProps[0x09] = pProps[0x09] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 7002) pProps[0x09] = pProps[0x09] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 7003) pProps[0x09] = pProps[0x09] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 7004) pProps[0x09] = pProps[0x09] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 7005) pProps[0x09] = pProps[0x09] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 7006) pProps[0x09] = pProps[0x09] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 7007) pProps[0x09] = pProps[0x09] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 7008) pProps[0x09] = pProps[0x09] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 7009) pProps[0x0B] = pProps[0x0B] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 7010) pProps[0x0B] = pProps[0x0B] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 7011) pProps[0x0B] = pProps[0x0B] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 7012) pProps[0x0B] = pProps[0x0B] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 7013) pProps[0x0B] = pProps[0x0B] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 8001) pProps[0x0A] = pProps[0x0A] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 8002) pProps[0x0A] = pProps[0x0A] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 8003) pProps[0x0A] = pProps[0x0A] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 8004) pProps[0x0A] = pProps[0x0A] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 8005) pProps[0x0A] = pProps[0x0A] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 8006) pProps[0x0A] = pProps[0x0A] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 8007) pProps[0x0C] = pProps[0x0C] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 8008) pProps[0x0C] = pProps[0x0C] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 8009) pProps[0x0C] = pProps[0x0C] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 8010) pProps[0x0C] = pProps[0x0C] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 8011) pProps[0x0C] = pProps[0x0C] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 8012) pProps[0x0C] = pProps[0x0C] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 8013) pProps[0x0C] = pProps[0x0C] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 8014) pProps[0x0C] = pProps[0x0C] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 8015) pProps[0x0D] = pProps[0x0D] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 8016) pProps[0x0D] = pProps[0x0D] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 8017) pProps[0x0D] = pProps[0x0D] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 8018) pProps[0x0D] = pProps[0x0D] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 8019) pProps[0x0D] = pProps[0x0D] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 9001) pProps[0x06] = pProps[0x06] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9002) pProps[0x06] = pProps[0x06] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9003) pProps[0x06] = pProps[0x06] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9004) pProps[0x06] = pProps[0x06] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9005) pProps[0x06] = pProps[0x06] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9006) pProps[0x06] = pProps[0x06] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9007) pProps[0x06] = pProps[0x06] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 9009) pProps[0x07] = pProps[0x07] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9010) pProps[0x07] = pProps[0x07] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9011) pProps[0x07] = pProps[0x07] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9012) pProps[0x07] = pProps[0x07] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 9013) pProps[0x07] = pProps[0x07] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9014) pProps[0x07] = pProps[0x07] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9015) pProps[0x07] = pProps[0x07] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9016) pProps[0x07] = pProps[0x07] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 9101) pProps[0x08] = pProps[0x08] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9102) pProps[0x08] = pProps[0x08] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9103) pProps[0x08] = pProps[0x08] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9104) pProps[0x08] = pProps[0x08] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 9105) pProps[0x08] = pProps[0x08] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9106) pProps[0x08] = pProps[0x08] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9107) pProps[0x08] = pProps[0x08] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9108) pProps[0x08] = pProps[0x08] & ~0x80 | (node->lData ? 0x80 : 0);

		if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
		{
			if(node->id == 9109) pProps[0x19] = pProps[0x19] & ~0x01 | (node->lData ? 0x01 : 0);
			else if(node->id == 9110) pProps[0x19] = pProps[0x19] & ~0x02 | (node->lData ? 0x02 : 0);
			else if(node->id == 9111) pProps[0x19] = pProps[0x19] & ~0x04 | (node->lData ? 0x04 : 0);
			else if(node->id == 9112) pProps[0x19] = pProps[0x19] & ~0x08 | (node->lData ? 0x08 : 0);
			else if(node->id == 9113) pProps[0x19] = pProps[0x19] & ~0x10 | (node->lData ? 0x10 : 0);
			else if(node->id == 9114) pProps[0x19] = pProps[0x19] & ~0x20 | (node->lData ? 0x20 : 0);
			else if(node->id == 9115) pProps[0x19] = pProps[0x19] & ~0x40 | (node->lData ? 0x40 : 0);
			else if(node->id == 9116) pProps[0x19] = pProps[0x19] & ~0x80 | (node->lData ? 0x80 : 0);
		}
	}

	if((pProps[0] & 0x0F) == 0x06)
	{
		if(node->id == 9201) pProps[0x15] = pProps[0x15] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9202) pProps[0x15] = pProps[0x15] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9203) pProps[0x15] = pProps[0x15] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9204) pProps[0x15] = pProps[0x15] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9205) pProps[0x15] = pProps[0x15] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9206) pProps[0x15] = pProps[0x15] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9207) pProps[0x15] = pProps[0x15] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 9208) pProps[0x16] = pProps[0x16] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9209) pProps[0x16] = pProps[0x16] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9210) pProps[0x16] = pProps[0x16] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9211) pProps[0x16] = pProps[0x16] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 9212) pProps[0x16] = pProps[0x16] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9213) pProps[0x16] = pProps[0x16] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9214) pProps[0x16] = pProps[0x16] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9215) pProps[0x16] = pProps[0x16] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 9216) pProps[0x17] = pProps[0x17] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9217) pProps[0x17] = pProps[0x17] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9218) pProps[0x17] = pProps[0x17] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9219) pProps[0x17] = pProps[0x17] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 9220) pProps[0x17] = pProps[0x17] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9221) pProps[0x17] = pProps[0x17] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9222) pProps[0x17] = pProps[0x17] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9223) pProps[0x17] = pProps[0x17] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 9224) pProps[0x18] = pProps[0x18] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 9225) pProps[0x18] = pProps[0x18] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 9226) pProps[0x18] = pProps[0x18] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 9227) pProps[0x18] = pProps[0x18] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 9228) pProps[0x18] = pProps[0x18] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 9229) pProps[0x18] = pProps[0x18] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 9230) pProps[0x18] = pProps[0x18] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 9231) pProps[0x18] = pProps[0x18] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	if(pProps[0] & 0x0F != 0x06)
		if(node->id == 3001) pProps[0x12] = node->lData2;

	if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 3002) pProps[0x04] = node->lData2;
		if(node->id == 3003) pProps[0x03] = node->lData;
	}

	if((pProps[0] & 0x0F) == 0x01)
	{
		if(node->id == 4001) pProps[0x0F] = pProps[0x0F] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 4002) pProps[0x0F] = pProps[0x0F] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 4003) pProps[0x0F] = pProps[0x0F] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 4004) pProps[0x0F] = pProps[0x0F] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 4005) pProps[0x0F] = pProps[0x0F] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 4006) pProps[0x0F] = pProps[0x0F] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 4007) pProps[0x0F] = pProps[0x0F] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 4008) pProps[0x0F] = pProps[0x0F] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	if((pProps[0] & 0x0F) > 0x01 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 4001) pProps[0x0F] = pProps[0x0F] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 4002) pProps[0x0F] = pProps[0x0F] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 4003) pProps[0x0F] = pProps[0x0F] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 4004) pProps[0x0F] = pProps[0x0F] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 4005) pProps[0x0F] = pProps[0x0F] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 4006) pProps[0x0F] = pProps[0x0F] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 4007) pProps[0x0F] = pProps[0x0F] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 4008) pProps[0x0F] = pProps[0x0F] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 4101) pProps[0x16] = pProps[0x16] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 4102) pProps[0x16] = pProps[0x16] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 4103) pProps[0x16] = pProps[0x16] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 4104) pProps[0x16] = pProps[0x16] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 4105) pProps[0x16] = pProps[0x16] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 4106) pProps[0x16] = pProps[0x16] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 4107) pProps[0x16] = pProps[0x16] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 4108) pProps[0x16] = pProps[0x16] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 4201) pProps[0x17] = pProps[0x17] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 4202) pProps[0x17] = pProps[0x17] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 4203) pProps[0x17] = pProps[0x17] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 4204) pProps[0x17] = pProps[0x17] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 4205) pProps[0x17] = pProps[0x17] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 4206) pProps[0x17] = pProps[0x17] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 4207) pProps[0x17] = pProps[0x17] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 4208) pProps[0x17] = pProps[0x17] & ~0x80 | (node->lData ? 0x80 : 0);
		else if(node->id == 4301) pProps[0x18] = pProps[0x18] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 4302) pProps[0x18] = pProps[0x18] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 4303) pProps[0x18] = pProps[0x18] & ~0x04 | (node->lData ? 0x04 : 0);
		else if(node->id == 4304) pProps[0x18] = pProps[0x18] & ~0x08 | (node->lData ? 0x08 : 0);
		else if(node->id == 4305) pProps[0x18] = pProps[0x18] & ~0x10 | (node->lData ? 0x10 : 0);
		else if(node->id == 4306) pProps[0x18] = pProps[0x18] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 4307) pProps[0x18] = pProps[0x18] & ~0x40 | (node->lData ? 0x40 : 0);
		else if(node->id == 4308) pProps[0x18] = pProps[0x18] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	if((pProps[0] & 0x0F) > 0x00 && (pProps[0] & 0x0F) < 0x06)
	{
		if(node->id == 5001) pProps[0x05] = pProps[0x05] & ~0x01 | (node->lData ? 0x01 : 0);
		else if(node->id == 5002) pProps[0x05] = pProps[0x05] & ~0x02 | (node->lData ? 0x02 : 0);
		else if(node->id == 5003) pProps[0x05] = pProps[0x05] & ~0x20 | (node->lData ? 0x20 : 0);
		else if(node->id == 5004) pProps[0x05] = pProps[0x05] & ~0x80 | (node->lData ? 0x80 : 0);
	}

	*pResult = 0;
}
