// MapTriggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "MapTriggerDlg.h"
#include "MapView.h"

#include "PropFontSheet.h"
#include "EntranceTriggerPage.h"
#include "EventTriggerPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapTriggerDlg dialog


CMapTriggerDlg::CMapTriggerDlg(CWnd* pParent /*=NULL*/)
	: cdxCSizingDialog(CMapTriggerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapTriggerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMapTriggerDlg::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapTriggerDlg)
	DDX_Control(pDX, IDC_DELETEALLTRIGGERS, m_wndDeleteAllTriggers);
	DDX_Control(pDX, IDC_DELETETRIGGER, m_wndDeleteTrigger);
	DDX_Control(pDX, IDC_EDITTRIGGER, m_wndEditTrigger);
	DDX_Control(pDX, IDC_ADDTRIGGER, m_wndAddTrigger);
	DDX_Control(pDX, IDC_GOTODESTINATION, m_wndGotoDestination);
	DDX_Control(pDX, IDC_GOTOTRIGGER, m_wndGotoTrigger);
	DDX_Control(pDX, IDC_TRIGGERLIST, m_wndTriggerList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapTriggerDlg, cdxCSizingDialog)
	//{{AFX_MSG_MAP(CMapTriggerDlg)
	ON_BN_CLICKED(IDC_GOTOTRIGGER, OnGotoTrigger)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_TRIGGERLIST, OnChangedTriggerList)
	ON_NOTIFY(NM_DBLCLK, IDC_TRIGGERLIST, OnEditTriggerDblClk)
	ON_BN_CLICKED(IDC_EDITTRIGGER, OnEditTrigger)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_TRIGGERADD_ENTRANCE, OnAddEntranceTrigger)
	ON_COMMAND(ID_TRIGGERADD_EVENT, OnAddEventTrigger)
	ON_BN_CLICKED(IDC_DELETETRIGGER, OnDeleteTrigger)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapTriggerDlg message handlers

BOOL CMapTriggerDlg::OnInitDialog() 
{
	cdxCSizingDialog::OnInitDialog();
	
	AddSzControl(m_wndTriggerList, mdResize, mdResize);
	AddSzControl(m_wndGotoTrigger, mdNone, mdRepos);
	AddSzControl(m_wndGotoDestination, mdNone, mdRepos);
	AddSzControl(m_wndAddTrigger, mdNone, mdRepos);
	AddSzControl(m_wndEditTrigger, mdNone, mdRepos);
	AddSzControl(m_wndDeleteTrigger, mdNone, mdRepos);
	AddSzControl(m_wndDeleteAllTriggers, mdNone, mdRepos);

	m_wndAddTrigger.SetMenuID(IDR_BUTTONMENUS, 2);

	m_wndTriggerList.SetExtendedStyle(LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT);

	m_wndTriggerList.InsertColumn(0, _T("Source Pos."), LVCFMT_LEFT, 73, 0);
	m_wndTriggerList.InsertColumn(1, _T("Destination"), LVCFMT_LEFT, 73, 1);
	m_wndTriggerList.InsertColumn(2, _T("Dest. Pos."), LVCFMT_LEFT, 73, 2);
	m_wndTriggerList.InsertColumn(3, _T("Facing"), LVCFMT_LEFT, 43, 3);
	m_wndTriggerList.InsertColumn(4, _T("Show Name"), LVCFMT_LEFT, 68, 4);

	SetWindowPos(NULL, Settings.wsTriggerWnd.rect.left, Settings.wsTriggerWnd.rect.top,
		Settings.wsTriggerWnd.rect.right - Settings.wsTriggerWnd.rect.left,
		Settings.wsTriggerWnd.rect.bottom - Settings.wsTriggerWnd.rect.top,
		(Settings.wsTriggerWnd.bVisible ? SWP_SHOWWINDOW : SWP_HIDEWINDOW) | SWP_NOZORDER);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMapTriggerDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
}

void CMapTriggerDlg::OnGotoTrigger() 
{
	POSITION pos = m_wndTriggerList.GetFirstSelectedItemPosition();
	if(!pos) return;
	int sel = m_wndTriggerList.GetNextSelectedItem(pos);
	Trigger* pTrigger = (Trigger*)m_wndTriggerList.GetItemData(sel);

	CRect rect;  m_pView->GetClientRect(rect);
	int nWidth = rect.Width() / 16;
	int nHeight = rect.Height() / 16;

	((CMapView*)m_pView)->ScrollToPosition(CPoint((pTrigger->srcX - nWidth / 2),
		(pTrigger->srcY - nHeight / 2)));
}

void CMapTriggerDlg::OnChangedTriggerList(NMHDR* pNotifyStruct, LRESULT* result)
{
	NMLISTVIEW* pNMLV = (NMLISTVIEW*)pNotifyStruct;
	*result = 0;

	Trigger* pTrigger = (Trigger*)m_wndTriggerList.GetItemData(pNMLV->iItem);

	if(!pTrigger) return;

	if(m_wndTriggerList.GetCheck(pNMLV->iItem))
		pTrigger->flags |= TRIGGER_MINIMAP;
	else
		pTrigger->flags &= ~TRIGGER_MINIMAP;

	if((pNMLV->uNewState & LVIS_SELECTED) && !(pNMLV->uOldState & LVIS_SELECTED))
		((CMapView*)m_pView)->SetCurrentTrigger(CPoint(pTrigger->srcX, pTrigger->srcY));
}

BOOL CMapTriggerDlg::Create(CView* pView) 
{
	m_pView = pView;
	return CDialog::Create(IDD, pView->GetParentFrame());
}

void CMapTriggerDlg::OnDestroy() 
{
	GetWindowRect(&Settings.wsTriggerWnd.rect);
	Settings.wsTriggerWnd.bVisible = (IsWindowVisible()) ? TRUE : FALSE;

	cdxCSizingDialog::OnDestroy();
}

void CMapTriggerDlg::OnEditTriggerDblClk(NMHDR* pNotifyStruct, LRESULT* result)
{
	*result = 0;
	OnEditTrigger();
}

void CMapTriggerDlg::OnEditTrigger() 
{
	POSITION pos = m_wndTriggerList.GetFirstSelectedItemPosition();
	if(!pos) return;
	int sel = m_wndTriggerList.GetNextSelectedItem(pos);
	Trigger* pTrigger = (Trigger*)m_wndTriggerList.GetItemData(sel);

	if(pTrigger->type == triggerEntrance)
	{
		EntranceTrigger* pEntr = (EntranceTrigger*)pTrigger;

		CPropFontSheet sheet(_T("Trigger Properties"), this);
		CEntranceTriggerPage page1;
		sheet.AddPage(&page1);
		sheet.m_psh.dwFlags |= PSH_NOAPPLYNOW;

		page1.m_nSourceX = pEntr->srcX;
		page1.m_nSourceY = pEntr->srcY;
		page1.m_nDestX = pEntr->destX;
		page1.m_nDestY = pEntr->destY;
		page1.m_nDestination = (pEntr->destination & 0x1FF);
		page1.m_nFacing = (pEntr->destination & 0x3000) >> 12;
		page1.m_nShowName = (pEntr->destination & 0x800) ? 1 : 0;

		if(sheet.DoModal() == IDOK)
		{
			pEntr->srcX = page1.m_nSourceX;
			pEntr->srcY = page1.m_nSourceY;
			pEntr->destX = page1.m_nDestX;
			pEntr->destY = page1.m_nDestY;
			pEntr->destination = (page1.m_nDestination) |
				(page1.m_nFacing << 12) | (page1.m_nShowName ? 0x800 : 0);
		}

		CString s;  s.Format("(%d, %d)", pEntr->srcX, pEntr->srcY);
		m_wndTriggerList.SetItemText(sel, 0, s);

		s.Format("$%03X", pEntr->destination & 0x1FF);
		m_wndTriggerList.SetItemText(sel, 1, s);

		s.Format("(%d, %d)", pEntr->destX, pEntr->destY);
		m_wndTriggerList.SetItemText(sel, 2, s);

		if((pEntr->destination & 0x3000) == 0x0000)
			s = "Up";
		else if((pEntr->destination & 0x3000) == 0x1000)
			s = "Right";
		else if((pEntr->destination & 0x3000) == 0x2000)
			s = "Down";
		else if((pEntr->destination & 0x3000) == 0x3000)
			s = "Left";

		m_wndTriggerList.SetItemText(sel, 3, s);

		if((pEntr->destination & 0x0800) == 0x0800)
			s = "Yes";
		else
			s = "No";

		m_wndTriggerList.SetItemText(sel, 4, s);
	}
	else if(pTrigger->type == triggerEvent)
	{
		EventTrigger* pEvent = (EventTrigger*)pTrigger;

		CPropFontSheet sheet(_T("Trigger Properties"), this);
		CEventTriggerPage page1;
		sheet.AddPage(&page1);
		sheet.m_psh.dwFlags |= PSH_NOAPPLYNOW;

		page1.m_nSourceX = pEvent->srcX;
		page1.m_nSourceY = pEvent->srcY;
		page1.m_nCode = pEvent->event;

		if(sheet.DoModal() == IDOK)
		{
			pEvent->srcX = page1.m_nSourceX;
			pEvent->srcY = page1.m_nSourceY;
			pEvent->event = page1.m_nCode;
		}

		CString s;  s.Format("(%d, %d)", pEvent->srcX, pEvent->srcY);
		m_wndTriggerList.SetItemText(sel, 0, s);

		s.Format("$%06X", pEvent->event);
		m_wndTriggerList.SetItemText(sel, 1, s);
	}

	m_pView->Invalidate();
	((CMapView*)m_pView)->SetCurrentTrigger(CPoint(pTrigger->srcX, pTrigger->srcY));
}

void CMapTriggerDlg::OnAddEntranceTrigger() 
{
/*	if(m_worldData->entrances.GetSize() == 256)
	{
		AfxMessageBox("You have reached the maximum number\nof allowed triggers (256).",
			MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	Entrance* pEntr = new Entrance;

	CEditTriggerDlg dlg;

	dlg.m_nSourceX = 0;
	dlg.m_nSourceY = 0;
	dlg.m_nDestType = 0;
	dlg.m_nDestination = 0;
	dlg.m_nDestX = 0;
	dlg.m_nDestY = 0;
	dlg.m_nDestEvent = 0;

	if(dlg.DoModal() == IDOK)
	{
		pEntr->srcX = dlg.m_nSourceX;
		pEntr->srcY = dlg.m_nSourceY;

		if(dlg.m_nDestType == 1)
		{
			pEntr->destination = 0xFF;
			pEntr->destX = dlg.m_nDestEvent;
			pEntr->destY = 0;
		}
		else
		{
			pEntr->destination = dlg.m_nDestination;
			pEntr->destX = dlg.m_nDestX;
			pEntr->destY = dlg.m_nDestY;
		}

		int nIndex = m_wndTriggerList.AddString(NULL);
		m_wndTriggerList.SetItemData(nIndex, (DWORD)pEntr);

		m_worldData->entrances.Add(pEntr);
		m_pView->Invalidate();
		((CMapView*)m_pView)->SetCurrentTrigger(CPoint(pEntr->srcX, pEntr->srcY));
	}
	else
	{
		delete pEntr;
	}*/
}

void CMapTriggerDlg::OnAddEventTrigger() 
{
}

void CMapTriggerDlg::OnDeleteTrigger() 
{
/*	int sel = m_wndTriggerList.GetCurSel();
	if(sel == -1) return;

	int res = AfxMessageBox("This operation is permanent and\ncannot be undone.  Continue?",
		MB_OKCANCEL | MB_ICONEXCLAMATION);

	if(res == IDCANCEL) return;

	Entrance* pEntr = (Entrance*)m_wndTriggerList.GetItemData(sel);

	for(int i = 0; i < m_worldData->entrances.GetSize(); i++)
	{
		if(pEntr == m_worldData->entrances[i])
		{
			m_wndTriggerList.DeleteString(i);
			m_worldData->entrances.RemoveAt(i);
			delete pEntr;

			m_pView->Invalidate();
			return;
		}
	}

	AfxMessageBox("The trigger wasn't found--this is bad.\nLet me know if you see this.");*/
}

void CMapTriggerDlg::AddTrigger(Trigger* pTrigger)
{
	CString s;  s.Format("(%d, %d)", pTrigger->srcX, pTrigger->srcY);
	int index = m_wndTriggerList.InsertItem(m_wndTriggerList.GetItemCount(), s);

	if(pTrigger->type == triggerEntrance)
	{
		EntranceTrigger* pEntr = (EntranceTrigger*)pTrigger;

		s.Format("$%03X", pEntr->destination & 0x1FF);
		m_wndTriggerList.SetItemText(index, 1, s);

		s.Format("(%d, %d)", pEntr->destX, pEntr->destY);
		m_wndTriggerList.SetItemText(index, 2, s);

		if((pEntr->destination & 0x3000) == 0x0000)
			s = "Up";
		else if((pEntr->destination & 0x3000) == 0x1000)
			s = "Right";
		else if((pEntr->destination & 0x3000) == 0x2000)
			s = "Down";
		else if((pEntr->destination & 0x3000) == 0x3000)
			s = "Left";

		m_wndTriggerList.SetItemText(index, 3, s);

		if((pEntr->destination & 0x0800) == 0x0800)
			s = "Yes";
		else
			s = "No";

		m_wndTriggerList.SetItemText(index, 4, s);
	}
	else if(pTrigger->type == triggerEvent)
	{
		EventTrigger* pEvent = (EventTrigger*)pTrigger;

		s.Format("$%06X", pEvent->event);
		m_wndTriggerList.SetItemText(index, 1, s);

		m_wndTriggerList.SetItemText(index, 2, NULL);
		m_wndTriggerList.SetItemText(index, 3, NULL);
		m_wndTriggerList.SetItemText(index, 4, NULL);
	}

	m_wndTriggerList.SetCheck(index, (pTrigger->flags & TRIGGER_MINIMAP) ? TRUE : FALSE);
	m_wndTriggerList.SetItemData(index, (DWORD)pTrigger);
}
