// MenuButton.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "MenuButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMenuButton

CMenuButton::CMenuButton()
{
}

CMenuButton::~CMenuButton()
{
}


BEGIN_MESSAGE_MAP(CMenuButton, CButton)
	//{{AFX_MSG_MAP(CMenuButton)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMenuButton message handlers

void CMenuButton::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;
	dc.Attach(lpdis->hDC);
	CRect rect = lpdis->rcItem;

    CPen pen;
    CPen* oldPen = NULL;

    if(lpdis->itemState & ODS_DISABLED)
        pen.CreatePen(PS_SOLID, 0, ::GetSysColor(COLOR_GRAYTEXT));
    else
        pen.CreatePen(PS_SOLID, 0, ::GetSysColor(COLOR_BTNTEXT));

    oldPen = dc.SelectObject(&pen);

    if(lpdis->itemState & ODS_SELECTED)
        dc.DrawFrameControl(rect, DFC_BUTTON, DFCS_BUTTONPUSH | DFCS_PUSHED);
    else
        dc.DrawFrameControl(rect, DFC_BUTTON, DFCS_BUTTONPUSH);

   	CString btnText;  GetWindowText(btnText);
	CSize size = dc.GetTextExtent(btnText);
    
	CRect textRect = CRect((rect.Width() - size.cx) / 2 - 6, 0, rect.Width(), rect.Height());

	CPoint firstSide = CPoint((rect.Width() - size.cx) / 2 + size.cx, rect.top + (rect.Height() / 2) - 1);
	CPoint lastSide = CPoint((rect.Width() - size.cx) / 2 + size.cx + 6, rect.top + (rect.Height() / 2) - 1);
	int arrowSize = 1;

	if(lpdis->itemState & ODS_SELECTED)
	{
		textRect.OffsetRect(1, 1);
		firstSide.Offset(1, 1);
		lastSide.Offset(1, 1);
	}

	dc.DrawText(btnText, textRect, DT_LEFT | DT_VCENTER | DT_SINGLELINE);

	for(;;)
	{
		dc.MoveTo(firstSide);
		dc.LineTo(firstSide + CPoint(0, arrowSize));

		dc.MoveTo(lastSide);
		dc.LineTo(lastSide + CPoint(0, arrowSize));

		firstSide.Offset(1, 0);
		lastSide.Offset(-1, 0);

		if(lastSide.x < firstSide.x) break;

		arrowSize++;
	}

	if(lpdis->itemState & ODS_FOCUS)
    {
        CRect rectFocus(rect);
        rectFocus.DeflateRect(3, 3);
        dc.DrawFocusRect(rectFocus);
    }

	dc.SelectObject(oldPen);

	dc.Detach();	
}

void CMenuButton::SetMenuID(int id, int index)
{
	m_nMenuID = id;
	m_nMenuIndex = index;
}

void CMenuButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CButton::OnLButtonDown(nFlags, point);

	CMenu menu;
	menu.LoadMenu(m_nMenuID);
	CMenu* pMenu = menu.GetSubMenu(m_nMenuIndex);

	CRect rect;  GetWindowRect(rect);
	int x = rect.left;
	int y = rect.bottom;
	int nCmd = pMenu->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RETURNCMD, x, y, this);

	if(nCmd)
		GetParent()->SendMessage(WM_COMMAND, MAKELONG(nCmd, 0), NULL);
}
