// MonsterEditView.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Doc.h"
#include "MonsterEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMonsterEditView

IMPLEMENT_DYNCREATE(CMonsterEditView, CSizingFormView)

CMonsterEditView::CMonsterEditView()
	: CSizingFormView(CMonsterEditView::IDD)
{
	//{{AFX_DATA_INIT(CMonsterEditView)
	//}}AFX_DATA_INIT

	m_bValid = FALSE;
}

CMonsterEditView::~CMonsterEditView()
{
}

void CMonsterEditView::DoDataExchange(CDataExchange* pDX)
{
	CSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonsterEditView)
	DDX_Control(pDX, IDC_LIST, m_wndList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMonsterEditView, CSizingFormView)
	//{{AFX_MSG_MAP(CMonsterEditView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_LBN_SELCHANGE(IDC_LIST, OnSelChangeList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonsterEditView diagnostics

#ifdef _DEBUG
void CMonsterEditView::AssertValid() const
{
	CSizingFormView::AssertValid();
}

void CMonsterEditView::Dump(CDumpContext& dc) const
{
	CSizingFormView::Dump(dc);
}
#endif //_DEBUG

CString g_strConditions[] =
{
	"Dark",
	"Zombie",
	"Poison",
	"Enable Magitek Commands",
	"Vanish",
	"Imp",
	"Petrify",
	"Death",
	"Condemned",
	"Kneeling",
	"Blink",
	"Silence",
	"Berserk",
	"Confusion",
	"HP Drain",
	"Sleep",
	"Float (1)",
	"Regen",
	"Slow",
	"Haste",
	"Stop",
	"Shell",
	"Safe",
	"Reflect",
	"Rage",
	"Frozen",
	"Protection from Death",
	"Morph into Esper",
	"Casting Spell",
	"Removed from Battle",
	"Randomly defended by Interceptor",
	"Float (2)"
};

CString g_strElements[] =
{
	"Fire",
	"Ice",
	"Lightning",
	"Poison",
	"Wind",
	"Pearl/Holy",
	"Earth",
	"Water"
};

/////////////////////////////////////////////////////////////////////////////
// CMonsterEditView message handlers

int CMonsterEditView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CSizingFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetControlInfo(IDC_MINBOUNDS, MINIMUM_BOUND);
	SetControlInfo(IDC_LIST, RESIZE_VERT);
	SetControlInfo(12345, RESIZE_HORZ | RESIZE_VERT);

	return 0;
}

void CMonsterEditView::OnDestroy() 
{
	CSizingFormView::OnDestroy();
	
	delete m_propSheet;
}

void CMonsterEditView::OnInitialUpdate() 
{
	m_propSheet = new CMonsterEditSheet(this);

	m_propSheet->Create(this, WS_CHILD | WS_VISIBLE);
	m_propSheet->SetDlgCtrlID(12345);
	m_propSheet->ModifyStyleEx(0, WS_EX_CONTROLPARENT);

	CRect rect;
	GetDlgItem(IDC_SHEET)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	m_propSheet->MoveWindow(&rect);

	CSizingFormView::OnInitialUpdate();
}

void CMonsterEditView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();

	m_wndList.ResetContent();
	m_wndList.m_pDoc = pDoc;
	m_wndList.m_dwListStyle = FF3LBS_NOCHANGE;

	m_monsterArray.RemoveAll();

	for(int i = 0; i < 384; i++)
		m_monsterArray.Add(pDoc->monsters[i].name);

	m_wndList.m_pArray = &m_monsterArray;

	for(i = 0; i < 384; i++)
		m_wndList.AddItem(i, 10);

	for(i = 0; i < 32; i++)
	{
		m_propSheet->m_statsPage.m_wndConditions.InsertItem(
			m_propSheet->m_statsPage.m_wndConditions.GetItemCount(), g_strConditions[i]);
	}

	for(i = 0; i < 8; i++)
		m_propSheet->m_statsPage.m_wndElements.AddItem(g_strElements[i]);

	m_propSheet->m_statsPage.m_wndName.m_pDoc = pDoc;
	m_propSheet->m_statsPage.m_wndPicture.m_pDoc = pDoc;

	m_bValid = TRUE;

	m_wndList.SetCurSel(0);
	UpdateControls(0);
}


void CMonsterEditView::UpdateControls(int nIndex)
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	Monster* pMonst = &pDoc->monsters[nIndex];

	m_propSheet->m_statsPage.m_wndName.SetText(pMonst->name, 10);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_HP, pMonst->hp);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_MP, pMonst->mp);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_EXP, pMonst->exp);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_GP, pMonst->gold);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_LEVEL, pMonst->level);

	m_propSheet->m_statsPage.SetDlgItemInt(IDC_STRENGTH, pMonst->strength);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_SPEED, pMonst->speed);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_DEFENSE, pMonst->defense);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_HITRATE, pMonst->hitRate);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_EVADERATE, pMonst->evadeRate);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_MAGDEF, pMonst->magicDefense);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_MAGPOWER, pMonst->magicPower);
	m_propSheet->m_statsPage.SetDlgItemInt(IDC_MAGBLOCK, pMonst->magBlockRate);

	m_propSheet->m_statsPage.m_wndPicture.m_nMonst = nIndex;
	m_propSheet->m_statsPage.m_wndPicture.Invalidate();

	for(int i = 0; i < 32; i++)
	{
		m_propSheet->m_statsPage.m_wndConditions.SetCheck(i,
			(pMonst->conditions[i / 8] & (1 << (i % 8))) ? 1 : 0);
	}

	for(i = 0; i < 8; i++)
	{
		m_propSheet->m_statsPage.m_wndElements.SetColumnCheck(i, 0,
			(pMonst->elemAbsorb & (1 << i)) ? 1 : 0);
		m_propSheet->m_statsPage.m_wndElements.SetColumnCheck(i, 1,
			(pMonst->elemNoEffect & (1 << i)) ? 1 : 0);
		m_propSheet->m_statsPage.m_wndElements.SetColumnCheck(i, 2,
			(pMonst->elemWeak & (1 << i)) ? 1 : 0);
	}

	m_propSheet->m_abilitiesPage.m_wndAttackName.m_pDoc = pDoc;
	
	m_propSheet->m_abilitiesPage.m_wndMorphList.ResetContent();
	m_propSheet->m_abilitiesPage.m_wndMorphList.m_pDoc = pDoc;
	m_propSheet->m_abilitiesPage.m_wndMorphList.m_dwListStyle = FF3LBS_NOCHANGE;

	m_propSheet->m_abilitiesPage.m_wndDroppedList.ResetContent();
	m_propSheet->m_abilitiesPage.m_wndDroppedList.m_pDoc = pDoc;
	m_propSheet->m_abilitiesPage.m_wndStolenList.ResetContent();
	m_propSheet->m_abilitiesPage.m_wndStolenList.m_pDoc = pDoc;

	m_itemArray.RemoveAll();

	for(i = 0; i < 256; i++)
		m_itemArray.Add(pDoc->items[i].name);

	m_propSheet->m_abilitiesPage.m_wndMorphList.m_pArray = &m_itemArray;
	m_propSheet->m_abilitiesPage.m_wndDroppedList.m_pArray = &m_itemArray;
	m_propSheet->m_abilitiesPage.m_wndStolenList.m_pArray = &m_itemArray;

	m_propSheet->m_abilitiesPage.m_wndDroppedList.AddItem(pMonst->itemsDropped[0], 13);
	m_propSheet->m_abilitiesPage.m_wndDroppedList.AddItem(pMonst->itemsDropped[1], 13);
	m_propSheet->m_abilitiesPage.m_wndStolenList.AddItem(pMonst->itemsStolen[0], 13);
	m_propSheet->m_abilitiesPage.m_wndStolenList.AddItem(pMonst->itemsStolen[1], 13);

	m_propSheet->m_abilitiesPage.SetDlgItemInt(IDC_MORPHNUM, pMonst->GetMorphPackage());
	m_propSheet->m_abilitiesPage.SetDlgItemInt(IDC_MORPHSUCCESS, pMonst->GetMorphSuccess());

	for(i = 0; i < 4; i++)
		m_propSheet->m_abilitiesPage.m_wndMorphList.AddItem(pDoc->morphPackages[pMonst->GetMorphPackage()][i], 13);
}

void CMonsterEditView::OnSelChangeList() 
{
	UpdateControls(m_wndList.GetCurSel());
}
