// MonsterFormationView.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Doc.h"
#include "MonsterFormationView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMonsterFormationView

IMPLEMENT_DYNCREATE(CMonsterFormationView, CSizingFormView)

CMonsterFormationView::CMonsterFormationView()
	: CSizingFormView(CMonsterFormationView::IDD)
{
	//{{AFX_DATA_INIT(CMonsterFormationView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_bValid = FALSE;
	m_bFromPreview = FALSE;
}

CMonsterFormationView::~CMonsterFormationView()
{
}

void CMonsterFormationView::DoDataExchange(CDataExchange* pDX)
{
	CSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonsterFormationView)
	DDX_Control(pDX, IDC_TEMPLATELIST, m_wndTemplateList);
	DDX_Control(pDX, IDC_EXECSCRIPT, m_wndExecScript);
	DDX_Control(pDX, IDC_SCRIPT, m_wndScript);
	DDX_Control(pDX, IDC_MUSIC, m_wndMusic);
	DDX_Control(pDX, IDC_PLAYMUSIC, m_wndPlayMusic);
	DDX_Control(pDX, IDC_SHOWADVMSG, m_wndShowMessages);
	DDX_Control(pDX, IDC_NOFANFARE, m_wndNoFanfare);
	DDX_Control(pDX, IDC_NOSIDE, m_wndNoSide);
	DDX_Control(pDX, IDC_NOPINCER, m_wndNoPincer);
	DDX_Control(pDX, IDC_NONORMAL, m_wndNoNormal);
	DDX_Control(pDX, IDC_NOBACK, m_wndNoBack);
	DDX_Control(pDX, IDC_APPEARANCE, m_wndAppearance);
	DDX_Control(pDX, IDC_BATTLEPREVIEW, m_wndPreview);
	DDX_Control(pDX, IDC_ENEMY6LIST, m_wndEnemy6List);
	DDX_Control(pDX, IDC_ENEMY5LIST, m_wndEnemy5List);
	DDX_Control(pDX, IDC_ENEMY4LIST, m_wndEnemy4List);
	DDX_Control(pDX, IDC_ENEMY3LIST, m_wndEnemy3List);
	DDX_Control(pDX, IDC_ENEMY2LIST, m_wndEnemy2List);
	DDX_Control(pDX, IDC_ENEMY1LIST, m_wndEnemy1List);
	DDX_Control(pDX, IDC_ENEMY6, m_wndEnemy6);
	DDX_Control(pDX, IDC_ENEMY5, m_wndEnemy5);
	DDX_Control(pDX, IDC_ENEMY4, m_wndEnemy4);
	DDX_Control(pDX, IDC_ENEMY3, m_wndEnemy3);
	DDX_Control(pDX, IDC_ENEMY2, m_wndEnemy2);
	DDX_Control(pDX, IDC_ENEMY1, m_wndEnemy1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMonsterFormationView, CSizingFormView)
	//{{AFX_MSG_MAP(CMonsterFormationView)
	ON_EN_CHANGE(IDC_FORMATIONNUM, OnChangeFormation)
	ON_BN_CLICKED(IDC_PREV1, OnPreviewButtonClicked)
	ON_CONTROL(BPN_POSITIONCHANGED, IDC_BATTLEPREVIEW, OnPreviewPositionChanged)
	ON_EN_CHANGE(IDC_ENEMY1XPOS, OnChangeEnemyPos)
	ON_BN_CLICKED(IDC_ENEMY1, OnClickedEnemy1)
	ON_BN_CLICKED(IDC_ENEMY2, OnClickedEnemy2)
	ON_BN_CLICKED(IDC_ENEMY3, OnClickedEnemy3)
	ON_BN_CLICKED(IDC_ENEMY4, OnClickedEnemy4)
	ON_BN_CLICKED(IDC_ENEMY5, OnClickedEnemy5)
	ON_BN_CLICKED(IDC_ENEMY6, OnClickedEnemy6)
	ON_CBN_SELENDOK(IDC_ENEMY1LIST, OnSelEndOKEnemy)
	ON_CBN_SELENDOK(IDC_APPEARANCE, OnSelEndOKAppearance)
	ON_BN_CLICKED(IDC_NONORMAL, OnClickedNoNormal)
	ON_BN_CLICKED(IDC_NOBACK, OnClickedNoBack)
	ON_BN_CLICKED(IDC_NOPINCER, OnClickedNoPincer)
	ON_BN_CLICKED(IDC_NOSIDE, OnClickedNoSide)
	ON_BN_CLICKED(IDC_SHOWADVMSG, OnClickedShowMessages)
	ON_BN_CLICKED(IDC_PLAYMUSIC, OnClickedPlayMusic)
	ON_BN_CLICKED(IDC_NOFANFARE, OnClickedNoFanfare)
	ON_BN_CLICKED(IDC_EXECSCRIPT, OnClickedExecScript)
	ON_BN_CLICKED(IDC_PREV2, OnPreviewButtonClicked)
	ON_BN_CLICKED(IDC_PREV3, OnPreviewButtonClicked)
	ON_BN_CLICKED(IDC_PREV4, OnPreviewButtonClicked)
	ON_BN_CLICKED(IDC_PREV5, OnPreviewButtonClicked)
	ON_BN_CLICKED(IDC_PREV6, OnPreviewButtonClicked)
	ON_EN_CHANGE(IDC_ENEMY1YPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY2XPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY2YPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY3XPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY3YPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY4XPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY4YPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY5XPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY5YPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY6XPOS, OnChangeEnemyPos)
	ON_EN_CHANGE(IDC_ENEMY6YPOS, OnChangeEnemyPos)
	ON_CBN_SELENDOK(IDC_ENEMY2LIST, OnSelEndOKEnemy)
	ON_CBN_SELENDOK(IDC_ENEMY3LIST, OnSelEndOKEnemy)
	ON_CBN_SELENDOK(IDC_ENEMY4LIST, OnSelEndOKEnemy)
	ON_CBN_SELENDOK(IDC_ENEMY5LIST, OnSelEndOKEnemy)
	ON_EN_CHANGE(IDC_SCRIPT, OnChangeScript)
	ON_EN_CHANGE(IDC_TEMPLATE, OnChangeTemplate)
	ON_CBN_SELENDOK(IDC_MUSIC, OnSelEndOKMusic)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_COMPAREVIEW, OnCompareView)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonsterFormationView diagnostics

#ifdef _DEBUG
void CMonsterFormationView::AssertValid() const
{
	CSizingFormView::AssertValid();
}

void CMonsterFormationView::Dump(CDumpContext& dc) const
{
	CSizingFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMonsterFormationView message handlers

LRESULT CMonsterFormationView::OnCompareView(WPARAM wParam, LPARAM lParam)
{
	if(lParam == 'MNST') return TRUE;
	else return FALSE;
}

CString g_strTemplates[13][7] =
{
	{									// 0
		"Enemy 1: $0000, 64 x 64",
		"Enemy 2: $0001, 64 x 64",
		"Enemy 3: $0010, 64 x 64",
		"Enemy 4: $0011, 64 x 64",
		"",
		""
	},
	{									// 1
		"Enemy 1: $0000, 64 x 64",
		"Enemy 2: $0001, 64 x 64",
		"Enemy 3: $0010, 32 x 32",
		"Enemy 4: $8010, 32 x 32",
		"Enemy 5: $0011, 32 x 32",
		"Enemy 6: $8011, 32 x 32"
	},
	{									// 2
		"Enemy 1: $0000, 96 x 64",
		"Enemy 2: $0001, 96 x 64",
		"",
		"",
		"",
		""
	},
	{									// 3
		"Enemy 1: $0000, 64 x 128",
		"Enemy 2: $0001, 64 x 128",
		"",
		"",
		"",
		""
	},
	{									// 4
		"Enemy 1: $0000, 96 x 64",
		"Enemy 2: $0010, 64 x 64",
		"Enemy 3: $0011, 64 x 64",
		"",
		"",
		""
	},
	{									// 5
		"Enemy 1: $0000, 64 x 128",
		"Enemy 2: $0001, 64 x 64",
		"Enemy 3: $0011, 64 x 64",
		"",
		"",
		""
	},
	{									// 6
		"Enemy 1: $0000, 128 x 128",
		"",
		"",
		"",
		"",
		""
	},
	{									// 7
		"Enemy 1: $0000, 96 x 96",
		"Enemy 2: $8001, 32 x 96",
		"Enemy 3: $0018, 32 x 32",
		"Enemy 4: $8018, 32 x 32",
		"Enemy 5: $0019, 32 x 32",
		"Enemy 6: $8019, 32 x 32"
	},
	{									// 8
		"Enemy 1: $0000, 64 x 64",
		"Enemy 2: $0010, 64 x 64",
		"Enemy 3: $0001, 32 x 64",
		"Enemy 4: $0011, 32 x 64",
		"",
		""
	},
	{									// 9
		"Enemy 1: $0000, 96 x 96",
		"",
		"",
		"",
		"",
		""
	},
	{									// A
		"Enemy 1: $0000, 64 x 96",
		"Enemy 2: $0001, 32 x 64",
		"Enemy 3: $0011, 32 x 64",
		"Enemy 4: $0018, 32 x 32",
		"Enemy 5: $8018, 32 x 32",
		""
	},
	{									// B
		"Enemy 1: $0000, 32 x 64",
		"Enemy 2: $8000, 32 x 64",
		"Enemy 3: $0001, 32 x 64",
		"Enemy 4: $0011, 32 x 64",
		"Enemy 5: $0010, 64 x 64",
		""
	},
	{									// C
		"Enemy 1: $0000, 64 x 64",
		"Enemy 2: $0001, 64 x 64",
		"Enemy 3: $0010, 32 x 64",
		"Enemy 4: $8010, 32 x 64",
		"Enemy 5: $0011, 32 x 64",
		"Enemy 6: $8011, 32 x 64"
	},
};

void CMonsterFormationView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	m_bValid = TRUE;

	m_wndEnemy1List.ResetContent();
	m_wndEnemy2List.ResetContent();
	m_wndEnemy3List.ResetContent();
	m_wndEnemy4List.ResetContent();
	m_wndEnemy5List.ResetContent();
	m_wndEnemy6List.ResetContent();

	m_wndEnemy1List.m_pDoc = pDoc;
	m_wndEnemy2List.m_pDoc = pDoc;
	m_wndEnemy3List.m_pDoc = pDoc;
	m_wndEnemy4List.m_pDoc = pDoc;
	m_wndEnemy5List.m_pDoc = pDoc;
	m_wndEnemy6List.m_pDoc = pDoc;

	for(int i = 0; i < 384; i++)
	{
		m_wndEnemy1List.AddString(pDoc->monsters[i].name, 10);
		m_wndEnemy2List.AddString(pDoc->monsters[i].name, 10);
		m_wndEnemy3List.AddString(pDoc->monsters[i].name, 10);
		m_wndEnemy4List.AddString(pDoc->monsters[i].name, 10);
		m_wndEnemy5List.AddString(pDoc->monsters[i].name, 10);
		m_wndEnemy6List.AddString(pDoc->monsters[i].name, 10);
	}

	((CSpinButtonCtrl*)GetDlgItem(IDC_FORMATIONSPIN))->SetRange(0, 575);

	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY1XSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY1YSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY2XSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY2YSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY3XSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY3YSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY4XSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY4YSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY5XSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY5YSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY6XSPIN))->SetRange(0, 15);
	((CSpinButtonCtrl*)GetDlgItem(IDC_ENEMY6YSPIN))->SetRange(0, 15);

	((CSpinButtonCtrl*)GetDlgItem(IDC_TEMPLATESPIN))->SetRange(0, 12);

	m_wndPreview.m_pDoc = pDoc;

	UpdateControls(0);
}

void CMonsterFormationView::UpdateControls(int nIndex)
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();

	if(pDoc->monsterFormations[nIndex].IsPresent(0))
	{
		m_wndEnemy1.SetCheck(1);
		EnableControls(1, TRUE);
		m_wndPreview.visible[0] = TRUE;
	}
	else
	{
		m_wndEnemy1.SetCheck(0);
		EnableControls(1, FALSE);
		m_wndPreview.visible[0] = FALSE;
	}

	if(pDoc->monsterFormations[nIndex].IsPresent(1))
	{
		m_wndEnemy2.SetCheck(1);
		EnableControls(2, TRUE);
		m_wndPreview.visible[1] = TRUE;
	}
	else
	{
		m_wndEnemy2.SetCheck(0);
		EnableControls(2, FALSE);
		m_wndPreview.visible[1] = FALSE;
	}

	if(pDoc->monsterFormations[nIndex].IsPresent(2))
	{
		m_wndEnemy3.SetCheck(1);
		EnableControls(3, TRUE);
		m_wndPreview.visible[2] = TRUE;
	}
	else
	{
		m_wndEnemy3.SetCheck(0);
		EnableControls(3, FALSE);
		m_wndPreview.visible[2] = FALSE;
	}

	if(pDoc->monsterFormations[nIndex].IsPresent(3))
	{
		m_wndEnemy4.SetCheck(1);
		EnableControls(4, TRUE);
		m_wndPreview.visible[3] = TRUE;
	}
	else
	{
		m_wndEnemy4.SetCheck(0);
		EnableControls(4, FALSE);
		m_wndPreview.visible[3] = FALSE;
	}

	if(pDoc->monsterFormations[nIndex].IsPresent(4))
	{
		m_wndEnemy5.SetCheck(1);
		EnableControls(5, TRUE);
		m_wndPreview.visible[4] = TRUE;
	}
	else
	{
		m_wndEnemy5.SetCheck(0);
		EnableControls(5, FALSE);
		m_wndPreview.visible[4] = FALSE;
	}

	if(pDoc->monsterFormations[nIndex].IsPresent(5))
	{
		m_wndEnemy6.SetCheck(1);
		EnableControls(6, TRUE);
		m_wndPreview.visible[5] = TRUE;
	}
	else
	{
		m_wndEnemy6.SetCheck(0);
		EnableControls(6, FALSE);
		m_wndPreview.visible[5] = FALSE;
	}

	((CButton*)GetDlgItem(IDC_PREV1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_PREV2))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_PREV3))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_PREV4))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_PREV5))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_PREV6))->SetCheck(0);
	m_wndPreview.active = -1;

	m_wndEnemy1List.SetCurSel(pDoc->monsterFormations[nIndex].GetMonster(0));
	m_wndEnemy2List.SetCurSel(pDoc->monsterFormations[nIndex].GetMonster(1));
	m_wndEnemy3List.SetCurSel(pDoc->monsterFormations[nIndex].GetMonster(2));
	m_wndEnemy4List.SetCurSel(pDoc->monsterFormations[nIndex].GetMonster(3));
	m_wndEnemy5List.SetCurSel(pDoc->monsterFormations[nIndex].GetMonster(4));
	m_wndEnemy6List.SetCurSel(pDoc->monsterFormations[nIndex].GetMonster(5));

	m_bValid = FALSE;
	SetDlgItemInt(IDC_ENEMY1XPOS, pDoc->monsterFormations[nIndex].GetXPos(0));
	SetDlgItemInt(IDC_ENEMY1YPOS, pDoc->monsterFormations[nIndex].GetYPos(0));
	SetDlgItemInt(IDC_ENEMY2XPOS, pDoc->monsterFormations[nIndex].GetXPos(1));
	SetDlgItemInt(IDC_ENEMY2YPOS, pDoc->monsterFormations[nIndex].GetYPos(1));
	SetDlgItemInt(IDC_ENEMY3XPOS, pDoc->monsterFormations[nIndex].GetXPos(2));
	SetDlgItemInt(IDC_ENEMY3YPOS, pDoc->monsterFormations[nIndex].GetYPos(2));
	SetDlgItemInt(IDC_ENEMY4XPOS, pDoc->monsterFormations[nIndex].GetXPos(3));
	SetDlgItemInt(IDC_ENEMY4YPOS, pDoc->monsterFormations[nIndex].GetYPos(3));
	SetDlgItemInt(IDC_ENEMY5XPOS, pDoc->monsterFormations[nIndex].GetXPos(4));
	SetDlgItemInt(IDC_ENEMY5YPOS, pDoc->monsterFormations[nIndex].GetYPos(4));
	SetDlgItemInt(IDC_ENEMY6XPOS, pDoc->monsterFormations[nIndex].GetXPos(5));
	SetDlgItemInt(IDC_ENEMY6YPOS, pDoc->monsterFormations[nIndex].GetYPos(5));
	m_bValid = TRUE;

	m_wndAppearance.SetCurSel(pDoc->monsterFormations[nIndex].GetAppearance());
	m_wndNoNormal.SetCheck((pDoc->monsterFormations[nIndex].aux[0] & 0x10) ? 1 : 0);
	m_wndNoBack.SetCheck((pDoc->monsterFormations[nIndex].aux[0] & 0x20) ? 1 : 0);
	m_wndNoPincer.SetCheck((pDoc->monsterFormations[nIndex].aux[0] & 0x40) ? 1 : 0);
	m_wndNoSide.SetCheck((pDoc->monsterFormations[nIndex].aux[0] & 0x80) ? 1 : 0);
	m_wndNoFanfare.SetCheck((pDoc->monsterFormations[nIndex].aux[1] & 0x01) ? 1 : 0);
	m_wndShowMessages.SetCheck((pDoc->monsterFormations[nIndex].aux[3] & 0x04) ? 1 : 0);

	m_wndExecScript.SetCheck((pDoc->monsterFormations[nIndex].aux[1] & 0x80) ? 1 : 0);
	SetDlgItemInt(IDC_SCRIPT, pDoc->monsterFormations[nIndex].aux[2]);

	m_wndPlayMusic.SetCheck((pDoc->monsterFormations[nIndex].aux[3] & 0x80) ? 0 : 1);
	m_wndMusic.SetCurSel((pDoc->monsterFormations[nIndex].aux[3] & 0x38) >> 3);

	SetDlgItemInt(IDC_TEMPLATE, pDoc->monsterFormations[nIndex].GetSizeTemplate());

	UpdateTemplate(pDoc->monsterFormations[nIndex].GetSizeTemplate());
	UpdatePreviewWindow(nIndex);
}

void CMonsterFormationView::OnChangeFormation() 
{
	if(!m_bValid) return;

	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);
	UpdateControls(nIndex);
}

void CMonsterFormationView::EnableControls(int nIndex, BOOL bEnable)
{
	if(nIndex == 1)
	{
		GetDlgItem(IDC_ENEMY1LIST)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY1XPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY1XSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY1YPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY1YSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_PREV1)->EnableWindow(bEnable);
	}
	else if(nIndex == 2)
	{
		GetDlgItem(IDC_ENEMY2LIST)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY2XPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY2XSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY2YPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY2YSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_PREV2)->EnableWindow(bEnable);
	}
	else if(nIndex == 3)
	{
		GetDlgItem(IDC_ENEMY3LIST)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY3XPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY3XSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY3YPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY3YSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_PREV3)->EnableWindow(bEnable);
	}
	else if(nIndex == 4)
	{
		GetDlgItem(IDC_ENEMY4LIST)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY4XPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY4XSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY4YPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY4YSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_PREV4)->EnableWindow(bEnable);
	}
	else if(nIndex == 5)
	{
		GetDlgItem(IDC_ENEMY5LIST)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY5XPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY5XSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY5YPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY5YSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_PREV5)->EnableWindow(bEnable);
	}
	else if(nIndex == 6)
	{
		GetDlgItem(IDC_ENEMY6LIST)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY6XPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY6XSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY6YPOS)->EnableWindow(bEnable);
		GetDlgItem(IDC_ENEMY6YSPIN)->EnableWindow(bEnable);
		GetDlgItem(IDC_PREV6)->EnableWindow(bEnable);
	}
}

void CMonsterFormationView::UpdatePreviewWindow(int nIndex)
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();

	m_wndPreview.monsters[0] = pDoc->monsterFormations[nIndex].GetMonster(0);
	m_wndPreview.monsters[1] = pDoc->monsterFormations[nIndex].GetMonster(1);
	m_wndPreview.monsters[2] = pDoc->monsterFormations[nIndex].GetMonster(2);
	m_wndPreview.monsters[3] = pDoc->monsterFormations[nIndex].GetMonster(3);
	m_wndPreview.monsters[4] = pDoc->monsterFormations[nIndex].GetMonster(4);
	m_wndPreview.monsters[5] = pDoc->monsterFormations[nIndex].GetMonster(5);

	m_wndPreview.positions[0].x = pDoc->monsterFormations[nIndex].GetXPos(0);
	m_wndPreview.positions[0].y = pDoc->monsterFormations[nIndex].GetYPos(0);
	m_wndPreview.positions[1].x = pDoc->monsterFormations[nIndex].GetXPos(1);
	m_wndPreview.positions[1].y = pDoc->monsterFormations[nIndex].GetYPos(1);
	m_wndPreview.positions[2].x = pDoc->monsterFormations[nIndex].GetXPos(2);
	m_wndPreview.positions[2].y = pDoc->monsterFormations[nIndex].GetYPos(2);
	m_wndPreview.positions[3].x = pDoc->monsterFormations[nIndex].GetXPos(3);
	m_wndPreview.positions[3].y = pDoc->monsterFormations[nIndex].GetYPos(3);
	m_wndPreview.positions[4].x = pDoc->monsterFormations[nIndex].GetXPos(4);
	m_wndPreview.positions[4].y = pDoc->monsterFormations[nIndex].GetYPos(4);
	m_wndPreview.positions[5].x = pDoc->monsterFormations[nIndex].GetXPos(5);
	m_wndPreview.positions[5].y = pDoc->monsterFormations[nIndex].GetYPos(5);
	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnPreviewButtonClicked() 
{
	if(((CButton*)GetDlgItem(IDC_PREV1))->GetCheck() == 1)
		m_wndPreview.active = 0;
	else if(((CButton*)GetDlgItem(IDC_PREV2))->GetCheck() == 1)
		m_wndPreview.active = 1;
	else if(((CButton*)GetDlgItem(IDC_PREV3))->GetCheck() == 1)
		m_wndPreview.active = 2;
	else if(((CButton*)GetDlgItem(IDC_PREV4))->GetCheck() == 1)
		m_wndPreview.active = 3;
	else if(((CButton*)GetDlgItem(IDC_PREV5))->GetCheck() == 1)
		m_wndPreview.active = 4;
	else if(((CButton*)GetDlgItem(IDC_PREV6))->GetCheck() == 1)
		m_wndPreview.active = 5;

	m_wndPreview.Invalidate();
}

void CMonsterFormationView::OnSelEndOKEnemy() 
{
	if(!m_bValid) return;

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	pDoc->monsterFormations[nIndex].SetMonster(0, m_wndEnemy1List.GetCurSel());
	pDoc->monsterFormations[nIndex].SetMonster(1, m_wndEnemy2List.GetCurSel());
	pDoc->monsterFormations[nIndex].SetMonster(2, m_wndEnemy3List.GetCurSel());
	pDoc->monsterFormations[nIndex].SetMonster(3, m_wndEnemy4List.GetCurSel());
	pDoc->monsterFormations[nIndex].SetMonster(4, m_wndEnemy5List.GetCurSel());
	pDoc->monsterFormations[nIndex].SetMonster(5, m_wndEnemy6List.GetCurSel());

	UpdatePreviewWindow(nIndex);
}

void CMonsterFormationView::OnPreviewPositionChanged() 
{
	int nIndex = m_wndPreview.active;
	int x = m_wndPreview.positions[nIndex].x;
	int y = m_wndPreview.positions[nIndex].y;

	m_bFromPreview = TRUE;

	if(nIndex == 0)
	{
		SetDlgItemInt(IDC_ENEMY1XPOS, x);
		SetDlgItemInt(IDC_ENEMY1YPOS, y);
	}
	else if(nIndex == 1)
	{
		SetDlgItemInt(IDC_ENEMY2XPOS, x);
		SetDlgItemInt(IDC_ENEMY2YPOS, y);
	}
	else if(nIndex == 2)
	{
		SetDlgItemInt(IDC_ENEMY3XPOS, x);
		SetDlgItemInt(IDC_ENEMY3YPOS, y);
	}
	else if(nIndex == 3)
	{
		SetDlgItemInt(IDC_ENEMY4XPOS, x);
		SetDlgItemInt(IDC_ENEMY4YPOS, y);
	}
	else if(nIndex == 4)
	{
		SetDlgItemInt(IDC_ENEMY5XPOS, x);
		SetDlgItemInt(IDC_ENEMY5YPOS, y);
	}
	else if(nIndex == 5)
	{
		SetDlgItemInt(IDC_ENEMY6XPOS, x);
		SetDlgItemInt(IDC_ENEMY6YPOS, y);
	}

	m_bFromPreview = FALSE;
}

void CMonsterFormationView::OnChangeEnemyPos() 
{
	if(!m_bValid) return;

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	pDoc->monsterFormations[nIndex].SetXPos(0, GetDlgItemInt(IDC_ENEMY1XPOS));
	pDoc->monsterFormations[nIndex].SetYPos(0, GetDlgItemInt(IDC_ENEMY1YPOS));
	pDoc->monsterFormations[nIndex].SetXPos(1, GetDlgItemInt(IDC_ENEMY2XPOS));
	pDoc->monsterFormations[nIndex].SetYPos(1, GetDlgItemInt(IDC_ENEMY2YPOS));
	pDoc->monsterFormations[nIndex].SetXPos(2, GetDlgItemInt(IDC_ENEMY3XPOS));
	pDoc->monsterFormations[nIndex].SetYPos(2, GetDlgItemInt(IDC_ENEMY3YPOS));
	pDoc->monsterFormations[nIndex].SetXPos(3, GetDlgItemInt(IDC_ENEMY4XPOS));
	pDoc->monsterFormations[nIndex].SetYPos(3, GetDlgItemInt(IDC_ENEMY4YPOS));
	pDoc->monsterFormations[nIndex].SetXPos(4, GetDlgItemInt(IDC_ENEMY5XPOS));
	pDoc->monsterFormations[nIndex].SetYPos(4, GetDlgItemInt(IDC_ENEMY5YPOS));
	pDoc->monsterFormations[nIndex].SetXPos(5, GetDlgItemInt(IDC_ENEMY6XPOS));
	pDoc->monsterFormations[nIndex].SetYPos(5, GetDlgItemInt(IDC_ENEMY6YPOS));

	if(!m_bFromPreview) UpdatePreviewWindow(nIndex);
}

void CMonsterFormationView::OnClickedEnemy1() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bEnable = (m_wndEnemy1.GetCheck() == 1) ? TRUE : FALSE;

	pDoc->monsterFormations[nIndex].SetPresent(0, bEnable);

	EnableControls(1, bEnable);
	((CButton*)GetDlgItem(IDC_PREV1))->SetCheck(0);
	m_wndPreview.visible[0] = bEnable;
	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnClickedEnemy2() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bEnable = (m_wndEnemy2.GetCheck() == 1) ? TRUE : FALSE;

	pDoc->monsterFormations[nIndex].SetPresent(1, bEnable);

	EnableControls(2, bEnable);
	((CButton*)GetDlgItem(IDC_PREV2))->SetCheck(0);
	m_wndPreview.visible[1] = bEnable;
	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnClickedEnemy3() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bEnable = (m_wndEnemy3.GetCheck() == 1) ? TRUE : FALSE;

	pDoc->monsterFormations[nIndex].SetPresent(2, bEnable);
	
	EnableControls(3, bEnable);
	((CButton*)GetDlgItem(IDC_PREV3))->SetCheck(0);
	m_wndPreview.visible[2] = bEnable;
	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnClickedEnemy4() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bEnable = (m_wndEnemy4.GetCheck() == 1) ? TRUE : FALSE;

	pDoc->monsterFormations[nIndex].SetPresent(3, bEnable);

	EnableControls(4, bEnable);
	((CButton*)GetDlgItem(IDC_PREV4))->SetCheck(0);
	m_wndPreview.visible[3] = bEnable;
	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnClickedEnemy5() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bEnable = (m_wndEnemy5.GetCheck() == 1) ? TRUE : FALSE;

	pDoc->monsterFormations[nIndex].SetPresent(4, bEnable);
	
	EnableControls(5, bEnable);
	((CButton*)GetDlgItem(IDC_PREV5))->SetCheck(0);
	m_wndPreview.visible[4] = bEnable;
	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnClickedEnemy6() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bEnable = (m_wndEnemy6.GetCheck() == 1) ? TRUE : FALSE;

	pDoc->monsterFormations[nIndex].SetPresent(5, bEnable);
	
	EnableControls(6, bEnable);
	((CButton*)GetDlgItem(IDC_PREV6))->SetCheck(0);
	m_wndPreview.visible[5] = bEnable;
	m_wndPreview.Invalidate(FALSE);
}


void CMonsterFormationView::OnSelEndOKAppearance() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	int nSel = ((CComboBox*)GetDlgItem(IDC_APPEARANCE))->GetCurSel();

	pDoc->monsterFormations[nIndex].SetAppearance(nSel);
}

void CMonsterFormationView::OnClickedNoNormal() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndNoNormal.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[0] |= 0x10;
	else
		pDoc->monsterFormations[nIndex].aux[0] &= ~0x10;
}

void CMonsterFormationView::OnClickedNoBack() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndNoBack.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[0] |= 0x20;
	else
		pDoc->monsterFormations[nIndex].aux[0] &= ~0x20;
}

void CMonsterFormationView::OnClickedNoPincer() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndNoPincer.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[0] |= 0x40;
	else
		pDoc->monsterFormations[nIndex].aux[0] &= ~0x40;
}

void CMonsterFormationView::OnClickedNoSide() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndNoSide.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[0] |= 0x80;
	else
		pDoc->monsterFormations[nIndex].aux[0] &= ~0x80;
}

void CMonsterFormationView::OnClickedShowMessages() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndShowMessages.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[3] |= 0x04;
	else
		pDoc->monsterFormations[nIndex].aux[3] &= ~0x04;
}

void CMonsterFormationView::OnClickedPlayMusic() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	// Notice that this button is inverted.
	BOOL bSet = (m_wndPlayMusic.GetCheck() == 1) ? FALSE : TRUE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[3] |= 0x80;
	else
		pDoc->monsterFormations[nIndex].aux[3] &= ~0x80;
}

void CMonsterFormationView::OnClickedNoFanfare() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndNoFanfare.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[1] |= 0x02;
	else
		pDoc->monsterFormations[nIndex].aux[1] &= ~0x02;
}

void CMonsterFormationView::OnClickedExecScript() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	BOOL bSet = (m_wndExecScript.GetCheck() == 1) ? TRUE : FALSE;
	if(bSet)
		pDoc->monsterFormations[nIndex].aux[1] |= 0x80;
	else
		pDoc->monsterFormations[nIndex].aux[1] &= ~0x80;
}

void CMonsterFormationView::OnChangeScript() 
{
	if(!m_bValid) return;

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	pDoc->monsterFormations[nIndex].aux[2] = GetDlgItemInt(IDC_SCRIPT);
}

void CMonsterFormationView::OnChangeTemplate() 
{
	if(!m_bValid) return;

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	m_bValid = FALSE;
	if(GetDlgItemInt(IDC_TEMPLATE) > 12)
		SetDlgItemInt(IDC_TEMPLATE, 12);
	m_bValid = TRUE;

	int nTempl = GetDlgItemInt(IDC_TEMPLATE);

	pDoc->monsterFormations[nIndex].SetSizeTemplate(nTempl);
	UpdateTemplate(nTempl);
}

void CMonsterFormationView::UpdateTemplate(int nTempl)
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	m_wndTemplateList.ResetContent();

	for(int i = 0; i < pDoc->monsterTemplateCount[nTempl]; i++)
	{
		CString s;
		s.Format("Enemy %d: ($%04X) %d x %d", i + 1, pDoc->monsterTemplates[nTempl][i].GetUnknown(),
			pDoc->monsterTemplates[nTempl][i].GetWidth() * 8,
			pDoc->monsterTemplates[nTempl][i].GetHeight() * 8);
		m_wndTemplateList.AddString(s);
	}

	for(i = 0; i < 6; i++)
	{
		m_wndPreview.sizes[i].cx = pDoc->monsterTemplates[nTempl][i].GetWidth();
		m_wndPreview.sizes[i].cy = pDoc->monsterTemplates[nTempl][i].GetHeight();
	}

	m_wndPreview.Invalidate(FALSE);
}

void CMonsterFormationView::OnSelEndOKMusic() 
{
	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();
	int nIndex = GetDlgItemInt(IDC_FORMATIONNUM);

	pDoc->monsterFormations[nIndex].aux[3] = (pDoc->monsterFormations[nIndex].aux[3] & ~0x38) | 
		(m_wndMusic.GetCurSel() << 3);
}
