#if !defined(AFX_MONSTERFORMATIONVIEW_H__7DAE6D60_D0CE_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_MONSTERFORMATIONVIEW_H__7DAE6D60_D0CE_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonsterFormationView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMonsterFormationView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "SizingFormView.h"
#include "FF3ComboBox.h"
#include "BattlePreviewWnd.h"

class CMonsterFormationView : public CSizingFormView
{
protected:
	CMonsterFormationView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMonsterFormationView)

	BOOL m_bValid;
	BOOL m_bFromPreview;

// Form Data
public:
	//{{AFX_DATA(CMonsterFormationView)
	enum { IDD = IDF_MONSTFORMATION };
	CListBox	m_wndTemplateList;
	CButton	m_wndExecScript;
	CEdit	m_wndScript;
	CComboBox	m_wndMusic;
	CButton	m_wndPlayMusic;
	CButton	m_wndShowMessages;
	CButton	m_wndNoFanfare;
	CButton	m_wndNoSide;
	CButton	m_wndNoPincer;
	CButton	m_wndNoNormal;
	CButton	m_wndNoBack;
	CComboBox	m_wndAppearance;
	CBattlePreviewWnd	m_wndPreview;
	CFF3ComboBox	m_wndEnemy6List;
	CFF3ComboBox	m_wndEnemy5List;
	CFF3ComboBox	m_wndEnemy4List;
	CFF3ComboBox	m_wndEnemy3List;
	CFF3ComboBox	m_wndEnemy2List;
	CFF3ComboBox	m_wndEnemy1List;
	CButton	m_wndEnemy6;
	CButton	m_wndEnemy5;
	CButton	m_wndEnemy4;
	CButton	m_wndEnemy3;
	CButton	m_wndEnemy2;
	CButton	m_wndEnemy1;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	void UpdateTemplate(int nTempl);
	void UpdatePreviewWindow(int nIndex);
	void EnableControls(int nIndex, BOOL bEnable);
	void UpdateControls(int nIndex);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonsterFormationView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMonsterFormationView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CMonsterFormationView)
	afx_msg void OnChangeFormation();
	afx_msg void OnPreviewButtonClicked();
	afx_msg void OnPreviewPositionChanged();
	afx_msg void OnChangeEnemyPos();
	afx_msg void OnClickedEnemy1();
	afx_msg void OnClickedEnemy2();
	afx_msg void OnClickedEnemy3();
	afx_msg void OnClickedEnemy4();
	afx_msg void OnClickedEnemy5();
	afx_msg void OnClickedEnemy6();
	afx_msg void OnSelEndOKEnemy();
	afx_msg void OnSelEndOKAppearance();
	afx_msg void OnClickedNoNormal();
	afx_msg void OnClickedNoBack();
	afx_msg void OnClickedNoPincer();
	afx_msg void OnClickedNoSide();
	afx_msg void OnClickedShowMessages();
	afx_msg void OnClickedPlayMusic();
	afx_msg void OnClickedNoFanfare();
	afx_msg void OnClickedExecScript();
	afx_msg void OnChangeScript();
	afx_msg void OnChangeTemplate();
	afx_msg void OnSelEndOKMusic();
	//}}AFX_MSG
	afx_msg LRESULT OnCompareView(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONSTERFORMATIONVIEW_H__7DAE6D60_D0CE_11D3_BC2A_00E029364BE2__INCLUDED_)
