// MultiCheckListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "MultiCheckListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMultiCheckListCtrl

CMultiCheckListCtrl::CMultiCheckListCtrl()
{
}

CMultiCheckListCtrl::~CMultiCheckListCtrl()
{
}


BEGIN_MESSAGE_MAP(CMultiCheckListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CMultiCheckListCtrl)
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	//}}AFX_MSG_MAP
	ON_WM_DRAWITEM_REFLECT()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiCheckListCtrl message handlers

int CMultiCheckListCtrl::AddItem(LPCTSTR lpszText)
{
	int nColumns = GetHeaderCtrl()->GetItemCount();
	int nItem = GetItemCount();

	LVITEM li;
	ZeroMemory(&li, sizeof(li));

	li.mask = LVIF_TEXT | LVIF_PARAM;
	li.iItem = nItem;
	li.iSubItem = 0;
	li.pszText = (LPTSTR)lpszText;
	li.cchTextMax = lstrlen(lpszText);
	li.lParam = 0;
	int nRes = InsertItem(&li);

	return nRes;
}

void CMultiCheckListCtrl::DrawItem(LPDRAWITEMSTRUCT lpdis)
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != -1)
	{
		dc.FillSolidRect(&rect, GetSysColor(COLOR_WINDOW));

		int nColumns = GetHeaderCtrl()->GetItemCount();

		CRect colRect;
		GetHeaderCtrl()->GetItemRect(0, &colRect);
		colRect.left += 4;
		colRect.right -= 2;
		colRect.top = rect.top;
		colRect.bottom = rect.bottom;
		dc.DrawText(GetItemText(nIndex, 0), &colRect,
			DT_LEFT | DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS);

		LVITEM li;
		li.mask = LVIF_PARAM;
		li.iItem = nIndex;
		li.iSubItem = 0;
		GetItem(&li);

		for(int i = 1; i < nColumns; i++)
		{
			CRect colRect;
			GetHeaderCtrl()->GetItemRect(i, &colRect);
			colRect.top = rect.top;
			colRect.bottom = rect.bottom;

			int iImage = (li.lParam & (1 << (i - 1))) ? 1 : 0;

			CPoint ptCheck(colRect.left + (colRect.right - colRect.left) / 2 - 8, colRect.top);
			m_images.Draw(&dc, iImage, ptCheck, ILD_NORMAL);
		}
	}

	dc.Detach();
}

void CMultiCheckListCtrl::PreSubclassWindow() 
{
	CListCtrl::PreSubclassWindow();

	m_images.Create(IDB_CHECKBOXES, 16, 0, RGB(255, 0, 255));
	SetImageList(&m_images, LVSIL_SMALL);
}

void CMultiCheckListCtrl::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMITEMACTIVATE lpNMIA = (LPNMITEMACTIVATE)pNMHDR;

	LVITEM li;
	li.mask = LVIF_PARAM;
	li.iItem = lpNMIA->iItem;
	li.iSubItem = 0;
	GetItem(&li);

	if(li.lParam & (1 << (lpNMIA->iSubItem - 1)))
		li.lParam &= ~(1 << (lpNMIA->iSubItem - 1));
	else
		li.lParam |= (1 << (lpNMIA->iSubItem - 1));

	SetItem(&li);

	CRect rect;
	GetItemRect(lpNMIA->iItem, &rect, LVIR_BOUNDS);
	InvalidateRect(&rect);

	*pResult = 0;
}

void CMultiCheckListCtrl::SetColumnCheck(int nItem, int nColumn, int nCheck)
{
	LVITEM li;
	li.mask = LVIF_PARAM;
	li.iItem = nItem;
	li.iSubItem = 0;
	GetItem(&li);

	if(nCheck == 0)
		li.lParam &= ~(1 << nColumn);
	else if(nCheck == 1)
		li.lParam |= (1 << nColumn);

	SetItem(&li);
}

int CMultiCheckListCtrl::GetColumnCheck(int nItem, int nColumn)
{
	LVITEM li;
	li.mask = LVIF_PARAM;
	li.iItem = nItem;
	li.iSubItem = 0;
	GetItem(&li);

	return li.lParam & (1 << nColumn);
}
