// PaletteEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "PaletteEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaletteEditDlg dialog


CPaletteEditDlg::CPaletteEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPaletteEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPaletteEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_bChangeProg = FALSE;
}


void CPaletteEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPaletteEditDlg)
	DDX_Control(pDX, IDC_ORIG_COLORBOX, m_wndOrigColorBox);
	DDX_Control(pDX, IDC_LUM, m_wndLum);
	DDX_Control(pDX, IDC_SAT, m_wndSat);
	DDX_Control(pDX, IDC_HUE, m_wndHue);
	DDX_Control(pDX, IDC_BLUE, m_wndBlue);
	DDX_Control(pDX, IDC_GREEN, m_wndGreen);
	DDX_Control(pDX, IDC_RED, m_wndRed);
	DDX_Control(pDX, IDC_COLORBOX, m_wndColorBox);
	DDX_Control(pDX, IDC_WHEEL, m_wndWheel);
	DDX_Control(pDX, IDC_LUMSLIDER, m_wndLumSlider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPaletteEditDlg, CDialog)
	//{{AFX_MSG_MAP(CPaletteEditDlg)
	ON_BN_CLICKED(IDC_WHEEL, OnWheelChanged)
	ON_BN_CLICKED(IDC_LUMSLIDER, OnLuminanceChanged)
	ON_EN_CHANGE(IDC_RED, OnChangeRed)
	ON_EN_CHANGE(IDC_GREEN, OnChangeGreen)
	ON_EN_CHANGE(IDC_BLUE, OnChangeBlue)
	ON_EN_CHANGE(IDC_HUE, OnChangeHue)
	ON_EN_CHANGE(IDC_LUM, OnChangeLum)
	ON_EN_CHANGE(IDC_SAT, OnChangeSat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaletteEditDlg message handlers

void CPaletteEditDlg::OnWheelChanged() 
{
	m_wndLumSlider.m_Hue = m_wndWheel.m_Hue;
	m_wndLumSlider.m_Sat = m_wndWheel.m_Sat;
	m_wndLumSlider.Invalidate();

	WORD wCol = HLStoRGB555(m_wndWheel.m_Hue, m_wndLumSlider.m_Lum, m_wndWheel.m_Sat);
	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_GREEN, G555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnLuminanceChanged() 
{
	WORD wCol = HLStoRGB555(m_wndWheel.m_Hue, m_wndLumSlider.m_Lum, m_wndWheel.m_Sat);
	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;
	
	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_GREEN, G555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnChangeRed() 
{
	if(m_bChangeProg) return;

	if(GetDlgItemInt(IDC_RED) < 0)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_RED, 0);
		m_bChangeProg = FALSE;
	}
	else if(GetDlgItemInt(IDC_RED) > 31)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_RED, 31);
		m_bChangeProg = FALSE;
	}

	WORD wCol = RGB555(GetDlgItemInt(IDC_RED), GetDlgItemInt(IDC_GREEN), GetDlgItemInt(IDC_BLUE));
	double h, s, l;
	RGB555toHSL(wCol, &h, &s, &l);

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_GREEN, G555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnChangeGreen() 
{
	if(m_bChangeProg) return;

	if(GetDlgItemInt(IDC_GREEN) < 0)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_GREEN, 0);
		m_bChangeProg = FALSE;
	}
	else if(GetDlgItemInt(IDC_GREEN) > 31)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_GREEN, 31);
		m_bChangeProg = FALSE;
	}

	WORD wCol = RGB555(GetDlgItemInt(IDC_RED), GetDlgItemInt(IDC_GREEN), GetDlgItemInt(IDC_BLUE));
	double h, s, l;
	RGB555toHSL(wCol, &h, &s, &l);

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnChangeBlue() 
{
	if(m_bChangeProg) return;

	if(GetDlgItemInt(IDC_BLUE) < 0)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_BLUE, 0);
		m_bChangeProg = FALSE;
	}
	else if(GetDlgItemInt(IDC_BLUE) > 31)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_BLUE, 31);
		m_bChangeProg = FALSE;
	}

	WORD wCol = RGB555(GetDlgItemInt(IDC_RED), GetDlgItemInt(IDC_GREEN), GetDlgItemInt(IDC_BLUE));
	double h, s, l;
	RGB555toHSL(wCol, &h, &s, &l);

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_GREEN, G555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnChangeHue() 
{
	if(m_bChangeProg) return;

	if(GetDlgItemInt(IDC_HUE) < 0)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_HUE, 0);
		m_bChangeProg = FALSE;
	}
	else if(GetDlgItemInt(IDC_HUE) > 30)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_HUE, 30);
		m_bChangeProg = FALSE;
	}

	double h, l, s;
	h = (double)GetDlgItemInt(IDC_HUE) / 30.0f;
	l = (double)GetDlgItemInt(IDC_LUM) / 30.0f;
	s = (double)GetDlgItemInt(IDC_SAT) / 30.0f;

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	WORD wCol = HLStoRGB555(h, l, s);
	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_GREEN, G555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnChangeLum() 
{
	if(m_bChangeProg) return;

	if(GetDlgItemInt(IDC_LUM) < 0)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_LUM, 0);
		m_bChangeProg = FALSE;
	}
	else if(GetDlgItemInt(IDC_LUM) > 30)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_LUM, 30);
		m_bChangeProg = FALSE;
	}

	double h, l, s;
	h = (double)GetDlgItemInt(IDC_HUE) / 30.0f;
	l = (double)GetDlgItemInt(IDC_LUM) / 30.0f;
	s = (double)GetDlgItemInt(IDC_SAT) / 30.0f;

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	WORD wCol = HLStoRGB555(h, l, s);
	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_GREEN, G555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_SAT, m_wndWheel.m_Sat * 30);

	m_bChangeProg = FALSE;
}

void CPaletteEditDlg::OnChangeSat() 
{
	if(m_bChangeProg) return;

	if(GetDlgItemInt(IDC_SAT) < 0)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_SAT, 0);
		m_bChangeProg = FALSE;
	}
	else if(GetDlgItemInt(IDC_SAT) > 30)
	{
		m_bChangeProg = TRUE;
		SetDlgItemInt(IDC_SAT, 30);
		m_bChangeProg = FALSE;
	}

	double h, l, s;
	h = (double)GetDlgItemInt(IDC_HUE) / 30.0f;
	l = (double)GetDlgItemInt(IDC_LUM) / 30.0f;
	s = (double)GetDlgItemInt(IDC_SAT) / 30.0f;

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	WORD wCol = HLStoRGB555(h, l, s);
	m_wndColorBox.m_Color = RGB(R555(wCol) * 8, G555(wCol) * 8, B555(wCol) * 8);
	m_wndColorBox.Invalidate();

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(wCol));
	SetDlgItemInt(IDC_GREEN, G555(wCol));
	SetDlgItemInt(IDC_BLUE, B555(wCol));

	SetDlgItemInt(IDC_HUE, m_wndWheel.m_Hue * 30);
	SetDlgItemInt(IDC_LUM, m_wndLumSlider.m_Lum * 30);

	m_bChangeProg = FALSE;
}

BOOL CPaletteEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	double h, s, l;
	RGB555toHSL(m_wColor, &h, &s, &l);

	m_wndWheel.SetHueSat(h, s);

	m_wndLumSlider.m_Hue = h;
	m_wndLumSlider.m_Sat = s;
	m_wndLumSlider.SetLuminance(l);

	m_wndColorBox.m_Color = RGB(R555(m_wColor) * 8, G555(m_wColor) * 8, B555(m_wColor) * 8);
	m_wndOrigColorBox.m_Color = RGB(R555(m_wColor) * 8, G555(m_wColor) * 8, B555(m_wColor) * 8);

	m_bChangeProg = TRUE;

	SetDlgItemInt(IDC_RED, R555(m_wColor));
	SetDlgItemInt(IDC_GREEN, G555(m_wColor));
	SetDlgItemInt(IDC_BLUE, B555(m_wColor));

	SetDlgItemInt(IDC_HUE, h * 30);
	SetDlgItemInt(IDC_SAT, s * 30);
	SetDlgItemInt(IDC_LUM, l * 30);

	m_bChangeProg = FALSE;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPaletteEditDlg::OnOK() 
{
	m_wColor = RGB555(GetDlgItemInt(IDC_RED), GetDlgItemInt(IDC_GREEN), GetDlgItemInt(IDC_BLUE));
	
	CDialog::OnOK();
}
