// PaletteList.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "PaletteList.h"

#include "FF3Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaletteList

CPaletteList::CPaletteList()
{
}

CPaletteList::~CPaletteList()
{
}


BEGIN_MESSAGE_MAP(CPaletteList, CListBox)
	//{{AFX_MSG_MAP(CPaletteList)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaletteList message handlers

void CPaletteList::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 36;
}

void CPaletteList::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;
	dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		CBrush* oldBrush = dc.SelectObject(
			CBrush::FromHandle((HBRUSH)GetStockObject(NULL_BRUSH)));

		CPen hilitePen(PS_SOLID, 2, (lpdis->itemState & ODS_SELECTED) ?
			RGB(255, 0, 0) : ::GetSysColor(COLOR_WINDOW));
		CPen linePen(PS_SOLID, 1, RGB(128, 128, 128));
		CPen* oldPen = dc.SelectObject(&hilitePen);

		if(!(lpdis->itemState & ODS_DISABLED))
		{
			CRect hiliteRect = rect;
			hiliteRect.DeflateRect(1, 1, 0, 0);
			dc.Rectangle(&hiliteRect);
		}

		if(lpdis->itemAction & ODA_DRAWENTIRE)
		{
			CRect lineRect = rect;
			lineRect.DeflateRect(2, 2);
			dc.SelectObject(&linePen);
			dc.Rectangle(&lineRect);
			
			CRect bltRect = lineRect;
			bltRect.DeflateRect(1, 1);

			CFF3Doc* pDoc = (CFF3Doc*)((CFrameWnd*)AfxGetMainWnd())->GetActiveDocument();

			int nPalette = ((CComboBox*)GetParent()->GetDlgItem(IDC_PAL_PALETTES))->GetCurSel();
			int nColor = nIndex;

			WORD wEntry = m_worldData->palette[nPalette * 16 + nColor];
			BYTE b = R555(wEntry);
			BYTE g = G555(wEntry);
			BYTE r = B555(wEntry);

			dc.FillSolidRect(&bltRect, RGB(r * 8, g * 8, b * 8));
		}

		dc.SelectObject(oldPen);
		dc.SelectObject(oldBrush);
	}

	dc.Detach();
}

int CPaletteList::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CListBox::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	return 0;
}
