// PropTreeInLineEdit.cpp : implementation file
//

#include "stdafx.h"
#include "PropTreeInLineEdit.h"

#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineEdit

CPropTreeInLineEdit::CPropTreeInLineEdit()
{
	m_dwFlags = 0;
}

CPropTreeInLineEdit::~CPropTreeInLineEdit()
{
	DestroyWindow();
}


BEGIN_MESSAGE_MAP(CPropTreeInLineEdit, CEdit)
	//{{AFX_MSG_MAP(CPropTreeInLineEdit)
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillFocus)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineEdit message handlers

BOOL CPropTreeInLineEdit::Create(DWORD dwStyle, CWnd* pParentWnd, UINT nID) 
{
	WNDCLASS wc;
	::GetClassInfo(NULL, _T("Edit"), &wc);
	wc.style |= CS_SAVEBITS;
	wc.lpszClassName = _T("PropTreeInLineEdit");
	AfxRegisterClass(&wc);

	dwStyle |= WS_CHILD | WS_CLIPSIBLINGS | ES_LEFT | ES_AUTOHSCROLL;

	BOOL rval = CreateEx(WS_EX_TOOLWINDOW, _T("PropTreeInLineEdit"), NULL, dwStyle,
		0, 0, 0, 0, pParentWnd->GetSafeHwnd(), NULL);
	
	return rval;
}

void CPropTreeInLineEdit::DoModal()
{
	ShowWindow(SW_SHOW);
	SetFocus();
	m_nModalResult = RunModalLoop(NULL);
}

void CPropTreeInLineEdit::OnKillFocus() 
{
	GetWindowText(m_strText);
	EndModalLoop(m_nModalResult);
	DestroyWindow();
}

void CPropTreeInLineEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if(nChar == VK_ESCAPE)
	{
		m_strText.Empty();
		EndModalLoop(m_nModalResult);
		DestroyWindow();
		return;
	}
	if(nChar == VK_RETURN || nChar == VK_TAB)
	{
		GetWindowText(m_strText);
		EndModalLoop(m_nModalResult);
		DestroyWindow();
		return;
	}
	
	CEdit::OnChar(nChar, nRepCnt, nFlags);

	// If the control should grow, do it.
	if(m_dwFlags & PTEF_GROWHORIZ)
	{
		CString str;

		GetWindowText(str);
		CWindowDC dc(this);
		CFont *pFont = GetFont();
		CFont *pFontDC = dc.SelectObject(pFont);
		CSize size = dc.GetTextExtent(str);
		dc.SelectObject(pFontDC);
		size.cx += 12;

		CRect rect; GetWindowRect(&rect);

		if(size.cx > rect.Width())
		{
			rect.right = rect.left + size.cx;
			MoveWindow(&rect);
			RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW | RDW_FRAME);
		}
	}
}

BOOL CPropTreeInLineEdit::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_DELETE || pMsg->wParam == VK_ESCAPE || 
			pMsg->wParam == VK_RIGHT || pMsg->wParam == VK_LEFT || pMsg->wParam == VK_UP || pMsg->wParam == VK_DOWN || 
			pMsg->wParam == VK_TAB || GetKeyState(VK_CONTROL))
		{
			::TranslateMessage(pMsg);
			::DispatchMessage(pMsg);
			return TRUE;
		}
	}
	
	return CEdit::PreTranslateMessage(pMsg);
}

void CPropTreeInLineEdit::SetFlags(DWORD flags)
{

}


///////////////////////////////////////////////////////////

CPropTreeInLineFF3Edit::CPropTreeInLineFF3Edit()
{
	m_nMaxLength = 8;
	m_nCaret = 0;
	m_bTracking = FALSE;
	m_bValid = TRUE;

	m_pText = new BYTE[m_nMaxLength];
	for(int i = 0; i < m_nMaxLength; i++) m_pText[i] = 0xFF;
}

CPropTreeInLineFF3Edit::~CPropTreeInLineFF3Edit()
{
	if(m_pText) delete m_pText;
}


BEGIN_MESSAGE_MAP(CPropTreeInLineFF3Edit, CWnd)
	//{{AFX_MSG_MAP(CPropTreeInLineFF3Edit)
	ON_WM_PAINT()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_SETCURSOR()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_CHAR()
	ON_WM_ERASEBKGND()
	ON_WM_CONTEXTMENU()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineFF3Edit message handlers

BOOL CPropTreeInLineFF3Edit::Create(DWORD dwStyle, CWnd* pParentWnd, UINT nID) 
{
	CString s = AfxRegisterWndClass(CS_SAVEBITS, 0, 0, 0);

	dwStyle |= WS_CHILD | WS_CLIPSIBLINGS;

	BOOL rval = CreateEx(WS_EX_TOOLWINDOW, s, NULL, dwStyle,
		0, 0, 0, 0, pParentWnd->GetSafeHwnd(), NULL);

	m_bReturnDown = FALSE;

	return rval;
}

void CPropTreeInLineFF3Edit::OnPaint() 
{
	CPaintDC pdc(this); // device context for painting

	CRect rect;  GetClientRect(rect);
	CRect textRect = rect;  textRect.DeflateRect(1, 1, 1, 1);

	CMemDC dc(&pdc, rect);

	CFont* pOldFont = dc.SelectObject(GetFont());

	dc.FillSolidRect(rect, RGB(112, 120, 192));
	dc.SetBkMode(TRANSPARENT);

	for(int i = 0; i < m_nMaxLength; i++)
	{
		CPen linePen(PS_SOLID, 1, RGB(255, 255, 255));
		CPen* oldPen = dc.SelectObject(&linePen);

		dc.MoveTo(textRect.left, textRect.bottom - 1);
		dc.LineTo(textRect.left + 7, textRect.bottom - 1);

		dc.SelectObject(oldPen);

		OutputFixedFontChar(&dc, CPoint(textRect.left, textRect.top + 2), m_pDoc, m_pText[i]);

		textRect.left += 8;
	}

	dc.SelectObject(pOldFont);
}

void CPropTreeInLineFF3Edit::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd::OnSetFocus(pOldWnd);

	CreateSolidCaret(2, 12);

	CPoint pt;  GetCursorPos(&pt);
	ScreenToClient(&pt);

	pt.x -= 3;
	m_nCaret = pt.x / 8;
	if(pt.x % 8 > 4) m_nCaret++;
	m_nCaret = min(m_nCaret, m_nMaxLength);

	SetCaretPos(CPoint(m_nCaret * 8 + 1, 3));
	ShowCaret();
}

void CPropTreeInLineFF3Edit::OnLButtonDown(UINT nFlags, CPoint pt) 
{
	pt.x -= 3;
	m_nCaret = pt.x / 8;
	if(pt.x % 8 > 4) m_nCaret++;
	m_nCaret = min(m_nCaret, m_nMaxLength);

	SetCaretPos(CPoint(m_nCaret * 8 + 1, 3));
	
	CWnd::OnLButtonDown(nFlags, pt);
}

void CPropTreeInLineFF3Edit::DoModal()
{
	ShowWindow(SW_SHOW);
	SetFocus();
	m_nModalResult = RunModalLoop(NULL);
}

void CPropTreeInLineFF3Edit::OnKillFocus(CWnd* pNewWnd) 
{
	HideCaret();
	DestroyCaret();
	EndModalLoop(m_nModalResult);
}

BOOL CPropTreeInLineFF3Edit::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	char* nCursor = IDC_ARROW;

	if(!m_bTracking)
		nCursor = IDC_IBEAM;
		
	::SetCursor(AfxGetApp()->LoadStandardCursor(MAKEINTRESOURCE(nCursor)));

	return TRUE;
}

BOOL CPropTreeInLineFF3Edit::PreTranslateMessage(MSG* pMsg) 
{
	switch(pMsg->message)
	{
		case WM_KEYDOWN:
		case WM_KEYUP:
			switch(pMsg->wParam)
			{
				case VK_UP:
				case VK_DOWN:
				case VK_LEFT:
				case VK_RIGHT:
				case VK_RETURN:

				// Bad Windows!  Don't eat my messages before I get them.
				SendMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
				return TRUE;
			}
			break;

		case WM_CHAR:
			SendMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
			return TRUE;
	}	

	return CWnd::PreTranslateMessage(pMsg);
}

void CPropTreeInLineFF3Edit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch(nChar)
	{ 
		case VK_LEFT:
			if(::GetKeyState(VK_CONTROL) & 0x8000)
				m_nCaret = 0;
			else
				m_nCaret = max(0, m_nCaret - 1);
			break;
 
		case VK_RIGHT:
			if(::GetKeyState(VK_CONTROL) & 0x8000)
				m_nCaret = m_nMaxLength;
			else
				m_nCaret = min(m_nCaret + 1, m_nMaxLength);
			break;

		case VK_HOME:
			m_nCaret = 0;
			break;
 
		case VK_END:
			m_nCaret = m_nMaxLength;
			break;

		case VK_DELETE:
			if(m_nCaret < m_nMaxLength)
			{
				memmove(m_pText + m_nCaret, m_pText + m_nCaret + 1, m_nMaxLength - (m_nCaret + 1));
				m_pText[m_nMaxLength - 1] = 0xFF;

				Invalidate();
			}
			break;			

		case VK_BACK:
			if(m_nCaret > 0)
			{
				if(m_nCaret == m_nMaxLength)
					m_pText[m_nMaxLength - 1] = 0xFF;
				else
				{
					memmove(m_pText + m_nCaret - 1, m_pText + m_nCaret, m_nMaxLength - m_nCaret);
					m_pText[m_nMaxLength - 1] = 0xFF;
				}

				m_nCaret--;
				Invalidate();
			}
			break;

		case VK_RETURN:
			m_bReturnDown = TRUE;
			break;
	}

	SetCaretPos(CPoint(m_nCaret * 8 + 1, 3));

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CPropTreeInLineFF3Edit::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if(nChar == VK_ESCAPE)
	{
		m_bValid = FALSE;
		EndModalLoop(m_nModalResult);
		return;
	}

	if((nChar == VK_RETURN && m_bReturnDown) || nChar == VK_TAB)
	{
		m_bReturnDown = FALSE;
		m_bValid = TRUE;
		EndModalLoop(m_nModalResult);
		return;
	}

	CWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CPropTreeInLineFF3Edit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if(nChar == 0x08) return;

	if(m_nCaret >= m_nMaxLength)
	{
		MessageBeep(-1);
		return;
	}

	BYTE ch = ASCIIToFixedChar((char)nChar);

	memmove(m_pText + m_nCaret + 1, m_pText + m_nCaret,
		m_nMaxLength - m_nCaret - 1);
	m_pText[m_nCaret] = ch;

	BOOL bOtherChar = FALSE;

	for(int i = m_nMaxLength - 1; i >= 0; i--)
		if(m_pText[i] == 0xFF)
			m_pText[i] = 0xFE;

	for(i = m_nMaxLength - 1; i >= 0; i--)
		if(m_pText[i] == 0xFE && !bOtherChar)
			m_pText[i] = 0xFF;
		else
			bOtherChar = TRUE;

	m_nCaret++;
	SetCaretPos(CPoint(m_nCaret * 8 + 1, 3));

	Invalidate();

	CWnd::OnChar(nChar, nRepCnt, nFlags);
}

BOOL CPropTreeInLineFF3Edit::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}

void CPropTreeInLineFF3Edit::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	SetFocus();

	CMenu menu;
	menu.LoadMenu(IDR_FIXEDTEXTICONS);

	CMenu* pMenu = menu.GetSubMenu(0);

	m_bTracking = TRUE;
	int cmd = (int)pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON | TPM_NONOTIFY | TPM_RETURNCMD,
		point.x, point.y, pWnd, NULL);
	m_bTracking = FALSE;

	BYTE chIns = 0;

	switch(cmd)
	{
		case ID_POPUP_DAGGER:		chIns = 0xA0;  break;
		case ID_POPUP_SWORD:		chIns = 0xA1;  break;
		case ID_POPUP_SPEAR:		chIns = 0xA2;  break;
		case ID_POPUP_KATANA:		chIns = 0xA3;  break;
		case ID_POPUP_STAFF:		chIns = 0xA4;  break;
		case ID_POPUP_ROD:			chIns = 0xA5;  break;
		case ID_POPUP_STAR:			chIns = 0xA6;  break;
		case ID_POPUP_DIAMOND:		chIns = 0xA7;  break;
		case ID_POPUP_CARD:			chIns = 0xA8;  break;
		case ID_POPUP_CLAW:			chIns = 0xA9;  break;
		case ID_POPUP_SHIELD:		chIns = 0xAA;  break;
		case ID_POPUP_HELMET:		chIns = 0xAB;  break;
		case ID_POPUP_ARMOR:		chIns = 0xAC;  break;
		case ID_POPUP_BRUSH:		chIns = 0xAD;  break;
		case ID_POPUP_SKEAN:		chIns = 0xAE;  break;
		case ID_POPUP_RELIC:		chIns = 0xAF;  break;
		case ID_POPUP_WHITEMAGIC:	chIns = 0xB0;  break;
		case ID_POPUP_BLACKMAGIC:	chIns = 0xB1;  break;
		case ID_POPUP_EFFECTMAGIC:	chIns = 0xB2;  break;
	}

	if(chIns) OnChar((UINT)chIns, 0, 0);
}

void CPropTreeInLineFF3Edit::SizeToContent()
{
	SetWindowPos(NULL, 0, 0, m_nMaxLength * 8 + 8, 24, SWP_NOMOVE | SWP_NOZORDER);
}

void CPropTreeInLineFF3Edit::SetText(BYTE* pText, int len)
{
	if(m_pText) delete m_pText;
	
	m_nMaxLength = len;
	m_pText = new BYTE[m_nMaxLength];
	
	for(int i = 0; i < m_nMaxLength; i++) m_pText[i] = pText[i];

	Invalidate();
}
