// PropTreeInLineLB.cpp : implementation file
//

#include "stdafx.h"
#include "PropTreeInLineLB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineLB

CPropTreeInLineLB::CPropTreeInLineLB()
{
	m_nExplicitWidth = 0;
	m_nExplicitHeight = 0;
	m_nSelection = LB_ERR;
}

CPropTreeInLineLB::~CPropTreeInLineLB()
{
	DestroyWindow();
}


BEGIN_MESSAGE_MAP(CPropTreeInLineLB, CListBox)
	//{{AFX_MSG_MAP(CPropTreeInLineLB)
	ON_WM_ACTIVATE()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineLB message handlers

BOOL CPropTreeInLineLB::Create(DWORD dwStyle, CWnd* pParentWnd, UINT nID) 
{
	WNDCLASS wc;
	::GetClassInfo(NULL, _T("ListBox"), &wc);
	wc.style |= CS_SAVEBITS;
	wc.lpszClassName = _T("PropTreeInLineLB");
	AfxRegisterClass(&wc);

	dwStyle |= WS_POPUP | WS_BORDER | WS_CLIPSIBLINGS | LBS_HASSTRINGS;

	BOOL rval = CreateEx(WS_EX_TOOLWINDOW, _T("PropTreeInLineLB"), NULL, dwStyle,
		0, 0, 0, 0, pParentWnd->GetSafeHwnd(), NULL);

	return rval;
}

int CPropTreeInLineLB::RecalcHeight()
{
	UINT height = 0;

	for(int i = 0; i < GetCount() + 1; i++)
		height += GetItemHeight(i);

	m_nExplicitHeight = height;
	return m_nExplicitHeight;
}

int CPropTreeInLineLB::SetExplicitWidth(int width)
{
	int oldWidth = m_nExplicitWidth;
	m_nExplicitWidth = width;
	return oldWidth;
}

int CPropTreeInLineLB::SetExplicitHeight(int height)
{
	int oldHeight = m_nExplicitHeight;
	m_nExplicitHeight = height;
	return oldHeight;
}

void CPropTreeInLineLB::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CListBox::OnActivate(nState, pWndOther, bMinimized);

	GetParent()->SendMessage(WM_NCACTIVATE, TRUE);

	if(nState == WA_INACTIVE && m_nSelection == LB_ERR)
	{
		m_nSelection = LB_ERR;
		EndModalLoop(m_nModalResult);
		DestroyWindow();
	}
}

void CPropTreeInLineLB::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CListBox::OnLButtonUp(nFlags, point);

	m_nSelection = GetCurSel();
	EndModalLoop(m_nModalResult);
	DestroyWindow();
}


void CPropTreeInLineLB::DoModal()
{
	ShowWindow(SW_SHOW);
	m_nModalResult = RunModalLoop(NULL);
}

void CPropTreeInLineLB::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
}

void CPropTreeInLineLB::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
}

void CPropTreeInLineLB::OnMouseMove(UINT nFlags, CPoint point) 
{
	BOOL bOutside;
	int nSel = (int)ItemFromPoint(point, bOutside);
	if(bOutside) nSel = -1;

	if(GetCurSel() != nSel) SetCurSel(nSel);

	CListBox::OnMouseMove(nFlags, point);
}

void CPropTreeInLineLB::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if(nChar == VK_RETURN)
	{
		m_nSelection = GetCurSel();
		EndModalLoop(m_nModalResult);
		DestroyWindow();
		return;
	}
	else if(nChar == VK_ESCAPE)
	{
		EndModalLoop(m_nModalResult);
		DestroyWindow();
		return;
	}

	CListBox::OnKeyDown(nChar, nRepCnt, nFlags);
}
