// ShopEditView.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Doc.h"
#include "ShopEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShopEditView

IMPLEMENT_DYNCREATE(CShopEditView, CSizingFormView)

CShopEditView::CShopEditView()
	: CSizingFormView(CShopEditView::IDD)
{
	//{{AFX_DATA_INIT(CShopEditView)
	m_nShop = 0;
	m_nTitle = -1;
	//}}AFX_DATA_INIT

	m_bValid = FALSE;
}

CShopEditView::~CShopEditView()
{
}

void CShopEditView::DoDataExchange(CDataExchange* pDX)
{
	CSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShopEditView)
	DDX_Control(pDX, IDC_SHOPTREE, m_wndTree);
	DDX_Control(pDX, IDC_SHOPSPIN, m_wndShopSpin);
	DDX_Text(pDX, IDC_SHOPNUM, m_nShop);
	DDV_MinMaxInt(pDX, m_nShop, 0, 127);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CShopEditView, CSizingFormView)
	//{{AFX_MSG_MAP(CShopEditView)
	ON_EN_CHANGE(IDC_SHOPNUM, OnChangeShopNum)
	//}}AFX_MSG_MAP
	ON_NOTIFY(PROPTN_PROPCHANGED, IDC_SHOPTREE, OnChangeProperties)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShopEditView diagnostics

#ifdef _DEBUG
void CShopEditView::AssertValid() const
{
	CSizingFormView::AssertValid();
}

void CShopEditView::Dump(CDumpContext& dc) const
{
	CSizingFormView::Dump(dc);
}

CFF3Doc* CShopEditView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFF3Doc)));
	return (CFF3Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShopEditView message handlers

void CShopEditView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CFF3Doc* pDoc = GetDocument();
	m_bValid = TRUE;

	m_wndShopSpin.SetRange(0, 127);

	m_wndTree.m_pDoc = pDoc;

	m_itemArray.RemoveAll();
	for(int i = 0; i < 256; i++)
	{
		m_itemArray.Add(pDoc->items[i].name);
	}

	UpdateData(TRUE);
	UpdateTree();
}

PROPERTYITEM g_strShopTitles[] =
{
	{ 0, "(Blank)", NULL },
	{ 1, "Weapon", NULL },
	{ 2, "Armor", NULL },
	{ 3, "Item", NULL },
	{ 4, "Relics", NULL },
	{ 5, "Vendor", NULL },
	{ -1, NULL, NULL },
};

PROPERTYITEM g_strShopProperties[] =
{
	{ 0, "No special properties", NULL },
	{ 1, "Items cost twice normal price", NULL },
	{ 2, "Items cost 1.5X normal price", NULL },
	{ 3, "Items cost half price when Edgar or Sabin is in the party", NULL },
	{ -1, NULL, NULL },
};

void CShopEditView::OnChangeShopNum() 
{
	if(!m_bValid) return;

	UpdateData(TRUE);
	UpdateTree();
}

void CShopEditView::UpdateTree()
{
	CFF3Doc* pDoc = GetDocument();

	// Update the property tree.
	m_wndTree.DeleteAllItems();

	m_wndTree.SetTrueFalseText(_T("Yes"), _T("No"));
	m_wndTree.AddGroup(1000, "General");
		m_wndTree.AddItem(1000, 1001, "Title", PROPT_COMBO, 0, (LPARAM)&g_strShopTitles, pDoc->shops[m_nShop].title & 0x0F);
		m_wndTree.AddItem(1000, 1002, "Properties", PROPT_COMBO, 0, (LPARAM)&g_strShopProperties, ((pDoc->shops[m_nShop].title & 0xF0) >> 4));

	m_wndTree.AddGroup(2000, "Items Sold");

	for(int i = 0; i < 8; i++)
	{
		CString s;  s.Format("Item %d", i);
		m_wndTree.AddItem(2000, 2001 + i, s, PROPT_FF3COMBO, 13, (LPARAM)&m_itemArray, pDoc->shops[m_nShop].items[i]);
	}

	m_wndTree.ExpandAll();
}

void CShopEditView::OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMPROPTREE* pNMPropTree = (NMPROPTREE*)pNMHDR;
	LPPROPERTYNODE node = pNMPropTree->node;

	CFF3Doc* pDoc = (CFF3Doc*)GetDocument();

	BYTE bTitle = pDoc->shops[m_nShop].title;

	if(node->id == 1001) bTitle = bTitle & ~0x0F | node->lData2;
	else if(node->id == 1002) bTitle = bTitle & ~0xF0 | (node->lData2 << 4);
	else if(node->id > 2000)
		pDoc->shops[m_nShop].items[node->id - 2001] = node->lData2;

	pDoc->shops[m_nShop].title = bTitle;

	*pResult = 0;
};