// SizingFormView.h : header file
//

#ifndef __SIZINGFORMVIEW_H__
#define __SIZINGFORMVIEW_H__

/////////////////////////////////////////////////////////////////////////////
// CSizingFormView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#ifndef ANCHOR_LEFT
#define ANCHOR_LEFT		0x0000
#define ANCHOR_TOP		0x0000
#define ANCHOR_RIGHT	0x0001
#define ANCHOR_BOTTOM	0x0002
#define	RESIZE_HORZ		0x0004
#define	RESIZE_VERT		0x0008
#define	RESIZE_BOTH		(RESIZE_HORZ | RESIZE_VERT)
#define MINIMUM_BOUND	0xFFFF
#endif

class CSizingFormView : public CView
{
protected:
	CSizingFormView(LPCTSTR lpszTemplateName);
	CSizingFormView(UINT nID);
	DECLARE_DYNAMIC(CSizingFormView)

// Form Data
public:
	//{{AFX_DATA(CSizingFormView)
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:

protected:
	LPCTSTR m_lpszTemplateName;
	CCreateContext* m_pCreateContext;
	HWND m_hWndFocus;   // last window to have focus

	CSize m_mruSize;
	CDWordArray	m_aControlInfo;
	UINT m_nMinBoundID;

// Operations
public:
	void SetControlInfo(WORD nID, WORD nAnchor);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSizingFormView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void OnDraw(CDC* pDC);      // default does nothing
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

	virtual void OnActivateView(BOOL, CView*, CView*);
	virtual void OnActivateFrame(UINT, CFrameWnd*);
	BOOL SaveFocusControl();    // updates m_hWndFocus

#ifndef _AFX_NO_OCC_SUPPORT
	// data and functions necessary for OLE control containment
	_AFX_OCC_DIALOG_INFO* m_pOccDialogInfo;
	virtual BOOL SetOccDialogInfo(_AFX_OCC_DIALOG_INFO* pOccDialogInfo);
	afx_msg LRESULT HandleInitDialog(WPARAM, LPARAM);
#endif

// Implementation
protected:
	virtual ~CSizingFormView();

	// Generated message map functions
	//{{AFX_MSG(CSizingFormView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
