// SmallTileListBox.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "SmallTileListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSmallTileListBox

CSmallTileListBox::CSmallTileListBox()
{
}

CSmallTileListBox::~CSmallTileListBox()
{
}


BEGIN_MESSAGE_MAP(CSmallTileListBox, CListBox)
	//{{AFX_MSG_MAP(CSmallTileListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSmallTileListBox message handlers

void CSmallTileListBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
}

void CSmallTileListBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CRect rect = lpdis->rcItem;
	CRect bltRect = CRect(0, 0, rect.Width(), rect.Height());
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		m_worldData = (WorldData*)lpdis->itemData;

		BeginDraw(&rect);

		if(lpdis->itemState & ODS_SELECTED)
			FillSolidRect(&bltRect, DDColor(31, 0, 0));

		bltRect.DeflateRect(2, 2);
		FillSolidRect(&bltRect, DDColor(16, 16, 16));

		bltRect.DeflateRect(1, 1);

		HRESULT hres;
		DDSURFACEDESC2 ddsd;
		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);

		while((hres = m_lpSurfaceBack->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING);
		if(hres == DD_OK)
		{
			Put8x8ChunkyTile(&ddsd, bltRect.left, bltRect.top, nIndex);

			m_lpSurfaceBack->Unlock(NULL);
		}

		EndDraw();
	}
}

void CSmallTileListBox::Put8x8ChunkyTile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile)
{
	int src = 0;
	BYTE r, g, b, bAll, b1, b2;
	WORD c1555, c2555;
	DWORD c1f, c2f;

	if(DDraw.ddpfPrimary.dwRGBBitCount == 16)
	{
		WORD* lpDest = (WORD*)ddsd->lpSurface + (ddsd->lPitch / 2) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			int sx = dx;

			for(int x = dx; x < dx + 8; x += 2)
			{
				bAll = m_worldData->tiles[bTile * 0x20 + src];

				b1 = (bAll >> 4) & 0xF;
				b2 = (bAll) & 0xF;

				c1555 = m_worldData->palette[m_worldData->tilePalettes[bTile] + b1];
				c2555 = m_worldData->palette[m_worldData->tilePalettes[bTile] + b2];

				r = R555(c1555);
				g = G555(c1555);
				b = B555(c1555);
				c1f = (b) | (g << 6) | (r << 11);

				r = R555(c2555);
				g = G555(c2555);
				b = B555(c2555);
				c2f = (b) | (g << 6) | (r << 11);

				lpDest[sx + 2] = (WORD)c1f;
				lpDest[sx] = (WORD)c2f;
				lpDest[sx + 3] = (WORD)c1f;
				lpDest[sx + 1] = (WORD)c2f;

				(lpDest + ddsd->lPitch / 2)[sx + 2] = (WORD)c1f;
				(lpDest + ddsd->lPitch / 2)[sx] = (WORD)c2f;
				(lpDest + ddsd->lPitch / 2)[sx + 3] = (WORD)c1f;
				(lpDest + ddsd->lPitch / 2)[sx + 1] = (WORD)c2f;

				sx += 4;
				src += 1;
			}

			lpDest += ddsd->lPitch;
		}
	}
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 24)
	{
		BYTE* lpDest = (BYTE*)ddsd->lpSurface + (ddsd->lPitch) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			int sx = dx * 3;

			for(int x = dx; x < dx + 8; x += 2)
			{
				bAll = m_worldData->tiles[bTile * 0x20 + src];

				b1 = (bAll >> 4) & 0xF;
				b2 = (bAll) & 0xF;

				c1555 = m_worldData->palette[m_worldData->tilePalettes[bTile] + b1];
				c2555 = m_worldData->palette[m_worldData->tilePalettes[bTile] + b2];

				r = R555(c1555) * 8;
				g = G555(c1555) * 8;
				b = B555(c1555) * 8;

				lpDest[sx + 6] = b;
				lpDest[sx + 9] = b;
				lpDest[sx + 7] = g;
				lpDest[sx + 10] = g;
				lpDest[sx + 8] = r;
				lpDest[sx + 11] = r;

				(lpDest + ddsd->lPitch)[sx + 6] = b;
				(lpDest + ddsd->lPitch)[sx + 9] = b;
				(lpDest + ddsd->lPitch)[sx + 7] = g;
				(lpDest + ddsd->lPitch)[sx + 10] = g;
				(lpDest + ddsd->lPitch)[sx + 8] = r;
				(lpDest + ddsd->lPitch)[sx + 11] = r;

				r = R555(c2555) * 8;
				g = G555(c2555) * 8;
				b = B555(c2555) * 8;

				lpDest[sx] = b;
				lpDest[sx + 3] = b;
				lpDest[sx + 1] = g;
				lpDest[sx + 4] = g;
				lpDest[sx + 2] = r;
				lpDest[sx + 5] = r;

				(lpDest + ddsd->lPitch)[sx] = b;
				(lpDest + ddsd->lPitch)[sx + 3] = b;
				(lpDest + ddsd->lPitch)[sx + 1] = g;
				(lpDest + ddsd->lPitch)[sx + 4] = g;
				(lpDest + ddsd->lPitch)[sx + 2] = r;
				(lpDest + ddsd->lPitch)[sx + 5] = r;

				sx += 12;
				src += 1;
			}

			lpDest += ddsd->lPitch * 2;
		}
	}
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 32)
	{
		DWORD* lpDest = (DWORD*)ddsd->lpSurface + (ddsd->lPitch / 4) * dy;

		for(int y = dy; y < dy + 16; y += 2)
		{
			for(int x = dx; x < dx + 16; x += 4)
			{
				bAll = m_worldData->tiles[bTile * 0x20 + src];

				b1 = (bAll >> 4) & 0xF;
				b2 = (bAll) & 0xF;

				c1555 = m_worldData->palette[m_worldData->tilePalettes[bTile] + b1];
				c2555 = m_worldData->palette[m_worldData->tilePalettes[bTile] + b2];

				r = R555(c1555) * 8;
				g = G555(c1555) * 8;
				b = B555(c1555) * 8;
				c1f = (b) | (g << 8) | (r << 16);

				r = R555(c2555) * 8;
				g = G555(c2555) * 8;
				b = B555(c2555) * 8;
				c2f = (b) | (g << 8) | (r << 16);

				lpDest[x + 2] = c1f;
				lpDest[x] = c2f;
				lpDest[x + 3] = c1f;
				lpDest[x + 1] = c2f;

				(lpDest + ddsd->lPitch / 4)[x + 2] = c1f;
				(lpDest + ddsd->lPitch / 4)[x] = c2f;
				(lpDest + ddsd->lPitch / 4)[x + 3] = c1f;
				(lpDest + ddsd->lPitch / 4)[x + 1] = c2f;

				src += 1;
			}

			lpDest += ddsd->lPitch / 2;
		}
	}
}
