// TabbedFrame.h : header file
//

#ifndef __TABBEDFRAME_H__
#define __TABBEDFRAME_H__

#define WM_GETTABCTRL (WM_USER + 300)

/////////////////////////////////////////////////////////////////////////////
// CTabbedFrame frame

#include "FrameWndEx.h"
#include "TabbedViewCtrl.h"

class CTabbedViewGroup;

#define DECLARE_VIEW_GROUP(name)					\
	class TVG##name : public CTabbedViewGroup		\
	{												\
		DECLARE_DYNCREATE(TVG##name)				\
		TVG##name();								\
	};

#define BEGIN_VIEW_GROUP(name)						\
	IMPLEMENT_DYNCREATE(TVG##name, CTabbedViewGroup) \
	TVG##name::TVG##name()							\
	{												\
		CTabbedViewGroup* pGroup = this;			\
		m_pfnInit = NULL;							\
		m_nActiveView = 0;

#define END_VIEW_GROUP()							\
	}

#define SET_ACTIVE_VIEW(index)						\
	pGroup->SetActiveView(index);

#define ADD_VIEW_CLASS(label, name)					\
	pGroup->AddViewClass(#label, RUNTIME_CLASS(name));

#define RECEIVE_INIT_MESSAGE(doc, function)			\
	m_pfnInit = &doc::OnTBFInitTVG##function;

#define DECLARE_VIEW_GROUP_INIT(name)				\
	static void CALLBACK OnTBFInitTVG##name (CTabbedViewGroup* pGroup);

#define BEGIN_VIEW_GROUP_INIT(doc, name)			\
	void CALLBACK doc::OnTBFInitTVG##name(CTabbedViewGroup* pGroup) \
	{

#define END_VIEW_GROUP_INIT()						\
	}

#define RUNTIME_VIEWGROUP(name)						\
	RUNTIME_CLASS(TVG##name)

typedef struct
{
	CString strLabel;
	CRuntimeClass* pClass;
	CView* pView;
} TabbedView;

typedef void (CALLBACK* TABFRAMEINITPROC)(CTabbedViewGroup*);

class CTabbedViewGroup : public CObject
{
	DECLARE_DYNCREATE(CTabbedViewGroup)

	CTabbedViewGroup();
	~CTabbedViewGroup();

public:
	void AddViewClass(LPCTSTR lpszTab, CRuntimeClass* pViewClass);
	void SetActiveView(UINT nIndex) { m_nActiveView = nIndex; }

protected:
	int m_nActiveView;
	CTypedPtrArray<CPtrArray, TabbedView*> m_aViews;

	TABFRAMEINITPROC m_pfnInit;

	friend class CTabbedFrame;
};

class CTabbedFrame : public CFrameWndEx
{
	DECLARE_DYNCREATE(CTabbedFrame)

protected:
	CTabbedFrame();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:
	CView* GetViewByName(LPCTSTR lpszName);

	int GetNumViews() { return m_pViewGroup->m_aViews.GetSize(); }
	CView* GetViewByIndex(int nIndex) { return m_pViewGroup->m_aViews[nIndex]->pView; }

protected:
	CTabbedViewCtrl m_wndTab;
	CFont m_fontTab;
	CTabbedViewGroup* m_pViewGroup;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTabbedFrame)
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CTabbedFrame();

	// Generated message map functions
	//{{AFX_MSG(CTabbedFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	LRESULT OnGetTabCtrl(WPARAM, LPARAM);
	void OnTabSelChanged(NMHDR* pNotifyStruct, LRESULT* result);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
