// TileListBox.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "TileListBox.h"
#include "FF3Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTileListBox

CTileListBox::CTileListBox()
{
}

CTileListBox::~CTileListBox()
{
}


BEGIN_MESSAGE_MAP(CTileListBox, CDirectDrawListBox)
	//{{AFX_MSG_MAP(CTileListBox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTileListBox message handlers

void CTileListBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
}

void CTileListBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CRect rect = lpdis->rcItem;
	CRect bltRect = CRect(0, 0, rect.Width(), rect.Height());
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		BeginDraw(&rect);
	
		m_object = (FF3Object*)lpdis->itemData;

/*		if(m_object->objectType == ObjLocationData)
		{
			if(((LocationData*)m_object)->pDoc->gLocationData->tileProperties
				[((LocationData*)m_object)->tileSet][nIndex] & LDF_ENTRANCE)
				FillSolidRect(&bltRect, DDColor(15, 15, 31));
			
			if(((LocationData*)m_object)->pDoc->gLocationData->tileProperties
				[((LocationData*)m_object)->tileSet][nIndex] & LDF_EXIT)
				FillSolidRect(&bltRect, DDColor(31, 15, 31));
		}*/

		if(lpdis->itemState & ODS_SELECTED)
			FillSolidRect(&bltRect, DDColor(31, 0, 0));

		bltRect.DeflateRect(2, 2);
		FillSolidRect(&bltRect, DDColor(16, 16, 16));

		bltRect.DeflateRect(1, 1);

		HRESULT hres;
		DDSURFACEDESC2 ddsd;
		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);

		while((hres = m_lpSurfaceBack->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING);
		if(hres == DD_OK)
		{
			Put16x16Tile(&ddsd, bltRect.left, bltRect.top, nIndex);

			m_lpSurfaceBack->Unlock(NULL);
		}

		EndDraw();
	}
}

void CTileListBox::Put16x16Tile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile)
{
	if(m_object->objectType == ObjWorldData)
	{
		Put8x8ChunkyTile(ddsd, dx, dy, ((WorldData*)m_object)->tileFormations[bTile * 4 + 0]);	
		Put8x8ChunkyTile(ddsd, dx + 8, dy, ((WorldData*)m_object)->tileFormations[bTile * 4 + 1]);
		Put8x8ChunkyTile(ddsd, dx, dy + 8, ((WorldData*)m_object)->tileFormations[bTile * 4 + 2]);
		Put8x8ChunkyTile(ddsd, dx + 8, dy + 8, ((WorldData*)m_object)->tileFormations[bTile * 4 + 3]);
	}
/*	else if(m_object->objectType == ObjLocationData)
	{
		Put8x8x3Tile(ddsd, dx, dy, &((LocationData*)m_object)->pDoc->gLocationData->tileFormations[((LocationData*)m_object)->tileSet][bTile + 0]);
		Put8x8x3Tile(ddsd, dx + 8, dy,  &((LocationData*)m_object)->pDoc->gLocationData->tileFormations[((LocationData*)m_object)->tileSet][bTile + 128]);
		Put8x8x3Tile(ddsd, dx, dy + 8,  &((LocationData*)m_object)->pDoc->gLocationData->tileFormations[((LocationData*)m_object)->tileSet][bTile + 256]);
		Put8x8x3Tile(ddsd, dx + 8, dy + 8,  &((LocationData*)m_object)->pDoc->gLocationData->tileFormations[((LocationData*)m_object)->tileSet][bTile + 384]);
	}*/
}

void CTileListBox::Put8x8ChunkyTile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile)
{
	int src = 0;
	BYTE r, g, b, bAll, b1, b2;
	WORD c1555, c2555;
	DWORD c1f, c2f;

	if(DDraw.ddpfPrimary.dwRGBBitCount == 16)
	{
		WORD* lpDest = (WORD*)ddsd->lpSurface + (ddsd->lPitch / 2) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			for(int x = dx; x < dx + 8; x += 2)
			{
				bAll = ((WorldData*)m_object)->tiles[bTile * 0x20 + src];

				b1 = (bAll >> 4) & 0xF;
				b2 = (bAll) & 0xF;

				c1555 = ((WorldData*)m_object)->palette[((WorldData*)m_object)->tilePalettes[bTile] + b1];
				c2555 = ((WorldData*)m_object)->palette[((WorldData*)m_object)->tilePalettes[bTile] + b2];

				r = R555(c1555);
				g = G555(c1555);
				b = B555(c1555);
				c1f = (b) | (g << 6) | (r << 11);

				r = R555(c2555);
				g = G555(c2555);
				b = B555(c2555);
				c2f = (b) | (g << 6) | (r << 11);

				lpDest[x + 1] = c1f;
				lpDest[x] = c2f;

				src += 1;
			}

			lpDest += ddsd->lPitch / 2;
		}
	}
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 24)
	{
		BYTE* lpDest = (BYTE*)ddsd->lpSurface + (ddsd->lPitch) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			int sx = dx * 3;

			for(int x = dx; x < dx + 8; x += 2)
			{
				bAll = ((WorldData*)m_object)->tiles[bTile * 0x20 + src];

				b1 = (bAll >> 4) & 0xF;
				b2 = (bAll) & 0xF;

				c1555 = ((WorldData*)m_object)->palette[((WorldData*)m_object)->tilePalettes[bTile] + b1];
				c2555 = ((WorldData*)m_object)->palette[((WorldData*)m_object)->tilePalettes[bTile] + b2];

				r = R555(c1555) * 8;
				g = G555(c1555) * 8;
				b = B555(c1555) * 8;
				c1f = (b) | (g << 8) | (r << 16);

				r = R555(c2555) * 8;
				g = G555(c2555) * 8;
				b = B555(c2555) * 8;
				c2f = (b) | (g << 8) | (r << 16);

				lpDest[sx] = (BYTE)(c1f & 0xFF);
				lpDest[sx + 1] = (BYTE)((c1f >> 8) & 0xFF);
				lpDest[sx + 2] = (BYTE)((c1f >> 16) & 0xFF);

				lpDest[sx + 3] = (BYTE)(c2f & 0xFF);
				lpDest[sx + 4] = (BYTE)((c2f >> 8) & 0xFF);
				lpDest[sx + 5] = (BYTE)((c2f >> 16) & 0xFF);

				sx += 6;
				src += 1;
			}

			lpDest += ddsd->lPitch;
		}
	}
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 32)
	{
		DWORD* lpDest = (DWORD*)ddsd->lpSurface + (ddsd->lPitch / 4) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			for(int x = dx; x < dx + 8; x += 2)
			{
				bAll = ((WorldData*)m_object)->tiles[bTile * 0x20 + src];

				b1 = (bAll >> 4) & 0xF;
				b2 = (bAll) & 0xF;

				c1555 = ((WorldData*)m_object)->palette[((WorldData*)m_object)->tilePalettes[bTile] + b1];
				c2555 = ((WorldData*)m_object)->palette[((WorldData*)m_object)->tilePalettes[bTile] + b2];

				r = R555(c1555) * 8;
				g = G555(c1555) * 8;
				b = B555(c1555) * 8;
				c1f = (b) | (g << 8) | (r << 16);

				r = R555(c2555) * 8;
				g = G555(c2555) * 8;
				b = B555(c2555) * 8;
				c2f = (b) | (g << 8) | (r << 16);

				lpDest[x + 1] = c1f;
				lpDest[x] = c2f;

				src += 1;
			}

			lpDest += ddsd->lPitch / 4;
		}
	}
}

/*void CTileListBox::Put8x8x3Tile(DDSURFACEDESC2* ddsd, int dx, int dy, LocationTilePart* pTilePart)
{
	BYTE aTile[64];
	BYTE bPlanes[3];

	BYTE* pTile = ((LocationData*)m_object)->pDoc->gLocationData->tiles[((LocationData*)m_object)->tileSet] + pTilePart->tilePart * 24;

	for(int row = 0; row < 8; row++)
	{
		bPlanes[0] = pTile[row * 2];
		bPlanes[1] = pTile[row * 2 + 1];
		bPlanes[2] = pTile[row + 16];

		for(int bit = 7; bit >= 0; bit--)
		{
			BYTE mask = 1 << bit;

			// Get a color index by separating the bits on each plane,
			// shifting them the correct amount depending on the plane,
			// and ORing them together.
			aTile[row * 8 + (7 - bit)] = ((bPlanes[0] & mask) >> bit) |
								   (((bPlanes[1] & mask) >> bit) << 1) |
								   (((bPlanes[2] & mask) >> bit) << 2);
								   
		}
	}

	int xSrc, ySrc;

	if(pTilePart->palette & 0x80) ySrc = 7; else ySrc = 0;

	DWORD c1f;
	BYTE b1, r, g, b;
	WORD c555;

	if(DDraw.ddpfPrimary.dwRGBBitCount == 16)
	{
		WORD* lpDest = (WORD*)ddsd->lpSurface + (ddsd->lPitch / 2) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			if(pTilePart->palette & 0x40) xSrc = 7; else xSrc = 0;

			for(int x = dx; x < dx + 8; x++)
			{
				b1 = aTile[ySrc * 8 + xSrc];

				c555 = ((LocationData*)m_object)->pDoc->gLocationData->palettes[((LocationData*)m_object)->paletteIndex][(pTilePart->palette & 0x1F) * 2 + b1];
				r = R555(c555);
				g = G555(c555);
				b = B555(c555);
				c1f = (r) | (g << 6) | (b << 11);

				lpDest[x] = (WORD)c1f;

				if(pTilePart->palette & 0x40) xSrc--; else xSrc++;
			}

			if(pTilePart->palette & 0x80) ySrc--; else ySrc++;

			lpDest += ddsd->lPitch / 2;
		}
	}
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 24)
	{
		BYTE* lpDest = (BYTE*)ddsd->lpSurface + (ddsd->lPitch) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			if(pTilePart->palette & 0x40) xSrc = 7; else xSrc = 0;
			int sx = dx * 3;

			for(int x = dx; x < dx + 8; x++)
			{
				b1 = aTile[ySrc * 8 + xSrc];

				c555 = ((LocationData*)m_object)->pDoc->gLocationData->palettes[((LocationData*)m_object)->paletteIndex][(pTilePart->palette & 0x1F) * 2 + b1];
				r = R555(c555) * 8;
				g = G555(c555) * 8;
				b = B555(c555) * 8;
				c1f = (r) | (g << 6) | (b << 11);

				lpDest[sx] = r;
				lpDest[sx + 1] = g;
				lpDest[sx + 2] = b;

				sx += 6;

				if(pTilePart->palette & 0x40) xSrc--; else xSrc++;
			}

			if(pTilePart->palette & 0x80) ySrc--; else ySrc++;

			lpDest += ddsd->lPitch;
		}
	}
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 32)
	{
		DWORD* lpDest = (DWORD*)ddsd->lpSurface + (ddsd->lPitch / 4) * dy;

		for(int y = dy; y < dy + 8; y++)
		{
			if(pTilePart->palette & 0x40) xSrc = 7; else xSrc = 0;

			for(int x = dx; x < dx + 8; x++)
			{
				b1 = aTile[ySrc * 8 + xSrc];

				c555 = ((LocationData*)m_object)->pDoc->gLocationData->palettes[((LocationData*)m_object)->paletteIndex][(pTilePart->palette & 0x1F) * 2 + b1];
				r = R555(c555) * 8;
				g = G555(c555) * 8;
				b = B555(c555) * 8;
				c1f = (r) | (g << 8) | (b << 16);

				lpDest[x] = c1f;

				if(pTilePart->palette & 0x40) xSrc--; else xSrc++;
			}

			if(pTilePart->palette & 0x80) ySrc--; else ySrc++;

			lpDest += ddsd->lPitch / 4;
		}
	}
}*/
