// TriggerListBox.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "TriggerListBox.h"
#include "FF3Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTriggerListBox

CTriggerListBox::CTriggerListBox()
{
}

CTriggerListBox::~CTriggerListBox()
{
}


BEGIN_MESSAGE_MAP(CTriggerListBox, CListBox)
	//{{AFX_MSG_MAP(CTriggerListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTriggerListBox message handlers

void CTriggerListBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 16;
}

void CTriggerListBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		Entrance* pEntr = (Entrance*)GetItemData(nIndex);

		CString strText;

		if(pEntr->destination != 0xFF)
		{
			strText.Format("Entrance: Source: (%d, %d), Destination: %d (%d, %d)",
				pEntr->srcX, pEntr->srcY, pEntr->destination, pEntr->destX, pEntr->destY);
			
			dc.SetTextColor(::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHTTEXT : COLOR_WINDOWTEXT));
		}
		else
		{
			strText.Format("Event: Source: (%d, %d), Event: %d",
				pEntr->srcX, pEntr->srcY, pEntr->destX);

			dc.SetTextColor((lpdis->itemState & ODS_SELECTED) ?
				::GetSysColor(COLOR_HIGHLIGHTTEXT) : RGB(0, 0, 255));
		}

		CRect textRect = rect;

		dc.FillSolidRect(textRect, ::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHT : COLOR_WINDOW));
		if(lpdis->itemState & ODS_FOCUS) dc.DrawFocusRect(&textRect);
		
		textRect.left += 4;

		CFont* oldFont = dc.SelectObject(GetFont());
		dc.SetBkMode(TRANSPARENT);
		dc.DrawText(strText, &textRect, DT_LEFT | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);
		dc.SelectObject(oldFont);
	}

	dc.Detach();
}
