// VFontListBox.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "VFontListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVFontListBox

CVFontListBox::CVFontListBox()
{
}

CVFontListBox::~CVFontListBox()
{
}


BEGIN_MESSAGE_MAP(CVFontListBox, CListBox)
	//{{AFX_MSG_MAP(CVFontListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVFontListBox message handlers

void CVFontListBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 28;
	lpmis->itemWidth = 38;
}

void CVFontListBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		CRect drawRect = rect;  drawRect.DeflateRect(3, 3, 3, 3);
		dc.FillSolidRect(rect, ::GetSysColor(COLOR_WINDOW));

		BYTE bChar = (BYTE)LOWORD(GetItemData(nIndex));
		CRect cellRect(rect.left + 2, rect.top + 2,
			rect.left + 2 + m_pDoc->charWidths[bChar] * 2, rect.bottom - 2);
		CRect emptyRect(rect.left + 2 + m_pDoc->charWidths[bChar] * 2, rect.top + 2,
			rect.right - 2, rect.bottom - 2);

		CPen linePen(PS_SOLID, 1, RGB(128, 128, 128));
		CPen* oldPen = dc.SelectObject(&linePen);
		CBrush* oldBrush = (CBrush*)dc.SelectStockObject(NULL_BRUSH);
		dc.FillSolidRect(cellRect, RGB(112, 120, 192));
		dc.Rectangle(cellRect);
		dc.FillSolidRect(emptyRect, RGB(192, 192, 192));
		dc.SelectObject(oldBrush);
		dc.SelectObject(oldPen);

		if(lpdis->itemState & ODS_SELECTED)
		{
			CPen selPen(PS_SOLID | PS_INSIDEFRAME, 2, RGB(255, 0, 0));
			
			oldPen = dc.SelectObject(&selPen);
			CBrush* oldBrush = (CBrush*)dc.SelectStockObject(NULL_BRUSH);
			dc.Rectangle(rect);
			dc.SelectObject(oldBrush);
			dc.SelectObject(oldPen);
		}

		WORD* pChar = &m_pDoc->variableFont[(bChar - 0x20) * 11];

		CPoint pt(drawRect.left, drawRect.top);

		for(int y = 0; y < 11; y++)
			for(int x = 0; x < m_pDoc->charWidths[bChar]; x++)
				if(pChar[y] & (1 << (11 - x)))
				{
					dc.SetPixelV(pt.x + (x * 2) + 2, pt.y + (y * 2) + 2, RGB(0, 0, 0));
					dc.SetPixelV(pt.x + (x * 2) + 2, pt.y + (y * 2) + 3, RGB(0, 0, 0));
					dc.SetPixelV(pt.x + (x * 2) + 3, pt.y + (y * 2) + 2, RGB(0, 0, 0));
					dc.SetPixelV(pt.x + (x * 2) + 3, pt.y + (y * 2) + 3, RGB(0, 0, 0));
					dc.SetPixelV(pt.x + (x * 2), pt.y + (y * 2), RGB(255, 255, 255));
					dc.SetPixelV(pt.x + (x * 2), pt.y + (y * 2) + 1, RGB(255, 255, 255));
					dc.SetPixelV(pt.x + (x * 2) + 1, pt.y + (y * 2), RGB(255, 255, 255));
					dc.SetPixelV(pt.x + (x * 2) + 1, pt.y + (y * 2) + 1, RGB(255, 255, 255));
				}
	}

	dc.Detach();
}


/////////////////////////////////////////////////////////////////////////////
// CFFontListBox

CFFontListBox::CFFontListBox()
{
}

CFFontListBox::~CFFontListBox()
{
}


BEGIN_MESSAGE_MAP(CFFontListBox, CListBox)
	//{{AFX_MSG_MAP(CFFontListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFFontListBox message handlers

void CFFontListBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 22;
	lpmis->itemWidth = 22;
}

void CFFontListBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		CRect drawRect = rect;  drawRect.DeflateRect(3, 3, 3, 3);

		BYTE bChar = (BYTE)LOWORD(GetItemData(nIndex));
		CRect cellRect(rect.left + 2, rect.top + 2,
			rect.right - 2, rect.bottom - 2);

		CPen linePen(PS_SOLID, 1, RGB(128, 128, 128));
		CPen* oldPen = dc.SelectObject(&linePen);
		CBrush* oldBrush = (CBrush*)dc.SelectStockObject(NULL_BRUSH);
		dc.FillSolidRect(cellRect, RGB(112, 120, 192));
		dc.Rectangle(cellRect);
		dc.SelectObject(oldBrush);
		dc.SelectObject(oldPen);

		if(lpdis->itemState & ODS_SELECTED)
		{
			CPen selPen(PS_SOLID | PS_INSIDEFRAME, 2, RGB(255, 0, 0));
			
			oldPen = dc.SelectObject(&selPen);
			CBrush* oldBrush = (CBrush*)dc.SelectStockObject(NULL_BRUSH);
			dc.Rectangle(rect);
			dc.SelectObject(oldBrush);
			dc.SelectObject(oldPen);
		}
		else
		{
			CPen selPen(PS_SOLID | PS_INSIDEFRAME, 2, GetSysColor(COLOR_WINDOW));
			
			oldPen = dc.SelectObject(&selPen);
			CBrush* oldBrush = (CBrush*)dc.SelectStockObject(NULL_BRUSH);
			dc.Rectangle(rect);
			dc.SelectObject(oldBrush);
			dc.SelectObject(oldPen);
		}

		CPoint pt(drawRect.left, drawRect.top);

		BYTE* pChar = &m_pDoc->fixedFont[(bChar - 0x80) * 16];

		BYTE aTile[64];
		BYTE bPlanes[2];
		BYTE mask;

		for(int row = 0; row < 8; row++)
		{
			bPlanes[0] = pChar[row * 2];
			bPlanes[1] = pChar[row * 2 + 1];

			for(int bit = 7; bit >= 0; bit--)
			{
				mask = 1 << bit;
			
				aTile[row * 8 + (7 - bit)] = ((bPlanes[0] & mask) >> bit) |
									   (((bPlanes[1] & mask) >> bit) << 1);
			}
		}

		COLORREF colors[4] = {
			RGB(112, 120, 192), RGB(0, 0, 0), RGB(112, 112, 112), RGB(255, 255, 255) };

		for(int y = 0; y < 8; y++)
			for(int x = 0; x < 8; x++)
				if(aTile[y * 8 + x] != 0)
				{
					dc.SetPixelV(pt.x + (x * 2), pt.y + (y * 2), colors[aTile[y * 8 + x]]);
					dc.SetPixelV(pt.x + (x * 2) + 1, pt.y + (y * 2), colors[aTile[y * 8 + x]]);
					dc.SetPixelV(pt.x + (x * 2), pt.y + (y * 2) + 1, colors[aTile[y * 8 + x]]);
					dc.SetPixelV(pt.x + (x * 2) + 1, pt.y + (y * 2) + 1, colors[aTile[y * 8 + x]]);
				}
	}

	dc.Detach();
}
