// WorkspaceView.h : interface of the CWorkspaceView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WORKSPACEVIEW_H__F76E85AC_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_WORKSPACEVIEW_H__F76E85AC_B089_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct 
{
	CRuntimeClass* pFrameClass;
	CRuntimeClass* pViewClass;
	UINT nID;
	DWORD dwData;
} WorkspaceItem;

class CWorkspaceView : public CTreeView
{
protected: // create from serialization only
	CWorkspaceView();
	DECLARE_DYNCREATE(CWorkspaceView)

// Attributes
public:
	CFF3Doc* GetDocument();

protected:
	CImageList m_imgIcons;

// Operations
public:

protected:
	HTREEITEM GetNextItem(HTREEITEM hItem);
	void ExpandBranch(HTREEITEM hti);
	void ExpandAll();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWorkspaceView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWorkspaceView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	HTREEITEM InsertItem(HTREEITEM hParent, LPCTSTR lpszText, int nImage,
		CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass, UINT nID, DWORD dwData);

	//{{AFX_MSG(CWorkspaceView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDeleteItem(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in WorkspaceView.cpp
inline CFF3Doc* CWorkspaceView::GetDocument()
   { return (CFF3Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WORKSPACEVIEW_H__F76E85AC_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
