// WorldBaseView.h : interface of the CWorldBaseView class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __WORLDBASEVIEW_H__
#define __WORLDBASEVIEW_H__

#include "DirectDrawView.h"

#define DM_BASE							0x80000000
#define DM_HighlightTriggers			(DM_BASE + 0x0001)
#define DM_ShadeRects					(DM_BASE + 0x0002)

#define DM_HT_ALL						0x0001

typedef struct
{
	RECT rect;
	DWORD color;
	BYTE opacity;
} DMSHADERECT;

class CWorldBaseView : public CDirectDrawView
{
protected: // create from serialization only
	CWorldBaseView();
	DECLARE_DYNCREATE(CWorldBaseView)

// Attributes
public:
	CFF3Doc* GetDocument();

	WorldData* m_worldData;

protected:
	CPoint m_ptMouseTile;
	CPoint m_ptCurrentTrigger;
	CPoint m_ptScrollOffset;
	CPoint m_ptLastMouse;

	BOOL m_bTimerSet;

	BYTE m_bClipWidth, m_bClipHeight;
	BYTE* m_pClipboard;
	BOOL m_bPasting;
	CRect m_rcMarquee;
	CRectTracker m_rcTracker;

// Operations
public:

protected:
	void Put8x8ChunkyTile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile, DWORD dwColor, BYTE bOpac);
	void Put16x16Tile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile, DWORD dwColor, BYTE bOpac);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWorldBaseView)
	public:
	virtual void OnInitialUpdate();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	//}}AFX_VIRTUAL
	void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);

	void DrawMap(DWORD tag, DWORD value, ... );

// Implementation
public:
	CRect GetTileScreenRect(int x, int y);
	virtual ~CWorldBaseView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	BOOL IsTileVisible(int x, int y);
	CRect GetVisibleTileBounds();
	//{{AFX_MSG(CMapView)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MapView.cpp
inline CFF3Doc* CWorldBaseView::GetDocument()
   { return (CFF3Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

#endif