// cdxCSizingFormView.cpp : implementation file
//

#include "stdafx.h"
#include "cdxCSizingFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// cdxCSizingFormView
/////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(cdxCSizingFormView, CFormView)

/////////////////////////////////////////////////////////////////////////////
// message map
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(cdxCSizingFormView, CFormView)
	//{{AFX_MSG_MAP(cdxCSizingFormView)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// cdxCSizingFormView initializing
/////////////////////////////////////////////////////////////////////////////

/*
 * since a formview would be resized initially,
 * we need another way than getting the current client area
 * to find out how big the client area of a MINIMUM sized
 * view would be.
 *
 * the first overload takes a CWnd placeholder whose lower right edge
 * will be taken as the maximum position.
 */

void cdxCSizingFormView::OnInitialUpdate(CWnd & ctrlLowerRightEdge, Freedom fd) 
{
	CFormView::OnInitialUpdate();
	ASSERT(::IsWindow(m_hWnd) && ::IsWindow(ctrlLowerRightEdge.m_hWnd));

	CRect	rect;
	CSize	szFormClientArea;
	ctrlLowerRightEdge.GetWindowRect(&rect);
	ScreenToClient(&rect);

	szFormClientArea.cx	=	rect.right;
	szFormClientArea.cy	=	rect.bottom;

	cdxCDynamicControlsManager::DoInitWindow(*this,fd,false,&szFormClientArea);
}

/*
 * this overload directly takes a CSize parameter
 */

void cdxCSizingFormView::OnInitialUpdate(const CSize & sz, Freedom fd) 
{
	CFormView::OnInitialUpdate();
	ASSERT(::IsWindow(m_hWnd));

	cdxCDynamicControlsManager::DoInitWindow(*this,fd,false,&sz);
}

/////////////////////////////////////////////////////////////////////////////
// cdxCSizingFormView messages
/////////////////////////////////////////////////////////////////////////////

void cdxCSizingFormView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	cdxCDynamicControlsManager::DoOnSize(nType,cx,cy);
}

void cdxCSizingFormView::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	CFormView::OnGetMinMaxInfo(lpMMI);
	cdxCDynamicControlsManager::DoOnGetMinMaxInfo(lpMMI);
}

BOOL cdxCSizingFormView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style &= ~WS_BORDER;
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;

	return CFormView::PreCreateWindow(cs);
}
