#if !defined(AFX_FONTEDITVIEW_H__9D9A9AC4_C388_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_FONTEDITVIEW_H__9D9A9AC4_C388_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FontEditView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFontEditView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "SizingFormView.h"
#include "VFontListBox.h"
#include "ColorSelector.h"
#include "PixelEditor.h"

class CVFontEditView : public CSizingFormView
{
protected:
	CVFontEditView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CVFontEditView)

// Form Data
public:
	//{{AFX_DATA(CVFontEditView)
	enum { IDD = IDF_VFONT };
	CEdit	m_wndWidth;
	CVFontListBox	m_wndList;
	CColorSelector	m_wndColors;
	CPixelEditor	m_wndFontEdit;
	//}}AFX_DATA

// Attributes
public:

protected:
	LOGFONT m_logFont;
	int m_nVertShift;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVFontEditView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	void ImportFont();
	virtual ~CVFontEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CVFontEditView)
	afx_msg void OnSelChangeCharList();
	afx_msg void OnImportTTF();
	afx_msg void OnChangeCharWidth();
	afx_msg void OnShiftFontUp();
	afx_msg void OnShiftFontDown();
	afx_msg void OnSelChangeColors(NMHDR* pNotifyStruct, LRESULT* result);
	afx_msg void OnChangeFontEdit();
	afx_msg void OnShiftUp();
	afx_msg void OnShiftDown();
	afx_msg void OnShiftLeft();
	afx_msg void OnShiftRight();
	afx_msg void OnClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


class CFFontEditView : public CSizingFormView
{
protected:
	CFFontEditView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CFFontEditView)

// Form Data
public:
	//{{AFX_DATA(CFFontEditView)
	enum { IDD = IDF_FFONT };
	CFFontListBox	m_wndList;
	CColorSelector	m_wndColors;
	CPixelEditor	m_wndFontEdit;
	//}}AFX_DATA

// Attributes
public:

protected:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFFontEditView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CFFontEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CFFontEditView)
	afx_msg void OnSelChangeCharList();
	afx_msg void OnSelChangeColors(NMHDR* pNotifyStruct, LRESULT* result);
	afx_msg void OnChangeFontEdit();
	afx_msg void OnShiftUp();
	afx_msg void OnShiftDown();
	afx_msg void OnShiftLeft();
	afx_msg void OnShiftRight();
	afx_msg void OnClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FONTEDITVIEW_H__9D9A9AC4_C388_11D3_BC2A_00E029364BE2__INCLUDED_)
