// FrameWndEx.h : interface of the CFrameWndEx class
//
/////////////////////////////////////////////////////////////////////////////


#ifndef __FRAMEWNDEX_H__
#define __FRAMEWNDEX_H__

class CFrameWndEx;
class CCommandBar;
class CResourceCollection;
class CMiniDockFrameWndEx;

#include "ResourceCollection.h"
#include "CommandBar.h"
#include "DockBarEx.h"

#define WM_UPDATETOOLBAR (WM_USER + 10)		// Usually implied by WM_UPDATEFLEXPANE
#define WM_UPDATEFLEXPANE (WM_USER + 11)

#define UIElement(lpszClass) (((CMainFrame*)AfxGetMainWnd())->GetUIElement(lpszClass))

class RegisteredUIElement
{
public:
	UINT nID;
	CMenu menu;
};

class CFrameWndEx : public CFrameWnd
{
protected: // create from serialization only
	CFrameWndEx();
	DECLARE_DYNCREATE(CFrameWndEx)

	CTypedPtrMap<CMapStringToPtr, CString, RegisteredUIElement*> m_uiElements;
	void RegisterUIElement(LPCTSTR lpszClass, UINT nID);

// Attributes
public:
	RegisteredUIElement* GetUIElement(LPCTSTR lpszClass);

	CResourceCollection* m_pResources;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFrameWndEx)
	//}}AFX_VIRTUAL
	virtual void OnUpdateFrameTitle(BOOL bAddToTitle);

protected:
	void UpdateFrameTitleForDocument(LPCTSTR lpszDocName);

// Implementation
public:
	virtual ~CFrameWndEx();

protected:  // control bar embedded members
	CCoolMenuManager m_menuManager;

public:
	CCommandBar m_cBarMenu;
	CCommandBar m_cBarStandard;

// Generated message map functions
protected:
	//{{AFX_MSG(CFrameWndEx)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	afx_msg void OnMenuPopup(UINT id, NMHDR* pNotifyStruct, LRESULT* result);
	afx_msg void OnWindowClose();
	DECLARE_MESSAGE_MAP()

public:
	virtual void EnableDocking(DWORD dwDockStyle);
	virtual void FloatControlBar(CControlBar* pBar, CPoint point, DWORD dwStyle = CBRS_ALIGN_TOP);
	virtual CMiniDockFrameWndEx* CreateFloatingFrame(DWORD dwStyle);
	virtual void DockControlBar(CCommandBar* pBar, UINT nDockBarID = AFX_IDW_DOCKBAR_TOP, LPCRECT lpRect = NULL);
	virtual void DockControlBar(CCommandBar* pBar, CDockBarEx* pDockBar, LPCRECT lpRect = NULL);
	virtual void ReDockControlBar(CCommandBar* pBar, CDockBarEx* pDockBar, LPCRECT lpRect);
};

/////////////////////////////////////////////////////////////////////////////

#endif // __FRAMEWNDEX_H__
