// mfxWhlPan.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "mfxWhlPan.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void MfxTrackAutoPan(CWnd* pParentWnd)
{
	CWheelWnd* pWP = new CWheelWnd;
	pWP->Create(pParentWnd);
}

/////////////////////////////////////////////////////////////////////////////
// CWheelWnd

CWheelWnd::CWheelWnd()
{
	m_pParentWnd = NULL;
	m_bmpOrigin.LoadBitmap(IDB_AUTOPAN);
	m_bNoVertScroll = m_bNoHorzScroll = TRUE;
	m_bQuitOnMBUp = FALSE;
}

CWheelWnd::~CWheelWnd()
{
}

BOOL CWheelWnd::Create(CWnd* pParentWnd)
{
	m_pParentWnd = pParentWnd;
	CScrollBar* pVBar;
	CScrollBar* pSBar;
	DWORD dwStyle = m_pParentWnd->GetStyle();
	pVBar = m_pParentWnd->GetScrollBarCtrl(SB_VERT);
	pSBar = m_pParentWnd->GetScrollBarCtrl(SB_HORZ);
	m_bNoVertScroll = ((pVBar != NULL && !pVBar->IsWindowEnabled()) ||
		(pVBar == NULL && !(dwStyle & WS_VSCROLL)));
	m_bNoHorzScroll = ((pSBar != NULL && !pSBar->IsWindowEnabled()) ||
		(pSBar == NULL && !(dwStyle & WS_HSCROLL)));

	if(m_bNoVertScroll && m_bNoHorzScroll)
	{
		delete this;
		return FALSE;
	}

	if(!CreateEx(WS_EX_TOOLWINDOW, AfxRegisterWndClass(CS_SAVEBITS), NULL,
		WS_CLIPSIBLINGS | WS_POPUP | MFS_SYNCACTIVE, CRect(0, 0, 1, 1), NULL, NULL))
	{
		return FALSE;
	}

	CRgn rgn;
	HRSRC hrsrc = FindResource(NULL, MAKEINTRESOURCE(IDR_AUTOPAN_REGION), RT_RCDATA);
	HGLOBAL hmem = LoadResource(NULL, hrsrc);
	DWORD dwSize = SizeofResource(NULL, hrsrc);
	RGNDATA* rd = (RGNDATA*)LockResource(hmem);
	rgn.CreateFromData(NULL, dwSize, rd);
	SetWindowRgn(rgn, FALSE);

	CPoint ptOrigin;
	GetCursorPos(&ptOrigin);
	ptOrigin -= CPoint(14, 14);
	SetCursorPos(ptOrigin.x, ptOrigin.y);
	m_pParentWnd->ScreenToClient(&ptOrigin);

	m_ptWheelOrg = ptOrigin;
	CRect rcWndDrag(ptOrigin.x, ptOrigin.y, ptOrigin.x + 29, ptOrigin.y + 29);
	m_pParentWnd->ClientToScreen(&rcWndDrag);
	MoveWindow(rcWndDrag);
	ShowWindow(SW_SHOW);
	m_pParentWnd->GetTopLevelFrame()->SendMessage(WM_NCACTIVATE, TRUE);
	SetCapture();
	
	m_nWheelTimer = SetTimer(1968, 10, NULL);

	m_nOriginBmpIndex = 28;
	if(!m_bNoVertScroll)
	{
		m_nOriginBmpIndex = 56;
		
		if(!m_bNoHorzScroll) m_nOriginBmpIndex = 0;
	}

	return TRUE;
}

BEGIN_MESSAGE_MAP(CWheelWnd, CMiniFrameWnd)
	//{{AFX_MSG_MAP(CWheelWnd)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_MBUTTONUP()
	ON_WM_CREATE()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWheelWnd message handlers

void CWheelWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect rect;
	GetClientRect(rect);

	// Bitmap size
	CPoint     ptSize;
	ptSize.x = 28;           // Get width of bitmap
	ptSize.y = 28;           // Get height of bitmap

	// Draw bitmap
	if (rect.Width() >= ptSize.x && rect.Height() >= ptSize.y)
	{
		// must have at least the first bitmap loaded before calling DrawItem
		ASSERT(m_bmpOrigin.m_hObject != NULL);     // required

		int x = rect.left + max(1, (rect.Width()-ptSize.x)/2);
		int y = rect.top + max(1, (rect.Height()-ptSize.y)/2);

		CDC dcMem;
		dcMem.CreateCompatibleDC(NULL);
		CBitmap* pOldBmp=dcMem.SelectObject(&m_bmpOrigin);
		dc.BitBlt(x, y, ptSize.x, ptSize.y, &dcMem, m_nOriginBmpIndex, 0, SRCCOPY);
		dcMem.SelectObject(pOldBmp);
	}
}

void CWheelWnd::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == m_nWheelTimer)
	{
		CPoint ptCur;
		GetCursorPos(&ptCur);
		m_pParentWnd->ScreenToClient(&ptCur);

		CPoint pt = ptCur - m_ptWheelOrg;

		int xDirection = -1, yDirection = -1;
		int xScroll = 0, yScroll = 0;

		xDirection = pt.x > 0 ? MFX_RIGHT : MFX_LEFT;
		xScroll = abs(pt.x) / 8;

		yDirection = pt.y > 0 ? MFX_DOWN : MFX_UP;
		yScroll = abs(pt.y) / 8;

		if(xScroll == 0 && abs(pt.x) < 5) xDirection = -1;
		if(yScroll == 0 && abs(pt.y) < 5) yDirection = -1;
		
		int nCursor;
		
		if(xDirection == MFX_LEFT)
		{
			if(!m_bNoHorzScroll && !m_bNoVertScroll)
			{
				if(yDirection == -1) nCursor = IDC_PAN_LEFT;
				if(yDirection == MFX_UP) nCursor = IDC_PAN_UPLEFT;
				if(yDirection == MFX_DOWN) nCursor = IDC_PAN_DOWNLEFT;
			}
			else if(!m_bNoHorzScroll)
			{
				nCursor = IDC_PAN_LEFT;
			}
			else
			{
				if(yDirection == -1) nCursor = IDC_PAN_UPDOWN;
				if(yDirection == MFX_UP) nCursor = IDC_PAN_UP;
				if(yDirection == MFX_DOWN) nCursor = IDC_PAN_DOWN;
			}
		}
	
		if(xDirection == MFX_RIGHT)
		{
			if(!m_bNoHorzScroll && !m_bNoVertScroll)
			{
				if(yDirection == -1) nCursor = IDC_PAN_RIGHT;
				if(yDirection == MFX_UP) nCursor = IDC_PAN_UPRIGHT;
				if(yDirection == MFX_DOWN) nCursor = IDC_PAN_DOWNRIGHT;
			}
			else if(!m_bNoHorzScroll)
			{
				nCursor = IDC_PAN_RIGHT;
			}
			else
			{
				if(yDirection == -1) nCursor = IDC_PAN_UPDOWN;
				if(yDirection == MFX_UP) nCursor = IDC_PAN_UP;
				if(yDirection == MFX_DOWN) nCursor = IDC_PAN_DOWN;
			}
		}

		if(xDirection == -1)
		{
			if(!m_bNoHorzScroll && !m_bNoVertScroll)
			{
				if(yDirection == MFX_UP) nCursor = IDC_PAN_UP;
				if(yDirection == MFX_DOWN) nCursor = IDC_PAN_DOWN;
				if(yDirection == -1) nCursor = IDC_PAN_ALL;
			}
			else if(!m_bNoHorzScroll)
			{
				nCursor = IDC_PAN_LEFTRIGHT;
			}
			else
			{
				if(yDirection == -1) nCursor = IDC_PAN_UPDOWN;
				if(yDirection == MFX_UP) nCursor = IDC_PAN_UP;
				if(yDirection == MFX_DOWN) nCursor = IDC_PAN_DOWN;
			}
		}

		SetCursor(nCursor);

		if(xScroll > 0) DoScroll(xDirection, xScroll);
		if(yScroll > 0) DoScroll(yDirection, yScroll);
	}
	else
		CMiniFrameWnd::OnTimer(nIDEvent);
}

void CWheelWnd::OnDestroy() 
{
	ReleaseCapture();
	KillTimer(m_nWheelTimer);
	::SetCursor(NULL);

	CPoint point;
	GetCursorPos(&point);
	point += CPoint(15,15);
	SetCursorPos(point.x, point.y);
	ScreenToClient(&point);

	CMiniFrameWnd::OnDestroy();
}

void CWheelWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	DestroyWindow();
}

void CWheelWnd::OnRButtonDown(UINT nFlags, CPoint point) 
{
	DestroyWindow();
}

void CWheelWnd::OnMButtonDown(UINT nFlags, CPoint point) 
{
	DestroyWindow();
}

void CWheelWnd::OnMButtonUp(UINT nFlags, CPoint point) 
{
	if(!m_bQuitOnMBUp) return;

	DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////
// CWheelWnd Functions

void CWheelWnd::SetCursor(int nCursor)
{
	::SetCursor(AfxGetApp()->LoadCursor(MAKEINTRESOURCE(nCursor)));
}

BOOL CWheelWnd::DoScroll(int nDirection, int nSize)
{
    int xOrig, x, xMax;
    int yOrig, y, yMax;

    //If no scroll bars, don't do anything
    // e.g. the user has a small scale in a zoom, or a large
    //     window and there are no scroll bars.  Everything is
    //     in view, so no panning needed.
    
	if(nDirection == MFX_DOWN || nDirection == MFX_UP)
	{
		if(m_bNoVertScroll)	nSize = 0;
	}
	    
	if(nDirection == MFX_RIGHT || nDirection == MFX_LEFT)
	{
		if(m_bNoHorzScroll)	nSize = 0;
	}
	    
    // Adjust current x position based on scroll bar constraints.
    xOrig = x = m_pParentWnd->GetScrollPos(SB_HORZ);
    
    // CWnd scrolling is very different in Win32/Win16, call
    // GetScrollRange on Win16 and GetScrollLimit on Win32 to
    // make sure the correct adjusted max is retrieved not something
    // bogus.  We do this for both x and y here.
    
    xMax = m_pParentWnd->GetScrollLimit(SB_HORZ);
	if (nDirection == MFX_LEFT || nDirection == MFX_RIGHT)
	{
		if (nDirection == MFX_LEFT)
			x -= nSize;
		else 
			x += nSize;

		//Sanity checks.
		if (x < 0)	x = 0;
		else if (x > xMax)	x = xMax;
	}
    
    // Adjust current y position based on scroll bar constraints.
    yOrig = y = m_pParentWnd->GetScrollPos(SB_VERT);
    yMax = m_pParentWnd->GetScrollLimit(SB_VERT);
   
	if (nDirection == MFX_UP ||nDirection == MFX_DOWN)
	{
		if (nDirection == MFX_UP)
			y -= nSize;
		else
			y += nSize;	

		//Sanity checks.
		if (y < 0)	y = 0;
	    else if (y > yMax)	y = yMax;
    }

    // If nothing changed, just return, no work to do.
    if (x == xOrig && y == yOrig) return FALSE;
    
	// Now that we've done an actual scroll operation, it's ok to dismiss the window
	// when the middle button is released.
	m_bQuitOnMBUp = TRUE;

	// Do the Scroll!	
	if (x != xOrig) m_pParentWnd->SetScrollPos(SB_HORZ, x);
	if (y != yOrig)	m_pParentWnd->SetScrollPos(SB_VERT, y);
	((CView*)m_pParentWnd)->OnScroll(MAKEWORD(-1, -1), 0);
	m_pParentWnd->Invalidate();

//  This is too jerky.
//	m_pParentWnd->ScrollWindow((xOrig - x) * 16, (yOrig - y) * 16);
//	m_pParentWnd->UpdateWindow();

    return TRUE;
}

void CWheelWnd::OnKillFocus(CWnd* pNewWnd) 
{
	CMiniFrameWnd::OnKillFocus(pNewWnd);
	DestroyWindow();	
}
